define([
        'services/app.service',
        'directives/app.directives',
        'filters/app.filters',
        'services/app.car.beans',
        'modalSelect'
    ],
    function () {
        'use strict';
        var app = angular.module('app.guaSelect.controller', [
            'app.handle.service',
            'app.directives',
            'app.filters',
            'app.car.beans',
            'ionic-modal-select'
        ]);
        //表单控制器
        app.controller('guaSelectController', function ($scope, $rootScope,$timeout, $ionicPopup, $http, $location, $state, $handleService, $interFace, $ionicHistory, $stateParams, $message, $carBeansService) {
            /********************定义变量*************************/
            // console.log('quote-info-$rootScope.carBeans.noCarProductList',$rootScope.carBeans.noCarProductList);
            // console.log($rootScope.carBeans,'carBeans');
            // console.log($rootScope.baseBean,'baseBean');

            $scope.pageCode = $stateParams.SU_CODE;  //页面路由参数 SU_CODE     DRAFTS 复制单  PQUERY  下发修改单
            // 如果是下发修改、复制单进来 显示折扣并且不允许修改
            $scope.isDiscountNoEdit = false; //不允许编辑折扣

            // console.log($rootScope.carBeans.vehicle.carCheckReason,'carCheckReason')
            // console.log($rootScope.carBeans.vehicle.carCheckReason=='1','carCheckFlag')
            // console.log($rootScope.baseBean,'baseBean')
            //单保责任险标志
            $scope.carCheckFlag = ($rootScope.carBeans.vehicle.carCheckReason == "1");
            $scope.calPremiumResult = { }; //保费试算保费结果
            $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = false; //保费试算成功标志
            $scope.calResultData = {}; //保费试算结果

            $scope.noNext=false;//保费小于0，不允许下一步管控
            $scope.jqTaxType = '';//平台返回交强险纳税类型
            $rootScope.reCalPremiumFlag = false; //重新计算标志

            $rootScope.renewalPolicyType = false; //是否选择上年方案
            $rootScope.hasRenewalPolicy = false; //是否带出上年方案
            $scope.isGuangxi = $rootScope.IS_GUANGXI_05; //是否是广西 特殊化处理

            $scope.verCodeObj = {}; //存转保答案

            $scope.CAR_CONFITM_FLAG=false;  //两号弹层
            $scope.showMsg=true;  //验证有误提示语
            $scope.CAR_CONFIRM_SECTION=true; //两号查询弹层内容显示隐藏
            $scope.permitFalse=0;   //两号容错标记
            $scope.msgText='请补充完整车架号和发动机号后重新报价';

            $scope.hasPrevLoading = false; //带出上年方案loading
            $scope.isSelectCar = false; //是否显示车型编码
            $scope.VHL_LIST = [];
            $rootScope.renewalMemory = false;//下个页面返回此页不覆盖续保数据标志
            $rootScope.calResultData4repeatInsure = null; //报价结果供冲突投保页使用
            $scope.prevYearBuyedNocarList = []; // 1015_车险续保带出非车购买信息购买数据
            $scope.renewal = $stateParams.SU_CODE && $stateParams.SU_CODE.toUpperCase() == 'RENEWAL'; // 1015_车险续保带出非车购买信息购买数据

            // 上一单购买的非车产品
            if($rootScope.switchBean.noCarPrdSwitch){
                // 0716对非车险展示排序
                if($rootScope.carBeans.noCarProductList&&$rootScope.carBeans.noCarProductList.length>0){
                    $rootScope.carBeans.noCarProductList = $rootScope.carBeans.noCarProductList.sort(function(x,y){
                        return x.riskCode - y.riskCode;
                    });
                }
                // 0716对非车险展示排序
                $scope.preBuyedNocarList  =  $rootScope.carBeans.noCarProductList || [];
            }else{
                // 0716对非车险展示排序
                if($rootScope.carBeans.noCarRiskList&&$rootScope.carBeans.noCarRiskList.length>0){
                    $rootScope.carBeans.noCarRiskList = $rootScope.carBeans.noCarRiskList.sort(function(x,y){
                        return x.riskCode - y.riskCode;
                    });
                }
                // 0716对非车险展示排序
                $scope.preBuyedNocarList  =  $rootScope.carBeans.noCarRiskList || [];
            }

            // 费折联动
            $scope.feeDiscount = {
                showFzldDialog: false,
                allowFlagBoolean: false,
                allowFlag: '0',   //通融标志 0-否 1-是
                allowReason: '',  //通融理由
                applyComissionRate: '', //申请手续费比例  费折联动方案为“1-调整费用”时必传
                applyComissionRatePre: '', //保存上一次的手续费
                applyComissionRateNormal: '', //保存常规报价手续费
                applySumDiscount: '',  //调整折扣        费折联动方案为“0-调整折扣”时必传
                applySumDiscountPre: '', //保存上一次的折扣
                applySumDiscountNormal: '', //保存常规报价折扣
                feeDiscountLinkPlan: '0',//费折联动方案   0-调整折扣 1-调整费用
                proposalNo: '',         //投保单号       下发修改报价必传
                quotationNo: '',        //报价单号
                quotationWay: '0',       //报价方式       0-常规报价 1-费折联动报价  默认常规报价
                quotationWayFinal: '0', // 保存最后决定的报价方式
                sumGrossPremium: '',    // 总保费
                businessMode: '',       //业务类型       当渠道类型为非直销业务时，展示“手续费”，否则不展示
                feeDiscountLinkFlag: '0',    //费折联动标志 0 不满足费折联动  1 满足费折联动
                allowSwitch: '0',           // 通融开关    0关               1开
                // allowSwitch: '1',
                allowSure: true,           // 确定开关能否点击
                errMsg: '',              /**/
                succMsg: '', 
                linkSituation:'',   //费折联动状态
                finalSumRate:'',  //最终总费比例
                finalSumRateShow:false,  //最终总费比例显示隐藏

                finalExpectedRate: '', //最终变动成本率
                maxExpectedRate: '', //变动成本率底线值
                initExpectedRate: '', //初始变动成本率
                minExpectedRate: '', //变动成本率软起步值
                minLinkDiscount: '', //可联动的最低总折扣
                descentLinkFlagBoolean: false,
                descentLinkFlag: '0', ///底线值下调联动标志   最低折扣标志 0-否 1-是

                applyDoubleAutoValuePre: '', // 保存上一次双自主系数
                applyDoubleAutoValue: '',// 双自主系数
            };

            // 打开费折联动弹框
            $scope.openFeeDialog = function(){
                // debugger
                if(!$rootScope.switchBean.hideCustAndDiscountSwitch){
                    // 0716缓存feeDiscount
                    $scope.feeDiscountB = angular.copy($scope.feeDiscount);
                    $scope.feeDiscount.showFzldDialog=true;
                    $scope.feeDiscount.allowSure=false;
                }
            };

            //法定节假日
            $scope.getHoliday = function(){
                $handleService.http({
                    url: "/quote/queryHolidayInfo",
                    method: "post",
                    data: {"startDate":$rootScope.baseBean.syInsureStartTime,"endDate":$rootScope.baseBean.syInsureEndTime},
                    success: function(data) {
                        if(data.resultCode == 0) {
                            $scope.holidyShow = true;
                            $scope.holidyList = data.result;
                        }
                    },
                });
            };
            $scope.closeHoliday = function(){
                $scope.holidyShow = false;
            }
            $scope.closeSelectCar = function() {
                $scope.isSelectCar = false;//0813关闭弹框
            };

            /*初始化每个险种的基本型 全面型*/
            $scope.initBasic = function(){
                angular.forEach($rootScope.baseBean.syRiskList,function(item,index){
                    if(SY_RISK[index].isBasic){
                        item.isBasic =SY_RISK[index].isBasic;
                    }
                });
            };
            $scope.initBasic();


            /********************end 变量********************/



            var Handle = function(handle) {

                //初始化
                handle.initPage = function() {
                    // console.log($rootScope.prePage,'$rootScope.prePage');
                    var lastPageFrom = '';
                    if($rootScope.prePage){
                         lastPageFrom = $rootScope.prePage.name
                    }
                    // console.log(lastPageFrom!='tab.owConfirm','lastPageFrom!=\'tab.owConfirm\'')
                    // 如果是下发修改、复制单进来 显示折扣并且不允许修改
                    if($scope.pageCode=='PQUERY'||$scope.pageCode=='DRAFTS' ||$rootScope.newPolicyShow){
                        // console.log($rootScope.carBeans.riskList,'$rootScope.carBeans.riskList initPage')
                        $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = true;// 展示折扣
                        $scope.isDiscountNoEdit = true; //不允许编辑
                        //遍历商业险
                        angular.forEach($rootScope.carBeans.riskList, function (riskItem, allIndex) {
                            if(riskItem.riskCode == "0302") {
                                console.log(riskItem.applySumDiscount,'riskItem.applySumDiscount')
                                //商业险总折扣
                                // 因为初次进来，并没有计算保费，页面要显示，所以先付一次值；
                                $scope.calPremiumResult.applySumDiscount = riskItem.applySumDiscount;
                            }
                        });

                    }
                    // 支持机构险别默认保额个性化配置0827
                    Handle.setDefaultValue();
                    // 0730增加获取上年承保方案开关，根据机构的维度管控开关 
                    if($rootScope.switchBean.lastYearDataSwitch) {
                        //带出上年方案
                        //0813交叉销售标志回调问题
                        if(!$rootScope.switchBean.noCarPrdSwitch){
                            Handle.getPrevYearPolicy();
                        }
                    }
                    //检查是否有上年数据, 有说明是续保/托保单, 下方要展示分享一键续保按钮
                    Handle.checkLastYearData();
                    //折旧
                    $scope.$watch('baseBean.syInsureStartTime', function (value) {
                        console.log('折旧')
                        Handle.depreciateValue();
                    });
                    $scope.$watch('baseBean.jqInsureStartTime', function (value) {
                        $rootScope.reCalPremiumFlag = true;
                    });

                    //监听折旧值-》同时修改 1.车损保额 2.全车盗抢 3.自燃损失  4.机动车损失保险（全面型）
                    $scope.$watch('carBeans.vehicle.actualValue', function (value) {
                        $rootScope.baseBean.syRiskList[0].sumInsured = $rootScope.baseBean.syRiskList[2].sumInsured = $rootScope.baseBean.syRiskList[6].sumInsured = $rootScope.baseBean.syRiskList[16].sumInsured = value;
                    });

                    //监听类型变化
                    $scope.$watch('baseBean.isBasic',function(value){
                        angular.forEach($rootScope.baseBean.syRiskList, function (item, index){
                            if(item.isBasic && item.isBasic.indexOf(value)==-1){
                                item.checked = false;
                            }
                        })
                    });
		     //监听三者险种保额修改，同时修改三者翻倍保额
                    $scope.$watch("baseBean.syRiskList[1].sumInsured", function(value) {
                        $rootScope.baseBean.syRiskList[15].sumInsured = value;
                        $rootScope.reCalPremiumFlag = true;
                    });
                    //监听三者不计免赔 三者不计免赔会影响三者翻倍不计免赔
                    $scope.$watch('NO_DED.FRANCHISE_FLAG_1T', function(value) {
                        if(value == true) {
                            $rootScope.baseBean.syRiskList[15].relatedInd = "1";
                        } else {
                            $rootScope.baseBean.syRiskList[15].relatedInd = "0";
                        }
                        $rootScope.NO_DED.FRANCHISE_FLAG_15T = value;
                    });
		            //不计免赔-三者翻倍
                    $scope.$watch('NO_DED.FRANCHISE_FLAG_15T', function(value) {
                        if(value == true) {
                            $rootScope.baseBean.syRiskList[1].relatedInd = "1";
                        } else {
                            $rootScope.baseBean.syRiskList[1].relatedInd = "0";
                        }
                        //三者翻倍的不计免赔不能控制三者不计免赔
                        // $rootScope.NO_DED.FRANCHISE_FLAG_1T = value;
                    })


                    //监听所有选择框 有变化 就需要重新计算
                    angular.forEach($rootScope.baseBean.syRiskList, function (item, index) {
                        $scope.$watch('baseBean.syRiskList[' + index + '].checked', function (value) {
                           $rootScope.reCalPremiumFlag = true; //重新计算 标识
                            //检查是否对应了主险
                            var cvr = $rootScope.baseBean.syRiskList[index],
                                cvrAll = $rootScope.baseBean.syRiskList,
                                csList = $rootScope.BASE_BEAN.CS_FJINS, //附加险和主险
                                csList2 = $rootScope.BASE_BEAN.CS_FJINS2, //机动车损失保险（全面型）附加险
                                jwList = $rootScope.BASE_BEAN.JF_FJINS;

                            //1.检查是否是 车损险 的附加险
                            angular.forEach(csList, function (item) {
                                //1.1主险 车损险 未选中 附加险 不让选
                                if (!cvrAll[0].checked && cvr.kindCode == item) {
                                    cvr.checked = false;
                                }
                                //1.2 车损险取消后  附加险 也跟着取消
                                angular.forEach(cvrAll, function (allItem, allIndex) {
                                    //选择框样式Element
                                    var cvrEle = angular.element("#syRiskList_" + allIndex).find('i.checkbox-icon');
                                    //如果  当前险种代码 和 附加险代码 对应
                                    if (allItem.kindCode == item) {
                                        if (!cvrAll[0].checked) {
                                            allItem.checked = false;
                                            cvrEle.addClass("check-grey");
                                        }
                                        else {
                                            cvrEle.removeClass("check-grey");
                                        }
                                    }
                                });
                            });
                            angular.forEach(csList2, function (item) {
                                //1.1主险 机动车损失保险（全面型） 未选中 附加险 不让选
                                if (!cvrAll[16].checked && cvr.kindCode == item) {
                                    cvr.checked = false;
                                }
                                //1.2 车损险取消后  附加险 也跟着取消
                                angular.forEach(cvrAll, function (allItem, allIndex) {
                                    //选择框样式Element
                                    var cvrEle = angular.element("#syRiskList_" + allIndex).find('i.checkbox-icon');
                                    //如果  当前险种代码 和 附加险代码 对应
                                    if (allItem.kindCode == item) {
                                        if (!cvrAll[16].checked) {
                                            allItem.checked = false;
                                            cvrEle.addClass("check-grey");
                                        }
                                        else {
                                            cvrEle.removeClass("check-grey");
                                        }
                                    }
                                });
                            });
                            //2.精神损失险 主险判断
                            if (cvr.kindCode == "030114") {
                                if (!$rootScope.baseBean.syRiskList[1].checked && !$rootScope.baseBean.syRiskList[3].checked) {
                                    cvr.checked = false;
                                }
                            }
                            if (cvr.kindCode == "030120") {
                                if (!$rootScope.baseBean.syRiskList[1].checked && !$rootScope.baseBean.syRiskList[15].checked) {
                                        cvr.checked = false;
                                }
                            }
                            //3.乘客座位险 不可以单独购买
                            if (cvr.kindCode == "030105" && value) {
                                $rootScope.baseBean.syRiskList[3].checked = true;
                            }
                            //4.司机座位险取消后 乘客座位险跟着取消
                            if (cvr.kindCode == "030104" && !value) {
                                $rootScope.baseBean.syRiskList[4].checked = false;
                            }
                            //5.商业以及司机附加险
                            angular.forEach(jwList, function (item) {
                                if ((!cvrAll[3].checked && cvr.kindCode == item) && (!cvrAll[1].checked && cvr.kindCode == item)) {
                                    cvr.checked = false;
                                }
                                angular.forEach(cvrAll, function (allItem, allIndex) {
                                    //选择框样式Element
                                    var cvrEle = angular.element("#syRiskList_" + allIndex).find('i.checkbox-icon');
                                    if (allItem.kindCode == item) {
                                        if ((cvrAll[3].checked) || (cvrAll[1].checked)) {
                                            cvrEle.removeClass("check-grey");
                                        }
                                        else {
                                            allItem.checked = false;
                                            cvrEle.addClass("check-grey");
                                        }
                                    }
                                });
                            });
                            //6.指定专修厂险别
                            if(cvr.kindCode == "030116"){
                                //山西机构-->选择添加二类专修厂特约-->则不可以选择{指定专修厂}险别 石梦星
                                var cvrEle = angular.element("#syRiskList_" + 14).find('i.checkbox-icon');
                                if($rootScope.switchBean.majorClause && $rootScope.baseBean.clauseList[4].checked){
                                    cvr.checked = false;
                                    cvrEle.addClass("check-grey");
                                }
                            }
                            //三者翻倍
                            angular.forEach(["030120","030114"], function (item) {
                                if (!cvrAll[1].checked && cvr.kindCode == item) {
                                    cvr.checked = false;
                                }
                                angular.forEach(cvrAll, function (allItem, allIndex) {
                                    //选择框样式Element
                                    var cvrEle = angular.element("#syRiskList_" + allIndex).find('i.checkbox-icon');
                                    if (allItem.kindCode == item) {
                                        if ((cvrAll[1].checked)) {
                                            cvrEle.removeClass("check-grey");
                                        }
                                        else {
                                            allItem.checked = false;
                                            cvrEle.addClass("check-grey");
                                        }
                                    }
                                });
                            })
                        });
                    });

                    //监听不计免赔
                    angular.forEach($rootScope.NO_DED, function(item) {
                        $scope.$watch(item, function(value) {
                            $rootScope.reCalPremiumFlag = true; //重新计算 标识
                        });
                    });

                    //监听输入框和下拉框
                    angular.forEach(angular.element("input[type='text'][ng-model],select[ng-model]"), function(elem) {
                        $scope.$watch($(elem).attr("ng-model"), function(value) {
                            $rootScope.reCalPremiumFlag = true; //重新计算 标识
                        })
                    });

                    //监听费折联动参数
                    $("body").on("change",'input[name="allowFlagBoolean"]',function(){
                        var  $selectedvalue = $("input[name='allowFlagBoolean']:checked").val();
                        $selectedvalue=='true' ? $scope.feeDiscount.allowFlag = '1' : $scope.feeDiscount.allowFlag = '0';
                        $scope.$apply(function () {
                            $scope.feeDiscount.allowSure = false;
                        });
                    });

                    //监听费折联动最低总折扣标志
                    $("body").on("change",'input[name="descentLinkFlagBoolean"]',function(){
                        var  $selectedvalue = $("input[name='descentLinkFlagBoolean']:checked").val();
                        $selectedvalue=='true' ? $scope.feeDiscount.descentLinkFlag = '1' : $scope.feeDiscount.descentLinkFlag = '0';
                        $scope.$apply(function () {
                            $scope.feeDiscount.allowSure = false;
                        });
                    });

                    $("body").on("change",'input[name="feeDiscountLinkPlan"]',function(){
                        var  $selectedvalue = $("input[name='feeDiscountLinkPlan']:checked").val();
                        if($selectedvalue == '0'){ // 修改折扣  恢复费用 和 双自主系数
                            $scope.$apply(function () {  
                                $scope.feeDiscount.applyComissionRate = $scope.feeDiscount.applyComissionRatePre;
                            });
                            $scope.$apply(function () {
                                $scope.feeDiscount.applyDoubleAutoValue = $scope.feeDiscount.applyDoubleAutoValuePre;
                            });
                        }else if($selectedvalue == '1'){ //修改费用  恢复折扣 和 双自主系数
                            $scope.$apply(function () {
                                $scope.feeDiscount.applySumDiscount = $scope.feeDiscount.applySumDiscountPre;
                            });
                            $scope.$apply(function () {
                                $scope.feeDiscount.applyDoubleAutoValue = $scope.feeDiscount.applyDoubleAutoValuePre;
                            });
                        }else if($selectedvalue == '2'){// 修改双自主系数  恢复费用 和 折扣
                            $scope.$apply(function () {
                                $scope.feeDiscount.applyComissionRate = $scope.feeDiscount.applyComissionRatePre;
                            });
                            $scope.$apply(function () {
                                $scope.feeDiscount.applySumDiscount = $scope.feeDiscount.applySumDiscountPre;
                            });
                        }
                        $scope.$apply(function () {
                            $scope.feeDiscount.allowSure = false;
                        });
                    });

                    $scope.applySumDiscountChange = function(){
                        $scope.feeDiscount.applySumDiscount = $scope.feeDiscount.applySumDiscount.replace(/(^[^\d]+)/,'').replace(/([^\d\.]+)/,'').replace(/(\.)\./,'$1').replace(/([\d]+[\.]{1}[\d]{6})[\s\S]+/,'$1').replace(/(\.[^\.]+)\./,'$1').replace(/^(\d{2})\d/,'$1');
                        $scope.feeDiscount.allowSure = false;
                    };
                    $scope.applyDoubleAutoValueChange = function(){
                        $scope.feeDiscount.applyDoubleAutoValue = $scope.feeDiscount.applyDoubleAutoValue.replace(/(^[^\d]+)/,'').replace(/([^\d\.]+)/,'').replace(/(\.)\./,'$1').replace(/([\d]+[\.]{1}[\d]{6})[\s\S]+/,'$1').replace(/(\.[^\.]+)\./,'$1').replace(/^(\d{2})\d/,'$1');
                        $scope.feeDiscount.allowSure = false;
                    };
                    $scope.applyComissionRateChange = function(){
                        $scope.feeDiscount.applyComissionRate = $scope.feeDiscount.applyComissionRate.replace(/(^[^\d]+)/,'').replace(/([^\d\.]+)/,'').replace(/(\.)\./,'$1').replace(/([\d]+[\.]{1}[\d]{2})[\s\S]+/,'$1').replace(/(\.[^\.]+)\./,'$1').replace(/^(\d{2})\d/,'$1');
                        $scope.feeDiscount.allowSure = false;
                    };

                    var nowDate = new Date().getTime(),
                        oldDateJq = new Date($rootScope.baseBean.jqInsureStartTime.replace(/[-]/g, '/')).getTime(),
                        oldDateSy = new Date($rootScope.baseBean.syInsureStartTime.replace(/[-]/g, '/')).getTime();
                    if(oldDateJq < nowDate){
                        $rootScope.baseBean.jqInsureStartTime = new Date().addDay(1).format('yyyy-MM-dd');
                        $rootScope.baseBean.jqInsureStartTime = Handle.translateTime($rootScope.baseBean.jqInsureStartTime, true);
                    }
                    if(oldDateSy < nowDate){
                        $rootScope.baseBean.syInsureStartTime = new Date().addDay(1).format('yyyy-MM-dd');
                        $rootScope.baseBean.syInsureStartTime = Handle.translateTime($rootScope.baseBean.syInsureStartTime, true);
                    }

                };

                handle.getNxtDate = function() {
                    var nex = new Date();
                    nex.setDate(nex.getDate() + 1);
                    return nex.format('yyyy-MM-dd 00:00:00');
                };

                // 设置T+n
                handle.getNumDate = function(num) {
                    var nex = new Date();
                    nex.setDate(nex.getDate() + num);
                    return nex.format('yyyy-MM-dd 00:00:00');
                };
                
                /*  ---  支持机构险别默认保额个性化配置0827  ---  */
                /**
                * 1、支持机构+险别+保额配置；（第三者责任险、车上人员司机责任险、车上人员乘客责任险、划痕险）
                * 2、续保数据中的上年保额不作调整，默认优先取上年保额数据；
                * 3、系统：APP和B2B；
                * 4、广东机构第三者责任险默认保额100万。
                */
                handle.setDefaultValue = function () {
                    //首页进入的新保设置保额默认个性化配置
                    if (!$stateParams.SU_CODE || $stateParams.SOURCE == 'index') {
                        // 跳转页面信息从车辆信息页进入,而且没有设置读取默认值标志才请求
                        if(!$rootScope.hasDefaultValueFlag && $rootScope.prePage && $rootScope.prePage.name && $rootScope.prePage.name.indexOf('carinfo')!=-1) {
                            // 请求接口数据
                            $handleService.http({
                                url: '/quote/queryDefaultInsuredAmount?orgNo=' + $U.getDeptCode(),
                                method: 'GET',
                                success: function (data) {
                                    $handleService.logger("object", data, "险别默认保额个性化配置接口返回结果--》");
                                    // debugger
                                    if ($U.isNotEmpty(data.result)) {
                                        var res = data.result;
                                        /** 接口返回值参考
                                        "result": {
                                            "orgNo": "0105",
                                            "orgName": "广西分公司",
                                            "thirdPartyInsurance": 0,第三方责任险
                                            "driverLiabilityInsurance": 0,车上人员司机责任险
                                            "passengerLiabilityInsurance": 0,车上人员乘客责任险
                                            "scratchRisk": 0 划痕险
                                        } 
                                        */
                                        // 第三者责任险
                                        var LIABILITY_INS_VAL = $rootScope.BASE_BEAN.LIABILITY_INS_VAL||[];
                                        if(LIABILITY_INS_VAL[res.thirdPartyInsurance]){
                                            // $rootScope.baseBean.syRiskList[1].checked = true;
                                            $rootScope.baseBean.syRiskList[1].sumInsured = res.thirdPartyInsurance; // 广东机构第三者责任险默认保额100万
                                        }
                                        // 车上人员司机责任险
                                        var DRIVER_SEAT = $rootScope.BASE_BEAN.DRIVER_SEAT||[];
                                        if(DRIVER_SEAT.indexOf(res.driverLiabilityInsurance/10000)>-1){
                                            // $rootScope.baseBean.syRiskList[3].checked = true;
                                            $rootScope.baseBean.syRiskList[3].unitInsured = res.driverLiabilityInsurance;
                                        }
                                        // 车上人员乘客责任险/乘客座位险(座)
                                        var PASSENGER_SEAT = $rootScope.BASE_BEAN.PASSENGER_SEAT||[];
                                        if(PASSENGER_SEAT.indexOf(res.passengerLiabilityInsurance/10000)>-1){
                                            // $rootScope.baseBean.syRiskList[4].checked = true;
                                            $rootScope.baseBean.syRiskList[4].unitInsured = res.passengerLiabilityInsurance;
                                        }
                                        // 划痕险
                                        var SCRATCH_INS = $rootScope.BASE_BEAN.SCRATCH_INS||[];
                                        if(SCRATCH_INS.indexOf(res.scratchRisk)>-1 ){
                                            // $rootScope.baseBean.syRiskList[8].checked = true;
                                            $rootScope.baseBean.syRiskList[8].sumInsured = res.scratchRisk;
                                        }
                                        $rootScope.hasDefaultValueFlag = true;//已读取,设置读取默认值标志
                                    } else {
                                        $U.showToast(errorMsg);
                                    }
                                },
                                error: function (err) {
                                    $handleService.logger('error', err);
                                }
                            });
                        }
                    }
                }

                //获取上年投保险种信息
                handle.getPrevYearPolicy = function() {
                    //0813【交叉销售】车险增加符合交叉销售的标识_start
                    if($U.isNotEmpty($scope.nocarList)) {
                        var productCodeArr = [];
                        var productCodeStr = '';
                        angular.forEach($scope.nocarList, function(nocarItem){
                            productCodeArr.push(nocarItem.productCode.substr(1,4));
                        })
                        productCodeStr = productCodeArr.join(',');
                    }
                    $rootScope.carBeans.base.allowNocarListFlag = productCodeStr||'';
                    //0813【交叉销售】车险增加符合交叉销售的标识_end
                    var riskList =  Handle.encapRisk();
                    //var _CAR_BEANS = {};
                   // 解决费折联动第一次默认报价的bug bug描述: quotationWay为'1', 却没有传费折联动相关信息
                    var _CAR_BEANS = angular.copy($rootScope.carBeans);
                    _CAR_BEANS.base.quotationWay = '0';
                    
                    _CAR_BEANS.riskList = riskList;
                    var hasReQuote = false; //是否调用重复投保标识  是否调用上年方案标志 伍念

                    angular.forEach(_CAR_BEANS.riskList, function(item) {
                        if(item.riskCode == "0302") { //勾选商业险
                            if(item.coverageList.length == 0) {
                                //没有选中任何一个险种
                                item.coverageList = [{
                                    deductible: "0",
                                    kindCode:"030101",
                                    kindInd: "1",
                                    relatedInd:"1",
                                    sumInsured:195800
                                }];
                                item.effectFlag = "0";
                                if($rootScope.baseBean.syOrigFlag)hasReQuote = true;
                            } else {
                                //TODO:与产品沟通是否每次都需要带出上年方案
                                //hasReQuote = false;
                            }
                            item.startDate = Handle.getNxtDate();
                            // 套方案接口传给核心的投保止期改为T+7 （只针对第一次套方案报价） 0711暂时注释
                            item.endDate = Handle.getNumDate(7);  // 1015放开T+7
                        } else if(item.riskCode == "0301") {
                            item.effectFlag = "0";
                            item.startDate = Handle.getNxtDate();
                            // 套方案接口传给核心的投保止期改为T+7 （只针对第一次套方案报价） 0711暂时注释
                            item.endDate = Handle.getNumDate(7); // 1015放开T+7
                        }
                    });

                    if(!hasReQuote) {
                        return;
                    }
                    $scope.hasPrevLoading = true; //带出上年方案的loading
                    $handleService.showLoading('hide');
                    $handleService.logger("object",_CAR_BEANS, "带出上年方案参数");
                    $handleService.http({
                        url: "/coverQuote?flowId=" + $rootScope.flowId,
                        method: "post",
                        data: _CAR_BEANS,
                        success: function(data) {
                            $handleService.logger("object", data, "获取上年投保方案返回数据");
                            $scope.hasPrevLoading = false;
                            if(data.resultCode == 0) {
                                //TODO:之前是每次带出上年方案，后面跟后台商量，续保就不带上年方案，后台遇到续保直接返回上年方案结果为空
                                if(!$U.isEmpty(data.result)){//之前
                                    Handle.setPrevYearRisk(data.result);
                                }
                                //带出上年方案后再次报价
                                $scope.calAmount();
                            }
                        },
                        complete: function () {
                            $scope.hasPrevLoading = false;
                        },
                        error: function (ex) {
                            $scope.hasPrevLoading = false;
                        }
                    })
                }
                //检查是否有上年数据, 有说明是续保/托保单, 下方要展示分享一键续保按钮
                handle.checkLastYearData = function(){
                    $rootScope.hasRenew = false;
                    if(!$rootScope.switchBean.renewalShareSwitch || $rootScope.carBeans.vehicle.licenseNo == '*-*' || !$rootScope.carBeans.vehicle.licenseNo || $rootScope.carBeans.owner.identifyType != "01")return;
                    $handleService.http({
                        url: "/renewal/queryPolicyInfo?flowId=" + $rootScope.flowId,
                        method: 'POST',
                        hasShowLoadding: false,
                        data: {
                            licenseNo: $rootScope.carBeans.vehicle.licenseNo,
                            insuredProduct:'0',
                            nonCarFlag:1 //1015_车险续保带出非车购买信,增加非车标志入参
                        },
                        success: function (data) {
                            if (data.resultCode == "0" && data.result.length>=1) {
                                // 求到期日
                                var riskList, abs1, abs2, endDate1, endDate2;
                                $scope.endDate = '';
                                for(var i = 0; i < data.result.length; i++){
                                    if($rootScope.carBeans.owner.identifyNumber == data.result[i].owner.identifyNumber){// 用身份证过滤报价方案list列表
                                        riskList = data.result[i].riskList;
                                        $scope.prevYearBuyedNocarList = data.result[i].noCarProductList; // 1015_车险续保带出非车购买信息,获取非车产品续保记录
                                        if(riskList.length ==1){
                                            $scope.endDate = riskList[0].endDate;                             
                                        }else if(riskList.length ==2){
                                            // 取2者较今日近者为保险到期日
                                            endDate1 = riskList[0].endDate;
                                            endDate2 = riskList[1].endDate;
                                            abs1 = Math.abs(new Date(endDate1.replace(/-/g,'/')).getTime() - new Date().getTime());
                                            abs2 = Math.abs(new Date(endDate2.replace(/-/g,'/')).getTime() - new Date().getTime());
                                            abs1 < abs2 ? $scope.endDate = endDate1 : $scope.endDate = endDate2;
                                        } 
                                        $rootScope.hasRenew = true;
                                        break;
                                    }
                                }
                            }
                            $scope.hasQueryPrevYearBuyedNocarList = true; // 1015_标记prevYearBuyedNocarList请求状态
                            Handle.initCheckedNocarList();
                        }
                    })
                };
                //设置上年投保险种方案
                handle.setPrevYearRisk = function(riskList) {

                    var carBeans = angular.copy(riskList);
                    var syRisk = angular.copy($rootScope.baseBean.syRiskList);

                    $rootScope.renisure = riskList;
                    //处理险种
                    angular.forEach(carBeans, function (item, index) {
                        var nowDate = new Date().getTime(),
                            oldDate;


                        if(item.kindCode == "0301" && $rootScope.baseBean.jqOrigFlag) {
                            if(item.expireDate) {
                                oldDate = new Date(item.expireDate.replace(/[-]/g, '/')).getTime();
                                if(oldDate < nowDate){
                                    $rootScope.baseBean.jqInsureStartTime = new Date().addDay(1).format('yyyy-MM-dd');
                                }
                                $rootScope.baseBean.jqInsureStartTime = Handle.translateTime(item.expireDate, true);
                            }
                        }
                        if(item.kindCode == "0302") { //商业险
                            if(!$rootScope.baseBean.syOrigFlag) {
                                return;
                            }
                            if((item.coverageItemList||[]).length > 0) { //带出上年方案
                                $rootScope.hasRenewalPolicy = true;
                                $rootScope.renewalPolicyType = true;
                            } else {
                                return;
                            }
                            //TODO：商业险起期需要判断是否是23:59:59
                            if(item.expireDate) {
                                oldDate = new Date(item.expireDate.replace(/[-]/g, '/')).getTime();
                                if(oldDate < nowDate){
                                    $rootScope.baseBean.syInsureStartTime = new Date().addDay(1).format('yyyy-MM-dd');
                                }
                                $rootScope.baseBean.syInsureStartTime = Handle.translateTime(item.expireDate, true);
                            }
                            angular.forEach(syRisk, function(defaultItem, defaultIndex) { //当前险种数据
                                defaultItem.checked = false; //全部不选中
                                angular.forEach(item.coverageItemList, function(syItem, syIndex) { //后端带出数据
                                    if(syItem.kindCode == defaultItem.kindCode) {
                                        defaultItem.renewal = true;  //带出上年方案标志
                                        syRisk[defaultIndex].checked = true;  //选中
                                        $rootScope.NO_DED["FRANCHISE_FLAG_" + defaultIndex +"T"] = true;
                                    }
                                })
                            });
                            if($rootScope.baseBean.syOrigFlag) {
                                $rootScope.baseBean.syRiskList = syRisk;
                            }
                        }
                    });
                }

                //转换时间
                /**
                 * flag: 时间是否只到分
                 * */
                handle.translateTime = function(timeStr, flag) {
                    var len = timeStr.length;
                    var newDate = new Date(timeStr.replace(/[-]/g, '/'));
                    var newTime;
                    if(len == 10) {//2018-09-03
                        newDate = new Date(timeStr.replace(/[-]/g, '/'));
                        if(flag) {
                            newTime = newDate.format('yyyy-MM-dd 00:00');
                        } else {
                            newTime = newDate.format('yyyy-MM-dd 00:00:00');
                        }

                    } else if(len == 13) {//2018-09-03 00
                        newDate = new Date((timeStr+":00:00").replace(/[-]/g, '/'));
                        if(flag) {
                            newTime = newDate.format('yyyy-MM-dd hh:00');
                        } else {
                            newTime = newDate.format('yyyy-MM-dd hh:00:00');
                        }
                    } else if(len == 16) {//2018-09-03 00:00
                        newDate = new Date((timeStr+":00").replace(/[-]/g, '/'));
                        if(flag) {
                            newTime = newDate.format('yyyy-MM-dd hh:mm');
                        } else {
                            newTime = newDate.format('yyyy-MM-dd hh:mm:00');
                        }
                    } else if(len == 19) {//2018-09-03 00:00:00
                        newDate = new Date(timeStr.replace(/[-]/g, '/'));
                        if(flag) {
                            newTime = newDate.format('yyyy-MM-dd hh:mm');
                        } else {
                            newTime = newDate.format('yyyy-MM-dd hh:mm:00');
                        }
                    }

                    return newTime;
                }


                //转换时间
                /**
                 * flag: 时间是否只到分 保留年月日
                 * */
                handle.translateTimeDate = function(timeStr, flag) {
                    var len = timeStr.length;
                    var newDate = new Date(timeStr.replace(/[-]/g, '/'));
                    var newTime;
                    if(len == 10) {//2018-09-03
                        newDate = new Date(timeStr.replace(/[-]/g, '/'));
                        if(flag) {
                            newTime = newDate.format('yyyy-MM-dd 00:00');
                        } else {
                            newTime = newDate.format('yyyy-MM-dd');
                        }

                    } else if(len == 13) {//2018-09-03 00
                        newDate = new Date((timeStr+":00:00").replace(/[-]/g, '/'));
                        if(flag) {
                            newTime = newDate.format('yyyy-MM-dd hh:00');
                        } else {
                            newTime = newDate.format('yyyy-MM-dd');
                        }
                    } else if(len == 16) {//2018-09-03 00:00
                        newDate = new Date((timeStr+":00").replace(/[-]/g, '/'));
                        if(flag) {
                            newTime = newDate.format('yyyy-MM-dd hh:mm');
                        } else {
                            newTime = newDate.format('yyyy-MM-dd');
                        }
                    } else if(len == 19) {//2018-09-03 00:00:00
                        newDate = new Date(timeStr.replace(/[-]/g, '/'));
                        if(flag) {
                            newTime = newDate.format('yyyy-MM-dd hh:mm');
                        } else {
                            newTime = newDate.format('yyyy-MM-dd');
                        }
                    }

                    return newTime;
                }

                //封装险种
                handle.encapRisk = function(opts) {
                    // console.log($rootScope.baseBean,'$rootScope.baseBean. ---封装')
                    // console.log($rootScope.carBeans,'$rootScope.carBeans. ---封装')
                    var syStartTime ="";
                    var syEndTime = "";
                    var effectFlag = "";

                    if($rootScope.baseBean.shortSY){ //短期商业险
                        syStartTime = Handle.translateTime($rootScope.baseBean.syInsureStartTimeShort);
                        syEndTime = ($rootScope.baseBean.syInsureEndTimeShort + ":59");
                        effectFlag = "1";
                    } else { //
                        syStartTime = Handle.translateTime($rootScope.baseBean.syInsureStartTime);
                        if(syStartTime.split(" ")[1] == "00:00:00") {
                            effectFlag = "0";
                        } else {
                            effectFlag = "1";
                        }
                    }

                    var jqStartTime ="";
                    var jqEndTime = "";
                    var jqEffectFlag = "";

                    if($rootScope.baseBean.shortJQ) { //短期交强险
                        jqStartTime = Handle.translateTime($rootScope.baseBean.jqInsureStartTimeShort);
                        jqEndTime = ($rootScope.baseBean.jqInsureEndTimeShort + ":59");
                        jqEffectFlag = "1";
                    } else {
                        jqStartTime = Handle.translateTime($rootScope.baseBean.jqInsureStartTime);
                        if(jqStartTime.split(" ")[1] == "00:00:00") {
                            jqEffectFlag = "0";
                        } else {
                            jqEffectFlag = "1";
                        }
                    }
                    //非短期险时 止期传空
                    var syCheckQuestion = "";
                    if($scope.calPremiumResult.syCalData) {
                        syCheckQuestion = $scope.calPremiumResult.syCalData.checkQuestion||"";
                    }
                    var syoptions = angular.extend(($scope.calPremiumResult.syCalData||{}), {
                        answer: syCheckQuestion? ($rootScope.baseBean.syAnswer||""):'',
                        checkQuestion: syCheckQuestion, //转保问题
                        coverageList: [],
                        applySumDiscount: $rootScope.baseBean.applySumDiscount,//折扣
                        effectFlag: effectFlag,
                        electronicInd:$rootScope.baseBean.syElectronicPolicy,
                        proposalNo: $rootScope.baseBean.syProposalNo, //投保单号  退回修改必填
                        riskCode: "0302",
                        startDate: syStartTime,
                        endDate: syEndTime,
                        imageId: $rootScope.baseBean.syImageId,
                        quotationNo: $rootScope.baseBean.syQuotationNo
                    });
                    console.log($scope.calPremiumResult.syCalData,syoptions,'555555');
                    var jqCheckQuestion = "";
                    if($scope.calPremiumResult.jqCalData) {
                        jqCheckQuestion = $scope.calPremiumResult.jqCalData.checkQuestion||"";
                    }
                    var jqOptions = angular.extend(($scope.calPremiumResult.jqCalData||{}), angular.extend($rootScope.baseBean.jqRiskList,{
                        answer: jqCheckQuestion? ($rootScope.baseBean.jqAnswer||""):'', //转保答案
                        checkQuestion: jqCheckQuestion, //转保问题
                        effectFlag: jqEffectFlag,
                        electronicInd:$rootScope.baseBean.jqElectronicPolicy,
                        startDate: jqStartTime,
                        proposalNo: $rootScope.baseBean.jqProposalNo, //投保单号  退回修改必填
                        endDate: jqEndTime
                    }));
                    var riskList = [];
                    //商业险
                    if($rootScope.baseBean.syOrigFlag) {
                        var syRiskList = [];
                        var _syRiskList = angular.copy($rootScope.baseBean.syRiskList);
                        //----------------------------------------------------------------------------------//
                        //1.对参数进行封装
                        //a.*****************************筛选已投保的险种*****************************
                        //筛选商业险
                        angular.forEach(_syRiskList, function (item, index, array) {
                            if(item.kindCode=='021' && item.rate =='0'){
                                /*单独处理免赔率 rate==0时  not push*/
                            }else if(item.kindCode=='030120' && ($rootScope.carBeans.vehicle.seatCount>9 || $rootScope.carBeans.base.busiAttrConfig.useNatures!='02' || $rootScope.carBeans.vehicle.carKindCode!='100' || $rootScope.carBeans.base.busiAttrConfig.attachNatures != '01')){
                                //三者假日翻倍险  not push  大于9座  营运  非客车

                            }
                            else if($scope.carCheckFlag){ //单保责任类
                                angular.forEach($rootScope.BASE_BEAN.DUTY_LIST, function (dutyTem) {
                                    if(item.kindCode == dutyTem){
                                        if (item.checked && $U.isNotEmpty(item.kindCode) && item.isBasic && item.isBasic.indexOf($rootScope.baseBean.isBasic)!=-1) { //选中的险种存入数据
                                            delete item.checked;
                                            delete item.isBasic;
                                            delete item.renewal;
                                            syRiskList.push(item);
                                        }
                                    }
                                });
                            } else {
                                // 非车上货物责任险
                                if(item.kindCode != "030113") {
                                    if(item.kindCode=='030111'){
                                        if (item.checked && $U.isNotEmpty(item.kindCode)  && item.isBasic && item.isBasic.indexOf($rootScope.baseBean.isBasic)!=-1) { //选中的险种存入数据
                                            if(true){
                                                if($rootScope.carBeans.base.busiAttrConfig.useNatures == '02'&&$rootScope.carBeans.vehicle.carKindCode=='100'){
                                                    delete item.checked;
                                                    delete item.isBasic;
                                                    delete item.renewal;
                                                    syRiskList.push(item);
                                                }
                                            }else{
                                                delete item.checked;
                                                delete item.isBasic;
                                                delete item.renewal;
                                                syRiskList.push(item);
                                            }
                                        }

                                    }else{
                                        if (item.checked && $U.isNotEmpty(item.kindCode)  && item.isBasic && item.isBasic.indexOf($rootScope.baseBean.isBasic)!=-1) { //选中的险种存入数据
                                            delete item.checked;
                                            delete item.isBasic;
                                            delete item.renewal;
                                            syRiskList.push(item);
                                        }
                                    }
                                } else { //车上货物责任险
                                    if($rootScope.carBeans.vehicle.carKindCode=='200'  && item.isBasic && item.isBasic.indexOf($rootScope.baseBean.isBasic)!=-1) { //
                                        if (item.checked && $U.isNotEmpty(item.kindCode)) { //选中的险种存入数据
                                            delete item.checked;
                                            delete item.isBasic;
                                            delete item.renewal;
                                            syRiskList.push(item);
                                        }
                                    }
                                }
                                //玻璃破碎,无法找到第三方  指定修理厂  修理期间 没有不计免赔
                                if(item.kindCode == "030107"||item.kindCode == "030115"||item.kindCode == "030112"||item.kindCode == "030116"){
                                    if ($U.isNotEmpty(item.kindCode)) { //玻璃破碎险
                                        item.relatedInd ='0';
                                    }
                                }

                            }
                        });
                        syoptions.coverageList = syRiskList;
                        //判断费折联动报价
                        if(opts && opts.quotationWay == '1'){ // 费折联动报价
                            console.log('费折联动')
                            // syoptions.feeDiscountLinkPlan = $scope.feeDiscount.feeDiscountLinkPlan;
                            // 0730选择“双自主系数”点击“确认”，这个字段（feeDiscountLinkPlan）传0
                            if($scope.feeDiscount.feeDiscountLinkPlan == '2') {
                                syoptions.feeDiscountLinkPlan = 0;
                            } else {
                                syoptions.feeDiscountLinkPlan = $scope.feeDiscount.feeDiscountLinkPlan;
                            }
                            syoptions.allowFlag = $scope.feeDiscount.allowFlag;
                            syoptions.allowReason = $scope.feeDiscount.allowReason;
                            syoptions.applySumDiscount = $scope.feeDiscount.applySumDiscount;
                            syoptions.comissionRate = $scope.feeDiscount.applyComissionRate;
                            syoptions.descentLinkFlag = $scope.feeDiscount.descentLinkFlag;
                            syoptions.applyDoubleAutoValue = $scope.feeDiscount.applyDoubleAutoValue;
                        }else{  // 常规报价
                            if($scope.pageCode=='PQUERY'||$scope.pageCode=='DRAFTS'||$rootScope.newPolicyShow){ // 下发修改、复制单进来，折扣取￥rootScope.carBean.riskList里面的值，
                                //遍历商业险
                                angular.forEach($rootScope.carBeans.riskList, function (riskItem, allIndex) {
                                    if(riskItem.riskCode == "0302"&&!$scope.feeDiscount.applySumDiscountNormal) {
                                        // console.log(riskItem.applySumDiscount,'riskItem.applySumDiscount')
                                        //商业险总折扣
                                        // 因为初次进来，并没有计算保费，页面要显示，所以先付一次值；
                                        $scope.feeDiscount.applySumDiscountNormal = $scope.calPremiumResult.applySumDiscount = riskItem.applySumDiscount;
                                    }
                                });
                            }
                            syoptions.feeDiscountLinkPlan = '';
                            syoptions.allowFlag = '';
                            syoptions.allowReason = '';
                            syoptions.applyDoubleAutoValue = '';
                            syoptions.applySumDiscount = $scope.feeDiscount.applySumDiscountNormal?$scope.feeDiscount.applySumDiscountNormal:$scope.calPremiumResult.applySumDiscount;
                            syoptions.comissionRate = $scope.feeDiscount.applyComissionRateNormal;
                            syoptions.descentLinkFlag = $scope.feeDiscount.descentLinkFlag;
                            
                        }
                        riskList.push(syoptions);
                    }

                    //交强险
                    if($rootScope.baseBean.jqOrigFlag) {
                        riskList.push(jqOptions);
                    }


                    return riskList;
                };
                // 设置费折联动初始值
                handle.setFeeDiscount = function(opts){
                    // debugger
                    var riskList = opts.riskList || {};
                    var base = opts.base || {};
                    var quotationWay = opts.quotationWay || '';

                    if(riskList.type == 'feeDiscount'){  // 费折联动后赋值
                        $scope.feeDiscount.sumGrossPremium =  (riskList.sumGrossPremium); //商业险保费
                        $scope.feeDiscount.applySumDiscount = $scope.feeDiscount.applySumDiscountPre = (riskList.applySumDiscount); //折扣
                        $scope.feeDiscount.applyComissionRate =  $scope.feeDiscount.applyComissionRatePre =(riskList.applyComissionRate); //手续费比例
                        $scope.feeDiscount.applyDoubleAutoValue = $scope.feeDiscount.applyDoubleAutoValuePre = riskList.applyDoubleAutoValue; //双自主系数
                        $rootScope.baseBean.applySumDiscount = riskList.applySumDiscount;  // 重新设置报价折扣
                        $rootScope.baseBean.salesFeeRate= riskList.salesFeeRate; //重新设置报价展业费
                    }else{
                        angular.forEach(riskList, function(riskItem) {  // 保费试算后赋值
                            if(riskItem.riskCode == "0302") { // 商业险
                                //费折联动数据初始化
                                $scope.feeDiscount.sumGrossPremium =  (riskItem.sumGrossPremium); //商业险保费
                                $scope.feeDiscount.applySumDiscount = $scope.feeDiscount.applySumDiscountPre = $scope.feeDiscount.applySumDiscountNormal = (riskItem.applySumDiscount); //折扣
                                $scope.feeDiscount.applyComissionRate = $scope.feeDiscount.applyComissionRatePre = $scope.feeDiscount.applyComissionRateNormal = (riskItem.comissionRate); //手续费比例
                                $scope.feeDiscount.feeDiscountLinkFlag = (riskItem.feeDiscountLinkFlag||'0'); //费折联动标志
                                $scope.feeDiscount.allowSwitch = (riskItem.allowSwitch||'0'); //通融开关
                                $scope.feeDiscount.quotationNo = (riskItem.quotationNo); //报价单号
                                $scope.feeDiscount.proposalNo = (riskItem.proposalNo); //报价单号
                                $scope.feeDiscount.applyDoubleAutoValue = $scope.feeDiscount.applyDoubleAutoValuePre  = riskItem.applyDoubleAutoValue; //双自主系数

                                $scope.feeDiscount.finalExpectedRate = riskItem.finalExpectedRate; //最终变动成本率
                                $scope.feeDiscount.maxExpectedRate = riskItem.maxExpectedRate; //变动成本率底线值
                                $scope.feeDiscount.initExpectedRate = riskItem.initExpectedRate; //初始变动成本率
                                $scope.feeDiscount.minExpectedRate = riskItem.minExpectedRate; //变动成本率软起步值
                                $scope.feeDiscount.minLinkDiscount = riskItem.minLinkDiscount; //可联动的最低总折扣
                                $scope.feeDiscount.linkSituation = riskItem.linkSituation; //费折联动状态
                                $scope.feeDiscount.descentLinkFlag = (riskItem.descentLinkFlag=='1'||riskItem.descentLinkFlag=='2')?'1':'0'; // 底线值下调联动标志 1或2提交1表示是，0或空提交0表示否
                                $scope.feeDiscount.descentLinkFlagBoolean = ($scope.feeDiscount.descentLinkFlag=='1')?true:false;
                                $scope.feeDiscount.errMsg = ''; //清空错误消息
                                $scope.feeDiscount.succMsg = ''; 
                            }
                        });
                        $scope.feeDiscount.businessMode = base.businessMode;   // 业务渠道
                    }

                    if(quotationWay == '0' && $scope.feeDiscount.quotationWayFinal == '1'){ // 本次是常规报价  上次是费折联动报价
                        $scope.feeDiscount.quotationWayFinal = '0';
                        $U.showToast('费折联动方案已失效，请重新配置！');
                    }else if(quotationWay == '1'){ // 本次是费折联动报价   上次不管了
                        $scope.feeDiscount.quotationWayFinal = '1';
                    }
                };

                //设置险种保费
                handle.setPremium = function(riskList) {
                    //calPremiumResult
                    $rootScope.calPremiumResult = $scope.calPremiumResult = {}; //保存计算后的商业险保费
                    $rootScope.getCalPremiumResult = {};//清空缓存，此参数用来保存保费计算结果，用来在提核页重新报价之后做对比，1112期
                    var deductiblePremium = 0; //不计免赔
                    angular.forEach(riskList, function(riskItem) {
                        if(riskItem.riskCode == "0302") {
                            //遍历商业险
                            angular.forEach(riskItem.coverageList, function(coverageItem, index) {
                                if(coverageItem.relatedInd == '1') {
                                    deductiblePremium = $U.accAdd(deductiblePremium,coverageItem.nonDeductiblePremium||'0');
                                }
                                //险种金额
                                $scope.calPremiumResult[coverageItem.kindCode] = coverageItem;
                            });
                            //计算保费成功之后 更新本地缓存折扣值
                            angular.forEach($rootScope.carBeans.riskList, function (item, allIndex) {
                                if(item.riskCode == "0302") {
                                        item.applySumDiscount = riskItem.applySumDiscount;
                                }
                            });

                            //存储商业险信息
                            $scope.calPremiumResult.syCalData = riskItem;
                            console.log($scope.calPremiumResult.syCalData,'666666');
                            //商业险系数
                            $scope.calPremiumResult.syAdjustInfo = riskItem.riskItemList;
                            //商业险风险等级
                            $rootScope.riskGradeSy = riskItem.riskGrade;
                            //商业险总折扣
                            $scope.calPremiumResult.applySumDiscount = riskItem.applySumDiscount;
                            //商业险总价
                            $scope.calPremiumResult.syTotalPremium =  (riskItem.sumGrossPremium||"0");
                            //0813商业险浮动系数
                            $scope.calPremiumResult.syFloatInfo = riskItem.riskItemList[0].ciNoFloatReason;
                            //车船税
                            $scope.calPremiumResult.vhlTax = {};//没有交强险时，赋值为空，避免报错
                            
                        } else if(riskItem.riskCode == "0301") {
                            //存储交强险信息
                            $scope.calPremiumResult.jqCalData = riskItem;
                            //交强险浮动系数
                            $scope.calPremiumResult.jqAdjustInfo = riskItem.floatInfo;
                            //交强险风险等级
                            $rootScope.riskGradeJq = riskItem.riskGrade;
                            //交强险总折扣
                            $scope.calPremiumResult.jqApplySumDiscount = riskItem.applySumDiscount;
                            //交强险保费
                            $scope.calPremiumResult.jqTotalPremium = (riskItem.sumGrossPremium||"0");
                            //车船税
                            $scope.calPremiumResult.vhlTax = (riskItem.vhlTax||"0");
                        }
                    });
                    //不计免赔总价
                    $scope.calPremiumResult.deductible = deductiblePremium;

                    //非车险种保费
                    $scope.nocarTotalPremium = $scope.calResultData.base.noCarSumPremium||'0';

                    //非车险种
                    if($rootScope.switchBean.noCarPrdSwitch){
                        $rootScope.noCarRiskList = $scope.calResultData.noCarProductList || [];
                    }else{
                        $rootScope.noCarRiskList = $scope.calResultData.noCarRiskList || [];
                    }
                    $rootScope.getCalPremiumResult = {
                        calPremiumResult:$scope.calPremiumResult,
                        nocarPremiumResult:$scope.nocarTotalPremium
                    }
                    // console.log($scope.getCalPremiumResult,'保费结果')
                }

                handle.depreciateValue = function(isFlag) {
                    //折旧
                    $handleService.http({
                        url: "/depreciation?flowId=" + $rootScope.flowId,
                        method: 'POST',
                        data: {
                            riskCode: "0302",
                            startDate: Handle.translateTime($rootScope.baseBean.syInsureStartTime)
                        },
                        success: function (data) {
                            $handleService.logger('object', data, '折旧返回结果');
                            if(data.resultCode == "0") {
                                $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = false;
                                if(!isFlag && $scope.isDiscountNoEdit){
                                    // 如果是初始化的时候查询的折旧 则让报价状态暂时改为 已报价 显示折扣信息
                                    $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = true;
                                }
                                $rootScope.carBeans.vehicle.actualValue = data.result.actualValue;
                                $rootScope.baseBean.actualValue = data.result.actualValue;
                                //修改车型实际价值
                                //$rootScope.CAR_BEANS.ACT_VALUE = data.ACT_VALUE;
                                //修改 车损 盗抢 自燃  机动车损失保险（全面型） 保额
                                $rootScope.baseBean.syRiskList[0].sumInsured = data.result.actualValue;
                                $rootScope.baseBean.syRiskList[2].sumInsured = data.result.actualValue;
                                $rootScope.baseBean.syRiskList[6].sumInsured = data.result.actualValue;
                                $rootScope.baseBean.syRiskList[16].sumInsured = data.result.actualValue;
                            } else {
                                $handleService.showAlert("提示",data.errorMsg);
                            }
                        },
                        error: function (ex) {
                            $handleService.logger('error', ex);
                        }
                    });
                }

                //获取非车险种
                handle.getNocarList = function() {
                    var nocartempList =[];
                    // //投保人为个人，使用性质非营运，车辆种类客车，核定座位数<=7 并且不是短期商业险
                    var has0621 = $rootScope.carBeans.base.busiAttrConfig.attachNatures=='01'&& $rootScope.carBeans.base.busiAttrConfig.useNatures == "02" && ($rootScope.baseBean.ownerAge >=18 &&$rootScope.baseBean.ownerAge <=70)&& $rootScope.carBeans.vehicle.carKindCode == "100" && Number($rootScope.carBeans.vehicle.seatCount) <= 7 && (!$rootScope.baseBean.shortSY &&!$rootScope.baseBean.shortJQ);
                    var has0601 = $rootScope.carBeans.base.busiAttrConfig.attachNatures=='01'&& $rootScope.carBeans.base.busiAttrConfig.useNatures == "02" && ($rootScope.baseBean.ownerAge >=18 &&$rootScope.baseBean.ownerAge <=70)&& $rootScope.carBeans.vehicle.carKindCode == "100" &&(!$rootScope.baseBean.shortSY && !$rootScope.baseBean.shortJQ);
                    var has0107 = $rootScope.carBeans.base.busiAttrConfig.attachNatures=='01'&& $rootScope.carBeans.base.busiAttrConfig.useNatures == "02" &&  $rootScope.carBeans.vehicle.carKindCode == "100" &&(!$rootScope.baseBean.shortSY && !$rootScope.baseBean.shortJQ);

                    //当不满足非车标志时  不获取非车产品信息
                    // if(!hasNocarFlag) {
                    //     $scope.nocarList = [];
                    //     return;
                    // }
                    var riskStr = "";
                    if($rootScope.baseBean.jqOrigFlag && $rootScope.baseBean.syOrigFlag) {
                        riskStr = "";
                    } else if($rootScope.baseBean.jqOrigFlag) {
                        riskStr = "0301";
                    }
                    else if($rootScope.baseBean.syOrigFlag) {
                        riskStr = "0302";
                    }
                    var optionsOld = {
                        productCode: '01',//机动车传01，摩托车传04
                        applyRiskCode: riskStr,//险种代码
                        companyCode: $U.getDeptCode() // 机构代码
                    }
                    $handleService.http({
                        url: "/queryNoCarRationInfo",
                        data: optionsOld,
                        success: function(data) {
                            $handleService.logger("object", data, "获取非车险种");
                            if(data.resultCode == "0") {
                                nocartempList =  angular.copy(data.result||[]);
                                for(var i = 0;i<nocartempList.length;i++){
                                    if(nocartempList[i].riskCode=='0621'&& !has0621){
                                        nocartempList.splice(i, 1) ;
                                        i--;
                                        continue;
                                    }
                                    if(nocartempList[i].riskCode=='0601' && !has0601){
                                        nocartempList.splice(i, 1) ;
                                        i--;
                                        continue;
                                    }
                                    if(nocartempList[i].riskCode=='0107'&& !has0107){
                                        nocartempList.splice(i, 1) ;
                                        i--;
                                        continue;
                                    }
                                }
                                $handleService.logger("object", nocartempList, "非车险种条件过滤");
                                $scope.nocarList =  nocartempList ||[];
                                angular.forEach($scope.nocarList, function(item){
                                    item.waxBatch = item.waxBatch || 1;
                                    item.checked = false;
                                   if(item.calType == "2") {
                                       item.totalPremium = item.premium * $rootScope.carBeans.vehicle.seatCount * Number(item.waxBatch);
                                   } else {
                                       item.totalPremium = item.premium * Number(item.waxBatch);
                                   }
                                });
                                //0813【交叉销售】车险增加符合交叉销售的标识_start
                                if($U.isNotEmpty($scope.nocarList)) {
                                    var productCodeArr = [];
                                    var productCodeStr = '';
                                    angular.forEach($scope.nocarList, function(nocarItem){
                                        productCodeArr.push(nocarItem.productCode.substr(1,4));
                                    })
                                    productCodeStr = productCodeArr.join(',');
                                }
                                $rootScope.carBeans.base.allowNocarListFlag = productCodeStr||'';
                                if($rootScope.switchBean.lastYearDataSwitch) {
                                    //带出上年方案
                                    Handle.getPrevYearPolicy();
                                }
                                //0813【交叉销售】车险增加符合交叉销售的标识_end
                                Handle.initCheckedNocarList();
                            }
                            
                        },
                        error:function(ex){
                            if($rootScope.switchBean.lastYearDataSwitch) {
                                //带出上年方案
                                Handle.getPrevYearPolicy();
                            }
                            $handleService.logger('error', ex);
                        }
                    })
                }

                //获取非车险种 ---> 新交叉销售
                handle.getNocarListNew = function() {
                    var nocartempList =[];
                    var optionsNew = {
                        departmentCode: $U.getDeptCode(), // 机构代码,
                        useNature: $rootScope.carBeans.base.busiAttrConfig.useNatures, //使用性质
                        attachNature: $rootScope.carBeans.base.busiAttrConfig.attachNatures, //所属性质
                        tonCount:  $rootScope.carBeans.vehicle.tonCount, //吨位
                        seatCount: $rootScope.carBeans.vehicle.seatCount, //核定载客数
                        vehicleType: $rootScope.carBeans.vehicle.carKindCode,
                    };
                    $handleService.http({
                        url: "/queryNoCarProducts",
                        data: optionsNew,
                        success: function(data) {
                            $handleService.logger("object", data, "获取非车险种");
                            if(data.resultCode == "0") {
                                nocartempList =  angular.copy(data.result||[]);
                                angular.forEach(nocartempList,function(exItem){
                                    // 修改exItem是为了让页面展示的正确
                                    //exItem.clauseText = exItem.rationList[0].clauseText || clauseTextO[exItem.productCode]; // 默认选择方案一 所以[0]
                                    exItem.maxBatch = exItem.rationList[0].maxBatch; // 默认选择方案一 所以[0]
                                    exItem.waxBatch = exItem.waxBatch || 1; //默认份数
                                    exItem.checked = false; // 默认不选中
                                    if(exItem.calType == "2") {// 默认保费
                                        exItem.totalPremium = exItem.premium * $rootScope.carBeans.vehicle.seatCount * Number(exItem.waxBatch) ;
                                    } else {
                                        exItem.totalPremium = exItem.premium * Number(exItem.waxBatch);
                                    }
                                    // 修改inItem是为了报价传的险种信息正确
                                    angular.forEach(exItem.rationList,function(inItem){
                                        inItem.productCode = exItem.productCode;
                                        inItem.productName = exItem.riskName;
                                        inItem.actualPremiumAmt = inItem.premium;
                                        inItem.releaiton = ["0107", "0840"].indexOf(inItem.riskCode) != -1 ? "0" : "14";
                                        inItem.noCarProductCoverage = inItem.noCarCoverageList;
                                    })
                                });
                                $scope.nocarList =  nocartempList || [];
                                //0813【交叉销售】车险增加符合交叉销售的标识_start
                                if($U.isNotEmpty($scope.nocarList)) {
                                    var productCodeArr = [];
                                    var productCodeStr = '';
                                    angular.forEach($scope.nocarList, function(nocarItem){
                                        productCodeArr.push(nocarItem.productCode.substr(1,4));
                                    })
                                    productCodeStr = productCodeArr.join(',');
                                }
                                $rootScope.carBeans.base.allowNocarListFlag = productCodeStr||'';

                                if($rootScope.switchBean.lastYearDataSwitch) {
                                    //带出上年方案
                                    Handle.getPrevYearPolicy();
                                }
                                $scope.hasQueryNocarList = true; // 1015_标记nocallist请求状态
                                //0813【交叉销售】车险增加符合交叉销售的标识_end
                                Handle.initCheckedNocarList();
                            }
                        },
                        error:function(ex){
                            if($rootScope.switchBean.lastYearDataSwitch) {
                                //带出上年方案
                                Handle.getPrevYearPolicy();
                            }
                            $handleService.logger('error', ex);
                        }
                    })
                }

                //0813特约信息保存
                handle.getClauseListTemp = function () {
                    var newList = [];
                    var newItem = null;
                    angular.forEach($rootScope.baseBean.specialData, function (specialDataItem) {
                        if (specialDataItem.checked) {
                            newItem = angular.copy(specialDataItem);
                            newList.push(newItem);
                        }
                    })
                    return newList;
                }
               
                // 通过从暂存单带过来的信息或者其他地方缓存的信息, 初始化选中的非车产品
                console.log('$scope.preBuyedNocarList',$scope.preBuyedNocarList);
                handle.initCheckedNocarList = function () {
                    //1015_判断两个接口是否都异步加载完
                    var goAheadStatus = $scope.hasQueryNocarList && $scope.hasQueryPrevYearBuyedNocarList;
                    if (goAheadStatus) {
                        //1015_判断是否满足续保并获取历史购买非车记录条件
                        var prevYearBuyedStatus = $stateParams.SU_CODE && $stateParams.SU_CODE.toUpperCase() == 'RENEWAL' && $U.isEmpty($scope.preBuyedNocarList) && $U.isNotEmpty($scope.prevYearBuyedNocarList);
                        if (prevYearBuyedStatus) {
                            console.warn('prevYearBuyedNocarList合并: ',$scope.prevYearBuyedNocarList);
                        } else {
                            console.warn('preBuyedNocarList,走暂存购买非车分支');
                        }
                        angular.forEach($scope.nocarList, function (exItem) { // 第一层: 循环可以购买的非车产品     
                            angular.forEach($scope.preBuyedNocarList, function (inItem) { // 第二层: 循环缓存里已购买的非车产品
                                if (exItem.riskCode == inItem.riskCode) { // 确定购买的产品
                                    //循环捞出最大份数 和  noCarCoverageList
                                    angular.forEach(exItem.rationList, function (inInItem) { // 可购买险种的方案list  match  缓存里已购买的非车产品
                                        if (inItem.rationCode == inInItem.rationCode) {
                                            exItem.maxBatch = inInItem.maxBatch; // 第三层
                                            exItem.noCarCoverageList = inInItem.noCarCoverageList; // 第三层
                                            exItem.noCarProductCoverage = inInItem.noCarCoverageList; // 第三层
                                            inItem.noCarCoverageList = inInItem.noCarCoverageList; // 第三层
                                            inItem.noCarProductCoverage = inInItem.noCarCoverageList; // 第三层
                                            $rootScope.nocarArr.push(inItem);
                                            exItem.checked = true;
                                            // 为了让页面展示正确
                                            if(Number(inItem.waxBatch) <= Number(exItem.maxBatch)){
                                                //如果当前投保分数在范围内才有效
                                                exItem.waxBatch = inItem.waxBatch || exItem.waxBatch || 1; // 第二层  伍念bug修改 
                                            }
                                            exItem.calType = inItem.calType;
                                            exItem.rationCode = inItem.rationCode;
                                            exItem.premium = inItem.premium || inItem.actualPremiumAmt || exItem.premium;
                                            // exItem.clauseText = inItem.clauseText || clauseTextO[exItem.productCode];
                                            //非车险种保费显示
                                            if (exItem.calType == "2") {
                                                exItem.totalPremium = Number(exItem.premium) * Number($rootScope.carBeans.vehicle.seatCount) * Number(exItem.waxBatch);
                                            } else {
                                                exItem.totalPremium = Number(exItem.premium) * Number(exItem.waxBatch);
                                            }
                                        }
                                    });
                                }
                            });
                        });
                        console.log('$scope.nocarList', $scope.nocarList);
                        //1015_这里做勾选
                        if ($stateParams.SU_CODE && $stateParams.SU_CODE.toUpperCase() == 'RENEWAL' && $U.isNotEmpty($scope.prevYearBuyedNocarList)) {
                            //检测非车历史购买记录和非车列表
                            angular.forEach($scope.nocarList, function (exItem) {
                                angular.forEach($scope.prevYearBuyedNocarList, function (inItem) {
                                    if (exItem.riskCode == inItem.riskCode) {
                                        if(prevYearBuyedStatus) {
                                            exItem['checked'] = true;
                                        }
                                        exItem['historyChecked'] = true;
                                        exItem['historyWaxBatch'] = inItem.waxBatch;
                                    }
                                })
                            })
                            $rootScope.nocarArr = [];
                            angular.forEach($scope.nocarList, function (data) {
                                var newData = angular.copy(data);
                                newData.rationList = [];
                                if (data.checked) {
                                    angular.forEach(data.rationList, function (item) {
                                        if (data.rationCode == item.rationCode) {
                                            item.waxBatch = newData.waxBatch;
                                            newData.rationList[0] = item;
                                            $rootScope.nocarArr.push(newData.rationList[0]);
                                        }
                                    });
                                };
                            });
                        };

                    } else {
                        console.warn('X goAheadStatus,不满足两个接口都异步加载完或则已经执行过');
                    }
                };
                //0813
                handle.checkCarModelFunc = function (evt, VHL) {
                    if (VHL) {
                        /*广东交管避免覆盖 start*/
                        if ($rootScope.carBeans.vehicle.gdQueryFlag == '1') {
                            angular.extend(VHL, $rootScope.carBeans.vehicle.jgVehicleModel || {})
                        }
                        /*广东交管避免覆盖 end*/

                        $scope.vehicleTypeFlag = VHL.jqxClassId;
                        //回填纳税类型  车型信息无纳税类型，且纳税类型经过业务员确认，无需修改
                        //$rootScope.baseBean.jqRiskList.vhlTax.taxRelifFlag=VHL.taxRelifFlag;

                        //车型对象封装
                        $rootScope.baseBean.vhlData = VHL;

                        //回填carBeans.vehicle
                        angular.forEach($rootScope.carBeans.vehicle, function (value, key) {
                            if (VHL.hasOwnProperty(key) && (VHL[key] || VHL[key] == 0)) {
                                $rootScope.carBeans.vehicle[key] = VHL[key];
                            }
                        });
                        //新车购置价
                        $rootScope.carBeans.vehicle.actualValue = VHL.purchasePrice;

                        //整备质量
                        $rootScope.baseBean.vhlData.completeKerbMass = Number(VHL.completeKerbMass) / 1000;
                        $rootScope.baseBean.jqRiskList.vhlTax.fuelType = VHL.powerTypeCode;

                        $rootScope.carBeans.vehicle.printBrandName = VHL.brandName || ''; //0813打印品牌型号回填
                    }
                }

                return handle;
            }(Handle||{})
            $rootScope.$on('$stateChangeSuccess', function (ev, to, toParams, from, fromParams) {
                $rootScope.prePage = from; //from为前一个页面的路由信息：url,cache,views,name
            });
            // APP分享一键续保
            $scope.toShare = function(){
                $state.go("tab.appPushYjxb", {endDate:$scope.endDate});
            }

            // 费折联动
            $scope.feeValid = function(){
                var result ={valid: true};
                if ( $scope.feeDiscount.feeDiscountLinkPlan == '0' && $scope.feeDiscount.applySumDiscount == '') {  //调折扣
                    result = {valid: false, msg: '总折扣不能为空'}
                }else if ($scope.feeDiscount.feeDiscountLinkPlan == '1' && $scope.feeDiscount.applyComissionRate == '') { //调手续费
                    result = {valid: false, msg: '手续费不能为空'}
                }else if($scope.feeDiscount.feeDiscountLinkPlan == '0' && $scope.feeDiscount.applySumDiscount <= 0 ){
                    result = {valid: false, msg: '总折必须大于0'}
                }
                return result;
            };

            $scope.feeLinkQuery = function(){
                // debugger
                var feeValid = $scope.feeValid();
                if(!feeValid.valid){
                    $U.showToast(feeValid.msg);
                    return;
                }
                $scope.feeDiscount.succMsg = '';
                $scope.feeDiscount.errMsg = '';
                if($scope.feeDiscount.feeDiscountLinkPlan == '1' &&  $scope.feeDiscount.initExpectedRate < $scope.feeDiscount.minExpectedRate){
                    $scope.feeDiscount.errMsg = '初始变动成本率低于变动成本率软起步值，仅允许调整折扣！';
                    $scope.feeDiscount.allowSure = false;
                    return;
                }
                var feeDiscount = {
                    allowFlag: $scope.feeDiscount.allowFlag ,
                    allowReason: $scope.feeDiscount.allowReason,
                    quotationNo: $scope.feeDiscount.quotationNo,
                    proposalNo: $scope.feeDiscount.proposalNo,
                    quotationWay: $scope.feeDiscount.quotationWay,
                    descentLinkFlag: $scope.feeDiscount.descentLinkFlag,
                    /* 
                        以下4个参数需要拼装:
                        修改折扣 和 双自主系数时, feeDiscountLinkPlan都要传0,  其他2项(折扣,费用,系数)传空
                        修改费用时feeDiscountLinkPlan传1, 折扣和自主系数传空

                        页面上feeDiscountLinkPlan的值和后台的值略有不同, 是为了方便切换radio时,另外2的值还原的逻辑处理
                        折扣:0  费用:1  自助系数:2 
                    */
                    applyComissionRate: '',
                    applySumDiscount:'',
                    feeDiscountLinkPlan: '',
                    applyDoubleAutoValue:'',
                };
                // 拼装下面4个参数
                switch($scope.feeDiscount.feeDiscountLinkPlan){
                    case '0': // 修改折扣
                    feeDiscount = angular.extend(feeDiscount, {
                        feeDiscountLinkPlan: '0',
                        applySumDiscount: $scope.feeDiscount.applySumDiscount,
                        // 0716修改折扣同时修改折扣和手续费
                        applyComissionRate: $scope.feeDiscount.allowFlagBoolean?$scope.feeDiscount.applyComissionRate:"",
                        });
                    break;
                    case '1': // 修改费用 
                    feeDiscount = angular.extend(feeDiscount, {
                        feeDiscountLinkPlan: '1',
                        applyComissionRate: $scope.feeDiscount.applyComissionRate,
                        // 0716修改手续费同时修改手续费和折扣
                        applySumDiscount: $scope.feeDiscount.allowFlagBoolean?$scope.feeDiscount.applySumDiscount:"",
                    });
                    break;
                    case '2': // 修改双自主系数
                    feeDiscount = angular.extend(feeDiscount, {
                        feeDiscountLinkPlan: '0',
                        applyDoubleAutoValue: $scope.feeDiscount.applyDoubleAutoValue,
                        // 0716修改双自主系数同时修改双自主系数和手续费
                        applyComissionRate: $scope.feeDiscount.allowFlagBoolean?$scope.feeDiscount.applyComissionRate:"",
                        });
                    break;  
                };

                $handleService.http({
                    url: "/vehichInsFeeLinkQuery",
                    data: feeDiscount,
                    success: function (data) {
                        // debugger
                        $handleService.logger('object', data, '费折计算保费');
                        //处理保费试算
                        if(data.resultCode == "0") {
                            $scope.feeDiscount.quotationWay = '1';  // 第一次默认是常规报价, 成功后, 后续都是费折联动报价
                            $scope.feeDiscount.allowSure = true;    // 确认开关变成true
                            $timeout(function () {
                                $scope.feeDiscount.finalSumRateShow=false;
                            },3000);
                            $scope.feeDiscount.finalSumRateShow=true;
                            $scope.feeDiscount.finalSumRate=data.result.finalSumRate;
                            $scope.feeDiscount.linkSituation=data.result.linkSituation;
                            
                            $scope.feeDiscount.finalExpectedRate = data.result.finalExpectedRate; //最终变动成本率
                            $scope.feeDiscount.maxExpectedRate = data.result.maxExpectedRate; //变动成本率底线值
                            $scope.feeDiscount.initExpectedRate = data.result.initExpectedRate; //初始变动成本率
                            $scope.feeDiscount.minExpectedRate = data.result.minExpectedRate; //变动成本率软起步值
                            $scope.feeDiscount.minLinkDiscount = data.result.minLinkDiscount; //可联动的最低总折扣
                            $scope.feeDiscount.descentLinkFlag = (data.result.descentLinkFlag=='1'||data.result.descentLinkFlag=='2')?'1':'0'; // 底线值下调联动标志 1或2提交1表示是，0或空提交0表示否
                            $scope.feeDiscount.descentLinkFlagBoolean = ($scope.feeDiscount.descentLinkFlag=='1')?true:false;

                            Handle.setFeeDiscount({
                                riskList :{
                                applyComissionRate: data.result.finalCommissionRate,  //手续费
                                applySumDiscount: data.result.finalSumDiscount,  //总折扣
                                sumGrossPremium: data.result.sumPremium, //保费
                                salesFeeRate: data.result.finalExhibitionRate, //展业费
                                applyDoubleAutoValue: data.result.applyDoubleAutoValue, // 双自主系数
                                type: 'feeDiscount'}
                            });
                        }
                        else if(data.resultCode == "2"){
                            $scope.feeDiscount.quotationWay = '1';  // 第一次默认是常规报价, 成功后, 后续都是费折联动报价
                            $scope.feeDiscount.allowSure = true;    // 确认开关变成true
                            $timeout(function () {
                                $scope.feeDiscount.finalSumRateShow=false;
                            },3000);
                            $scope.feeDiscount.finalSumRateShow=true;
                            $scope.feeDiscount.finalSumRate=data.result.finalSumRate;
                            $scope.feeDiscount.linkSituation=data.result.linkSituation;

                            $scope.feeDiscount.finalExpectedRate = data.result.finalExpectedRate; //最终变动成本率
                            $scope.feeDiscount.maxExpectedRate = data.result.maxExpectedRate; //变动成本率底线值
                            $scope.feeDiscount.initExpectedRate = data.result.initExpectedRate; //初始变动成本率
                            $scope.feeDiscount.minExpectedRate = data.result.minExpectedRate; //变动成本率软起步值
                            $scope.feeDiscount.minLinkDiscount = data.result.minLinkDiscount; //可联动的最低总折扣
                            $scope.feeDiscount.descentLinkFlag = (data.result.descentLinkFlag=='1'||data.result.descentLinkFlag=='2')?'1':'0'; // 底线值下调联动标志 1或2提交1表示是，0或空提交0表示否
                            $scope.feeDiscount.descentLinkFlagBoolean = ($scope.feeDiscount.descentLinkFlag=='1')?true:false;

                            Handle.setFeeDiscount({
                                riskList :{
                                    applyComissionRate: data.result.finalCommissionRate,  //手续费
                                    applySumDiscount: data.result.finalSumDiscount,  //总折扣
                                    sumGrossPremium: data.result.sumPremium, //保费
                                    salesFeeRate: data.result.finalExhibitionRate, //展业费
                                    applyDoubleAutoValue: data.result.applyDoubleAutoValue, // 双自主系数
                                    type: 'feeDiscount'}
                            });
                            $scope.feeDiscount.succMsg = '您修改的折扣或手续费超出系统控制范围, 已为您按最优值计算保费';
                        }
                        else {
                            $scope.feeDiscount.allowSure = false;    // 确认开关变成true
                            $handleService.showAlert('提示',data.errorMsg);
                        }
                    },
                    error: function (ex) {
                        $scope.feeDiscount.allowSure = false;    // 确认开关变成true
                    }
                });

            };

            //理赔信息页面
            $scope.claimListPage = function() {
                $state.go("tab.claimListPage");
            };

            //不计免赔更改重新计算
            $scope.recalculatPremium = function() {
                $rootScope.reCalPremiumFlag = true; //重新计算标识
            };

            //显示报价详情页面
            $scope.calsDetailsPage = function () {
                //跳转到-》报价详情页面
                $state.go("tab.calsDetailsPage", {tempNo: $rootScope.tempNo});
            };

            //弹出折扣系数信息
            $scope.openAdjustInfo = function () {
                if (!$scope.hasCalPremiunFlag) {
                    return;
                }
                window._cache = {};
                window._cache.adjust = {
                    applySumDiscount: $scope.calPremiumResult.applySumDiscount, //商业险总折扣
                    jqApplySumDiscount: $scope.calPremiumResult.jqApplySumDiscount, //交强险总折扣
                    jqAdjust: $scope.calPremiumResult.jqAdjustInfo|| {},  //交强险系数
                    syAdjust: $scope.calPremiumResult.syAdjustInfo, //商业险系数
                    syFloat: $scope.calPremiumResult.syFloatInfo, //0813商业险浮动系数
                    syInfo: $scope.calResultData.accidentRespoSy //商业险往年出险次数
                };
                //跳转到-》信息确认页面
                $location.path("tab/adjustInfo");
            };
			// 0716关闭费折联动对话框
			$scope.closeFzldDialog = function () {
                // 还原feeDiscount
                // debugger
                if($scope.feeDiscountB) {
                    $scope.feeDiscount = angular.copy($scope.feeDiscountB);
                };
                $scope.feeDiscount.showFzldDialog = false;
			};

            //修改折扣
            $scope.modifyAdjust = function () {
                // debugger
                // 0716start
                // $scope.feeDiscount.feeDiscountLinkFlag = "2";
                // $scope.feeDiscount.businessMode = "2";
                // $scope.feeDiscount.showFzldDialog = true;
                // 如果是下发修改、复制单进来 显示折扣并且不允许修改
                if($scope.isDiscountNoEdit){//不允许修改
                    return;
                }
                // 0716end
                if($rootScope.switchBean.hideCustAndDiscountSwitch){
                    return;
                }
                var old = $scope.hasCalPremiunFlag ? $scope.calPremiumResult.applySumDiscount : '';
                if (!old) {
                    return;
                }
                $handleService.showConfirm({
                    title: '折扣修改',
                    template: '<input type="number" min="0" class="tac" maxlength="8" value="' + old + '" id="new_adjust" style/>',
                    sure: function () {
                        var new_adjust = angular.element('#new_adjust').val();
                        if(!(/^\d{1,2}(\.(\d{1,6})?)?$/.test(new_adjust))){
                            $U.showToast("折扣不得超过六位小数！");
                            return;
                        }

                        //如果修改折扣，需要把上次试算返回的建议折扣传回去
                       // $rootScope.syRiskList.ADVICE_TOTAL_ADJUST = $rootScope.CALCOST_RESULT.ADJUST.ADVICE_TOTAL_ADJ;
                        //传新的折扣
                        $rootScope.baseBean.applySumDiscount = $scope.feeDiscount.applySumDiscountNormal = $U.formatPremium(new_adjust, 6);
                        //重新报价
                        $scope.calAmount();
                    }
                });
                setTimeout(function () {
                    angular.element('#new_adjust').click().focus().val(old);//指针定位到输入框最后
                }, 100);
            };
            //修改折扣修改框遮挡问题
            function keyboardShowHandler(e){
                $(".popup").css({
                    "margin-top": -e.keyboardHeight + "px",
                    transform: "translate(-50%, 50%)"
                });

                if($(".popup").offset().top <= 0) {
                    $(".popup").css({
                        "margin-top": -e.keyboardHeight - $(".popup").offset().top + "px",
                        transform: "translate(-50%, 50%)"
                    });
                }
                if($("#checkTowNumWrap").length > 0) {
                    $(".popup").css({
                        "margin-top": -e.keyboardHeight + "px",
                        transform: "translate(-50%, 10%)"
                    });
                }

            }
            function keyboardHideHandler(e){
                $(".popup").css({
                    "margin-top": "0px",
                    transform: "translate(-50%, -50%)"
                });
            }

            //费折联动输入框这档问题
            function keyboardDiscountShow(e){
                $(".popup-fee").css({
                    "margin-top": -e.keyboardHeight + "px",
                    transform: "translate(0, 50%)"
                });

                if($(".popup-fee").offset().top <= 0) {
                    $(".popup-fee").css({
                        "margin-top": -e.keyboardHeight - $(".popup-fee").offset().top + "px",
                        transform: "translate(0, 50%)"
                    });
                }
            }
            function keyboardDiscountHide(e){
                $(".popup-fee").css({
                    "margin-top": "0px",
                    transform: "translate(0, 0)"
                });
            }


            $scope.keyboardShowHandler = keyboardShowHandler;

            if(ionic.Platform.isIOS()) { //解决IOS下 修改折扣输入框被键盘挡住的问题
                window.addEventListener('native.keyboardshow', keyboardShowHandler);
                window.addEventListener('native.keyboardhide', keyboardHideHandler);

                window.addEventListener('native.keyboardshow', keyboardDiscountShow);
                window.addEventListener('native.keyboardhide', keyboardDiscountHide);
            }

            //显示车船税明细
            $scope.showCsflag = function () {
                var RESULT = $scope.calPremiumResult.vhlTax.sumPayTax;
                if (RESULT && RESULT != "0.0") {
                    $rootScope.showTaxDetail = true;
                }
                else {
                    return;
                }
            };
            //影藏车船税明细
            $scope.hideCcsBox = function () {
                $rootScope.showTaxDetail = false;
            };

            //费率修改事件
            $scope.rateChange = function (val) {
                $rootScope.reCalPremiumFlag = true; //重新计算标识
                //判断 值范围
                var rate = Number(val);
                if (!window.isNaN(rate)) {
                    //全国统一
                    // 进口车承保指定专修厂险，费率区间为15%-60%
                    // 国产车承保指定专修厂险，费率区间为10%-30%

                    var vhead = $rootScope.carBeans.vehicle.frameNo.substr(0,1);
                    //判断车架号 是国产还是进口
                    if(vhead.toUpperCase() == "L"){
                        if (rate < 100) {
                            $U.showToast('国产车费率必须为100~300之间的数字');
                            $rootScope.baseBean.syRiskList[14].rate = "100";
                            return;
                        }
                        else if (rate > 300) {
                            $U.showToast('国产车费率必须为100~300之间的数字');
                            $rootScope.baseBean.syRiskList[14].rate = "300";
                            return;
                        }
                    }
                    else {
                        if (rate < 150) {
                            $U.showToast('进口车费率必须为150~600之间的数字');
                            $rootScope.baseBean.syRiskList[14].rate = "150";
                            return;
                        }
                        else if (rate > 600) {
                            $U.showToast('进口车费率必须为150~600之间的数字');
                            $rootScope.baseBean.syRiskList[14].rate = "600";
                            return;
                        }
                    }
                }
                else {
                    $U.showToast('费率必须为100~600之间的数字');
                    return;
                }
            };
            //车上货物责任险保额
            $scope.carDuty=function () {
                if($rootScope.baseBean.syRiskList[11].checked){
                    if($rootScope.baseBean.syRiskList[11].sumInsured>1000000||$rootScope.baseBean.syRiskList[11].sumInsured<=0){
                        $rootScope.baseBean.syRiskList[11].sumInsured='';
                        $U.showToast('车上货物责任险保额范围：0~1,000,000');
                    }else{
                        $rootScope.baseBean.syRiskList[11].sumInsured=Number($rootScope.baseBean.syRiskList[11].sumInsured.toString().match(/^\d+(?:\.\d{0,2})?/))
                    }
                }

            };

            //车损 自然 全车盗抢 保额修改 新车购置价下浮20%
            $scope.quotaChange = function (index) {  //修改车损保额
                $scope.changeVHL = {};
                var newAmt = Number($rootScope.carBeans.vehicle.purchasePrice); //新车购置价
                var vhlAmt = Number($rootScope.baseBean.actualValue);//Number($rootScope.carBeans.vehicle.actualValue); //折旧后价格
                //1.所有机构 车损可改
                if (index == 0) {
                    $handleService.showConfirm({
                        title: '修改车辆损失险',
                        template: '<input type="tel" ng-model="changeVHL.change" class="others" maxlength="10" placeholder="保额最小值不能低于新车购置价20%">',
                        confirm: false,
                        scope: $scope,
                        sure: function () {
                            if ($U.isEmpty($scope.changeVHL.change)) {
                                $U.showToast("保额输入不得为空或非数字");
                            }
                            else {
                                var valiAmt = Number($scope.changeVHL.change); //修改的价格

                                if(isNaN(valiAmt)) {
                                    $U.showToast("保额输入不得为空或非数字");
                                    return;
                                }

                                var minLimit = Number(newAmt * 0.2); //最小价格等于新车购置价20%

                                //如果 修改值 小于最小范围
                                if (valiAmt < minLimit) {  //修改的保额 小于于新车购置价20% 不允许
                                    $U.showToast("保额最小值不能低于新车购置价20%[" + minLimit + "]");
                                    return;
                                }
                                else {
                                    $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = false;
                                    $rootScope.baseBean.syRiskList[0].sumInsured = valiAmt.toFixed(2).toString();
                                }
                            }
                        }
                    });
                }
                // 更改 机动车损失保险（全面型）
                else if (index == 3) {
                    $handleService.showConfirm({
                        title: '修改车辆损失险',
                        template: '<input type="tel" ng-model="changeVHL.change" class="others" maxlength="10"  placeholder="保额最小值不能低于新车购置价20%">',
                        confirm: false,
                        scope: $scope,
                        sure: function () {
                            if ($U.isEmpty($scope.changeVHL.change)) {
                                $U.showToast("保额输入不得为空或非数字");
                            }
                            else {
                                var valiAmt = Number($scope.changeVHL.change); //修改的价格

                                if(isNaN(valiAmt)) {
                                    $U.showToast("保额输入不得为空或非数字");
                                    return;
                                }

                                var minLimit = Number(newAmt * 0.2); //最小价格等于新车购置价20%

                                //如果 修改值 小于最小范围
                                if (valiAmt < minLimit) {  //修改的保额 小于于新车购置价20% 不允许
                                    $U.showToast("保额最小值不能低于新车购置价20%[" + minLimit + "]");
                                    return;
                                }
                                else {
                                    $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = false;
                                    $rootScope.baseBean.syRiskList[16].sumInsured = valiAmt.toFixed(2).toString();
                                    if(valiAmt>newAmt){
                                        $rootScope.baseBean.syRiskList[2].sumInsured = newAmt.toFixed(2).toString();
                                    }else{
                                        $rootScope.baseBean.syRiskList[2].sumInsured = valiAmt.toFixed(2).toString();
                                    }
                                }
                            }
                        }
                    });
                }
                else if(index == 2){
                    $handleService.showConfirm({
                        title: '修改全车盗抢险',
                        template: '<input type="tel" ng-model="changeVHL.stolen" class="others" maxlength="10"  placeholder="保额最小值不能低于新车购置价20%">',
                        confirm: false,
                        scope: $scope,
                        sure: function () {
                            if ($U.isEmpty($scope.changeVHL.stolen)) {
                                $U.showToast("保额输入不得为空或非数字");
                            }
                            else {
                                var valiAmt = Number($scope.changeVHL.stolen); //盗抢险修改的价格

                                if(isNaN(valiAmt)) {
                                    $U.showToast("保额输入不得为空或非数字");
                                    return;
                                }

                                var minLimit = Number(newAmt * 0.2); //最小价格等于新车购置价20%

                                //如果 修改值 小于最小范围
                                if (valiAmt < minLimit) {  //修改的保额 小于于新车购置价20% 不允许
                                    $U.showToast("保额最小值不能低于新车购置价20%[" + minLimit + "]");
                                    return;
                                }
                                else {
                                    $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = false;
                                    $rootScope.baseBean.syRiskList[2].sumInsured = valiAmt.toFixed(2).toString();
                                }
                            }
                        }
                    });
                }
                else if(index == 1){//自燃损失险
                    $handleService.showConfirm({
                        title: '修改自燃损失险',
                        template: '<input type="tel" ng-model="changeVHL.fire" class="others" maxlength="10" placeholder="保额最小值不能低于新车购置价20%">',
                        confirm: false,
                        scope: $scope,
                        sure: function () {
                            if (isNaN(Number($scope.changeVHL.fire))) {
                                $U.showToast("保额输入不得为空或非数字");
                            }
                            else {
                                var valiAmt = Number($scope.changeVHL.fire); //自燃损失险修改的价格

                                if(isNaN(valiAmt)) {
                                    $U.showToast("保额输入不得为空或非数字");
                                    return;
                                }

                                var minLimit = Number(newAmt * 0.2); //最小价格等于新车购置价20%

                                //如果 修改值 小于最小范围
                                if (valiAmt < minLimit) {  //修改的保额 小于于新车购置价20% 不允许
                                    $U.showToast("保额最小值不能低于新车购置价20%[" + minLimit + "]");
                                    return;
                                }
                                else {
                                    $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = false;
                                    $rootScope.baseBean.syRiskList[6].sumInsured = valiAmt.toFixed(2).toString();
                                }
                            }
                        }
                    });
                }
            };

            $scope.chooseNone = function($event){
                /*<!--商业险  座位大于9 100为客车 02非营运-->*/
                if($rootScope.baseBean.isBasic == '1' && ($rootScope.carBeans.vehicle.seatCount>9 || $rootScope.carBeans.base.busiAttrConfig.useNatures!='02'||$rootScope.carBeans.vehicle.carKindCode!='100' ||$rootScope.carBeans.base.busiAttrConfig.attachNatures != '01')){
                    $rootScope.baseBean.isBasic = '0';
                    $U.showToast('仅限10座以下家庭自用客车投保');
                }else{
                    $rootScope.carBeans.ALL_CHOS = false;
                    $scope.chooseAll(false);
                }
            };
            //全选操作方法
            $scope.chooseAll = function (val, $event) {
                //遍历全部商业险
                angular.forEach($rootScope.baseBean.syRiskList, function (item, index) {
                    var CVRG = $rootScope.baseBean.syRiskList[index];
                    CVRG.checked = false; //首先全部为不选中
                    if(item.kindCode && item.isBasic && item.isBasic.indexOf($rootScope.baseBean.isBasic)!=-1) {
                        //单保责任 -- 》 去掉非责任险种
                        if($scope.carCheckFlag){
                            angular.forEach($rootScope.BASE_BEAN.DUTY_LIST, function (dutyTem) {
                                if(item.kindCode == dutyTem){
                                    CVRG.checked = val;
                                    //不计免赔 全选操作
                                    $rootScope.NO_DED['FRANCHISE_FLAG_' + index + 'T'] = val;
                                }
                            });
                        }
                        else {
                            //车上货物险 货车时
                            if($rootScope.carBeans.vehicle.carKindCode == "200"){
                                if(true){
                                    if(CVRG.kindCode != "030111"){
                                        CVRG.checked = val;
                                        //不计免赔 全选操作
                                        $rootScope.NO_DED['FRANCHISE_FLAG_' + index + 'T'] = val;
                                    }
                                }else{
                                    CVRG.checked = val;
                                    //不计免赔 全选操作
                                    $rootScope.NO_DED['FRANCHISE_FLAG_' + index + 'T'] = val;
                                }
                            }else {
                                if(CVRG.kindCode == "030120"){
                                    //三者假日翻倍险
                                    // todo 三者翻倍先不上  代码注释
                                    if($rootScope.carBeans.vehicle.seatCount<10 && $rootScope.carBeans.base.busiAttrConfig.useNatures=='02'&&$rootScope.carBeans.vehicle.carKindCode=='100' && $rootScope.carBeans.base.busiAttrConfig.attachNatures == '01'){
                                        CVRG.checked = val;
                                        //不计免赔 全选操作
                                        $rootScope.NO_DED['FRANCHISE_FLAG_' + index + 'T'] = val;
                                    }

                                }else if(CVRG.kindCode != "030113"){
                                    if(true){
                                        if(CVRG.kindCode != "030111"){
                                            CVRG.checked = val;
                                            //不计免赔 全选操作
                                            $rootScope.NO_DED['FRANCHISE_FLAG_' + index + 'T'] = val;
                                        }else{
                                            if($rootScope.carBeans.base.busiAttrConfig.useNatures != '01'){
                                                CVRG.checked = val;
                                                //不计免赔 全选操作
                                                $rootScope.NO_DED['FRANCHISE_FLAG_' + index + 'T'] = val;
                                            }
                                        }
                                    }else{
                                        CVRG.checked = val;
                                        //不计免赔 全选操作
                                        $rootScope.NO_DED['FRANCHISE_FLAG_' + index + 'T'] = val;
                                    }
                                }
                            }
                        }
                    }
                });
                $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = false;
                $handleService.logger("object", $rootScope.baseBean.syRiskList, "全选后险种对象")
                $event && $event.stopPropagation();
            };

            //两号校验接口
            $scope.checkTwoNumber = function (vhl_frm) {
                var options = {
                    endFrameNo: $rootScope.baseBean.twoFrameNo, //车架号后6位
                    vhlNo: $rootScope.carBeans.vehicle.licenseNo  // 车牌
                };

                $handleService.http({
                    url: "/checkFrameNo",
                    method: 'POST',
                    data: options,
                    success: function (data) {
                        $handleService.logger('object', data, '两号校验接口');

                        if (data.resultCode == "0") {
                            $rootScope.baseBean.isTwoNum=true;
                            $scope.CAR_CONFITM_FLAG = false; //两号校验成功后 隐藏两号弹出层
                            //跳转到-》信息确认页面
                            $location.path("tab/owConfirm");
                        }
                        else {
                            $scope.permitFalse++;
                            $rootScope.baseBean.twoFrameNo='';
                            if($scope.permitFalse==2){
                                $scope.permitFalse=0;
                                $scope.CAR_CONFIRM_SECTION=false;
                            }
                        }
                    },
                    error: function (ex) {
                        $handleService.logger('error', ex);
                    }
                });
            };

            $scope.cancelPop=function () {
                $scope.CAR_CONFITM_FLAG=false; //两号弹层
            };
            $scope.returnToLast=function () {
                $scope.CAR_CONFIRM_SECTION=true;
            };

            //两号提交并报价
            $scope.submitTwoNumber=function () {
                var reg=/^[A-Za-z0-9]{17}$/;
                var engNo=$rootScope.baseBean.engNo_R;
                var vhlFrm=$rootScope.baseBean.twoFrameNo_R;

                if(engNo && vhlFrm){
                    var isReach = vhlFrm.indexOf("I") +vhlFrm.indexOf("O") + vhlFrm.indexOf("Q");
                    if(reg.test(vhlFrm)){
                        if (isReach > -3) { //车架号 不包含 I O Q
                            $scope.showMsg=false;
                            $scope.msgText='车架号有误，请重新输入';
                        }else{
                            $rootScope.carBeans.vehicle.engineNo=engNo;
                            $rootScope.carBeans.vehicle.frameNo=vhlFrm;
                            $rootScope.reCalPremiumFlag=true;
                            $scope.calAmount();
                            $rootScope.baseBean.isTwoNum = true;
                            $scope.CAR_CONFITM_FLAG = false;
                        }
                    }else{
                        $scope.showMsg=false;
                        $scope.msgText='车架号有误，请重新输入';
                    }
                }else{
                    $scope.showMsg=false;
                    $scope.msgText='车架号/发动机号输入不能为空';
                }
            };

            //费用补偿险选择后
            $scope.costChoHandle = function (val) {
                var _cost_val = val.split(' ');
                //临时展示使用scope
                $rootScope.baseBean.syRiskList[10].quantity = _cost_val[0];
                $rootScope.baseBean.syRiskList[10].unitInsured = _cost_val[1];
                $scope.$apply();
            };

            //选择车型编码
            $scope.checkCarModel = function (evt, VHL) {
                $scope.evt = evt || null;
                $scope.VHL = VHL || null;
            };


            //选择确定选择
            $scope.reSearchCar = function() {
                if( $scope.vehicleTypeFlag){
                    if($carBeansService[$scope.vehicleTypeFlag]=='001'){//货车
                        $rootScope.carBeans.vehicle.carKindCode='200';
                    }else if($carBeansService[$scope.vehicleTypeFlag]=='003'){ //客车
                        $rootScope.carBeans.vehicle.carKindCode='100';
                        $rootScope.baseBean.syRiskList[11].checked=false;
                    }
                }else{
                    $rootScope.carBeans.vehicle.carKindCode='';
                }

                //调用折旧方法
                $handleService.saveTmp(function(){
                    $scope.isSelectCar = false;
                    //传参为1 时，则表示，不是初始化页面调用折旧方法
                    Handle.depreciateValue(1);
                });
                Handle.checkCarModelFunc($scope.evt, $scope.VHL);//0813
                history.back(-1);//0813返回车辆信息页

            };
            //保费计算方法
            $scope.calAmount = function (opts) {
                //勾选的险别保额为0时，给出对应险别保额不能为0提示
                var flagg = 1;
                var syRiskNameList = ['车辆损失险','商业第三者责任险','全车盗抢险','车上人员责任险（司机）','乘客座位险(4座)','玻璃单独破碎险','自燃损失险','','车身划痕损失险',
                    '发动机涉水损失险','修理期间费用补偿险','车上货物责任险','精神损害抚慰金责任险','无法找到第三方责任险','指定修理厂特约险','三者假日翻倍险','机动车损失保险','车轮损坏除外险'
                ];
                var items =  $rootScope.baseBean.syRiskList;
                // console.log($rootScope.baseBean.syRiskList,'$rootScope.baseBean.syRiskList');
                for(var index =0;index< items.length;index++){
                    var item = items[index];
                    if( ( index==0 || index==1 || index==2 || index==6 || index==8 || index==11 || index==12 || index==15 || index==16) && item.checked && (item.sumInsured == 0|| item.sumInsured == null || item.sumInsured == '') ){
                        $handleService.showAlert('温馨提示',"你选择的“"+syRiskNameList[index]+"”保额为零，报价失败，请检查并修改后重新报价");
                        flagg = 0;
                        break ;
                    }
                    if( ( index==3|| index==4 ) && item.checked && (item.unitInsured==0 || item.unitInsured==null ||item.unitInsured=='') ){
                        $handleService.showAlert('温馨提示',"你选择的“"+syRiskNameList[index]+"”保额为零，报价失败，请检查并修改后重新报价");
                        flagg = 0;
                        break ;
                    }
                    if( index==10 && item.checked && (item.quantity == 0 ||item.quantity == null||item.quantity == ''|| item.unitInsured == 0||item.unitInsured == null||item.unitInsured == '') ){
                        $handleService.showAlert('温馨提示',"你选择的“"+syRiskNameList[index]+"”保额为零，报价失败，请检查并修改后重新报价");
                        flagg = 0;
                        break ;
                    }

                    if(index==14  && item.checked && (item.rate == 0|| item.rate == null || item.rate == '') ){
                        $handleService.showAlert('温馨提示',"你选择的“"+syRiskNameList[index]+"”保额为零，报价失败，请检查并修改后重新报价");
                        flagg = 0;
                        break ;
                    }
                }
                if(!flagg){
                    return ;
                }
                var opts = opts || {};
                if(opts.quotationWay == '1' && $scope.feeDiscount.allowFlag =='1' && $scope.feeDiscount.allowFlagBoolean && $scope.feeDiscount.allowReason == ''){
                    //费折联动报价 &&  勾选通融理由  &&  通融理由
                    $U.showToast('通融理由不能为空');
                    return;
                }
                //河北车船税解缴改革,没有开关删除多于关联字段
                if(!$rootScope.switchBean.driLicenseSwitch){
                    delete $rootScope.carBeans.owner.provinceCode
                    delete $rootScope.carBeans.owner.provinceName
                    delete $rootScope.carBeans.owner.cityCode
                    delete $rootScope.carBeans.owner.cityName
                    delete $rootScope.carBeans.owner.areaCode
                    delete $rootScope.carBeans.owner.areaName
                }
                var del= $.Deferred();
                var delay=function (del) {
                    //投保时长
                    HandleService.operateTime({
                        operatId: "03",
                        sure:function () {
                            del.resolve();
                        }
                    });
                    return del;
                };

                var dtd = $.Deferred();
                var wait = function(dtd){
                    if(opts.quotationWay != '1' && $scope.feeDiscount.quotationWayFinal == '1' && !$rootScope.reCalPremiumFlag){ // 本次是常规报价  上次是费折联动报价  且没投保方案未做任何更改
                        $handleService.showConfirm({
                            title: '温馨提示',
                            cssClass: 'discount-confirm',
                            template: '计算保费将导致承保方案失效,是否确定计算?',
                            sure: function(){
                                $scope.feeDiscount.quotationWayFinal = '0'; //此处人为改动上次报价为常规报价  为了不冒泡提示  不影响其他逻辑
                                dtd.resolve();
                            }
                        });
                    }else{
                        dtd.resolve();
                    }
                    return dtd;
                };
                var dts = $.Deferred();
                var tasks=function (dts) {
                    var num=$rootScope.baseBean.syRiskList.length;
                    if($rootScope.carBeans.vehicle.seatCount==0){
                        angular.forEach($rootScope.baseBean.syRiskList,function (item) {
                            if((item.kindCode=='030104' && item.checked) || (item.kindCode=='030105' && item.checked)){
                                $U.showToast('座位数为零不能投保车上人员责任保险（司机和乘客）！');
                                num--;
                                return;
                            }
                        });
                    }
                    window.setTimeout(function () {
                        if(num==$rootScope.baseBean.syRiskList.length){
                            dts.resolve();
                        }else{
                            dts.reject();
                        }
                    }, 0);
                    return dts;
                };

                $.when(delay(del),wait(dtd),tasks(dts))
                    .done(function(){
                        /*<!--商业险  座位大于9 100为客车 02非营运-->*/
                        if($rootScope.baseBean.isBasic == '1' && ($rootScope.carBeans.vehicle.seatCount>9 || $rootScope.carBeans.base.busiAttrConfig.useNatures!='02'||$rootScope.carBeans.vehicle.carKindCode!='100' || $rootScope.carBeans.base.busiAttrConfig.attachNatures != '01')){
                            $rootScope.baseBean.isBasic = '0';
                            $U.showToast('仅限10座以下家庭自用客车投保');
                            return;
                        }

                        //车上货物责任险验证
                        if($rootScope.baseBean.syRiskList[11].checked){
                            if($rootScope.baseBean.syRiskList[11].sumInsured>1000000||$rootScope.baseBean.syRiskList[11].sumInsured<=0){
                                $rootScope.baseBean.syRiskList[11].sumInsured='';
                                $U.showToast('车上货物责任险保额范围：0~1,000,000');
                                return;
                            }else{
                                $rootScope.baseBean.syRiskList[11].sumInsured=Number($rootScope.baseBean.syRiskList[11].sumInsured.toString().match(/^\d+(?:\.\d{0,2})?/))
                            }
                        }
                        //封装交强险和商业险传值
                        var riskList =  Handle.encapRisk(opts);
                        console.log(riskList,'封装交强险和商业险传值-------------');
                        //封装非车险的时间和关联车险code
                        angular.forEach($rootScope.nocarArr,function(item){
                            if($rootScope.baseBean.syOrigFlag){
                                item.startDate = $rootScope.baseBean.syInsureStartTime;
                                item.carRiskCode = '0302';
                            }else{
                                item.startDate = $rootScope.baseBean.jqInsureStartTime;
                                item.carRiskCode = '0301';
                            }
                                
                        })
                        if($rootScope.switchBean.noCarPrdSwitch){ // 非车险
                            $rootScope.carBeans.noCarProductList = $rootScope.nocarArr;
                            $rootScope.carBeans.noCarRiskList = [];
                        }else{
                            $rootScope.carBeans.noCarProductList = [];
                            $rootScope.carBeans.noCarRiskList = $rootScope.nocarArr;
                        }

                        // console.log($rootScope.carBeans,'$rootScope.carBeans$rootScope.carBeans')
                        var _CAR_BEANS = angular.copy($rootScope.carBeans);
                        // console.log(_CAR_BEANS,'$rootScope.carBeans$rootScope.carBeans')
                        // console.log($rootScope.carBeans,'$rootScope.carBeans$rootScope.carBeans')
                        _CAR_BEANS.riskList = riskList;
                        // console.log(_CAR_BEANS.riskList,'riskList');
                        // console.log($rootScope.carBeans,'$rootScope.carBeans$rootScope.carBeans---------修改')
                        $rootScope.quoteRistList = riskList; // 保存报价的险种信息
                        // console.log($rootScope.quoteRistList,'保存报价的险种信息')
                        //人人团字段特殊处理
                        if(window.requestParam.webSources == "QMYX") {
                            if(window.requestParam.issueCode) { //出单员
                                _CAR_BEANS.peopleMarket.issueCode = window.requestParam.issueCode;
                            }
                            //人人团有客户源时 增加客户源字段
                            if(window.requestParam.cooperateCode) {
                                _CAR_BEANS.peopleMarket.cooperateCode = window.requestParam.cooperateCode;
                            }

                            if(window.requestParam.outUserId) {
                                _CAR_BEANS.peopleMarket.outUserId = window.requestParam.outUserId;
                            }
                            if(window.requestParam.outDf) {
                                _CAR_BEANS.peopleMarket.outDf = window.requestParam.outDf;
                            }
                            if(window.requestParam.refereeId) {
                                _CAR_BEANS.peopleMarket.refereeId = window.requestParam.refereeId;
                            }
                            //TerminalSource处理 jxx
                            window.requestParam.terminalSource ? _CAR_BEANS.base.terminalSource = window.requestParam.terminalSource : '';
                        }

                        //商业险选中之后，险种不能为空
                        if( riskList[0].coverageList.length == 0) {
                            $U.showToast("请至少选择一种商业险险种");
                            return false;
                        }


                        //判断费折联动报价
                        if(opts && opts.quotationWay == '1'){ // 费折联动报价
                            _CAR_BEANS.base.quotationWay = '1';
                        }else{ // 常规报价
                            _CAR_BEANS.base.quotationWay = '0';
                        }

                        if($rootScope.carBeans.base.frmNoFlag){ // 从暂存单带过来的frmNoFlag
                            _CAR_BEANS.base.frmNoFlag = $rootScope.carBeans.base.frmNoFlag; 
                            if($rootScope.isNewCarFlag ){// 新车 
                                // 只能用暂存单2号报价   
                                _CAR_BEANS.vehicle.engineNo = $rootScope.tempEngineNo;
                                _CAR_BEANS.vehicle.frameNo = $rootScope.tempFrameNo;                                        
                            }
                        }else{// 新单 or 暂存frmNoFlag为空
                            if($rootScope.isNewCarFlag ){
                                _CAR_BEANS.base.frmNoFlag = $rootScope.carBeans.base.frmNoFlag = '1'; //新车假两号                                 
                                // 只能用暂存单2号报价 或者  ""     
                                _CAR_BEANS.vehicle.engineNo = $rootScope.tempEngineNo || '';   
                                _CAR_BEANS.vehicle.frameNo = $rootScope.tempFrameNo || '';             
                            }else{
                                _CAR_BEANS.base.frmNoFlag = $rootScope.carBeans.base.frmNoFlag = '2'; //真两号
                            }
                        }
                        //电子保单标志更改
                        if($rootScope.carBeans.base.busiAttrConfig.policyStyles == '1'){
                            _CAR_BEANS.riskList[0].electronicInd = '1';
                            _CAR_BEANS.riskList[1]?_CAR_BEANS.riskList[1].electronicInd = '1':'';
                        }else{
                            _CAR_BEANS.riskList[0].electronicInd = '0';
                            _CAR_BEANS.riskList[1]?_CAR_BEANS.riskList[1].electronicInd = '0':'';
                        }
                        //校验开票银行名称和开户行账号 不符合正则清空传空报价
                        /^\d{6,30}$/.test(_CAR_BEANS.applicant.account) ? '': _CAR_BEANS.applicant.account = '';
                        /^\d{6,30}$/.test(_CAR_BEANS.insured.account) ? '': _CAR_BEANS.insured.account = '';
                        /^[\u4E00-\u9FA5A-Za-z()（）]+$/.test(_CAR_BEANS.applicant.openBank) ? '':_CAR_BEANS.applicant.openBank = '';
                        /^[\u4E00-\u9FA5A-Za-z()（）]+$/.test(_CAR_BEANS.insured.openBank) ? '':_CAR_BEANS.insured.openBank = '';
                        // 0716选择否时,adviceSumDiscount不传给核心,暂时都不传
                        // if($scope.feeDiscount.showFzldDialog && !$scope.feeDiscount.allowFlagBoolean) {
                            _CAR_BEANS.riskList[0].adviceSumDiscount = "";
                        // };
                        // console.log(_CAR_BEANS,'_CAR_BEANS')
                        // 保存起来,新车免两号需重新报价时使用
                        $rootScope.subObj = JSON.parse(JSON.stringify(_CAR_BEANS));//缓存投被保人信息
                        $rootScope.carBeans = $rootScope._CAR_BEANS =_CAR_BEANS;
                        $handleService.logger('object',_CAR_BEANS, '保费计算请求参数');
                        //2.提交数据到后台服务
                        $handleService.http({
                            url: "/quote?flowId=" + $rootScope.flowId,
                            data: _CAR_BEANS,
                            success: function (data) {
                                $handleService.logger('object', data, '保费计算请求结果');
                                $rootScope.calPremiumResult = $scope.calPremiumResult = {}; //转保答案缓存问题解决
                                $scope.feeDiscount.showFzldDialog = false;  // 费折联动关闭
                                $scope.verCodeShowFlag = false;
                                // 0716标志计算
                                
                                 //特约数据
                                if($U.isNotEmpty(data.result)&&$U.isNotEmpty(data.result.policyInfo)&&$U.isNotEmpty(data.result.policyInfo.vehicle)){
                                    $rootScope.riskGrade = data.result.policyInfo.vehicle.riskGrade||'';
                                }
                                //特约数据
                                if($U.isNotEmpty(data.result)&&$U.isNotEmpty(data.result.policyInfo)&&$U.isNotEmpty(data.result.policyInfo.clauseVOList)){
                                    
                                    $rootScope.baseBean.specialData=data.result.policyInfo.clauseVOList;
                                    angular.forEach($rootScope.baseBean.specialData,function (item) {
                                        if(item.isNeeded=='1'){
                                            item.checked=true;
                                        }else{
                                            item.checked=false;
                                        }
                                        if(item.clauseCode == 'HA0005N') {
                                            //fix HA0005N特约多一个参数问题
                                            item.clauseParamList.forEach(function(a,b){
                                                if(a.key && a.key == '#HA0005N_year#'){
                                                    item.clauseParamList.splice(b,1);
                                                }
                                            })
                                            item.parameterList.forEach(function(a,b){
                                                if(a.HA0005N_year && a.HA0005N_year == '年'){
                                                    item.parameterList.splice(b,1);
                                                }
                                            })
                                            // item.clauseParamList = item.clauseParamList.splice(1);
                                            // item.parameterList = item.parameterList.splice(1);
                                        }
                                    });
                                }
                                //如果有在提核页面修改过特约内容，则优先读取为历史记录
                                // debugger
                                if($rootScope.prePage == 'INDEX' || $U.isNotEmpty($rootScope.baseBean.tempChooseData)) {
                                    $rootScope.historyTy = [];//清空返回历史的记录,新保不需要历史记录
                                }
                                if($U.isNotEmpty($rootScope.baseBean.tempChooseData)){
                                    $scope.clauseListTemp = $rootScope.baseBean.tempChooseData;
                                    console.log('有在提核页面修改过特约内容',$scope.clauseListTemp);
                                } else {
                                    //否则，再判断是否有接口返回历史的记录
                                    if ($U.isNotEmpty($rootScope.historyTy)) {
                                        var arr = [];
                                        angular.forEach($rootScope.historyTy, function (item) {
                                            if (item.isNeeded === '1' && item.isModify === '0') {
                                                //必传不可改特约,不取
                                            } else {
                                                //选中
                                                item['checked'] = true;
                                                arr.push(item);
                                            }
                                        })
                                        // 赋值到暂存数据
                                        $scope.clauseListTemp = arr;
                                        $rootScope.baseBean.tempChooseData = [];//置空
                                        console.log('接口返回历史的特约内容',$scope.clauseListTemp);
                                    } else {
                                        console.log('接口没有返回历史的特约内容！！！',$scope.clauseListTemp);
                                    }
                                }
                                
                                $rootScope.copyOriginSpecialData = angular.copy($rootScope.baseBean.specialData);//备份原始特约
                                //0813特约信息保存，组合自定义修改过的数据和核心返回的数据-start
                                if ($U.isNotEmpty($rootScope.baseBean.specialData) && $U.isNotEmpty($scope.clauseListTemp)) {
                                    $handleService.logger("object", $rootScope.baseBean.specialData, "获取特约核心返回数据");
                                    $handleService.logger("object", $scope.clauseListTemp, "获取特约修改返回数据");
                                    angular.forEach($rootScope.baseBean.specialData, function (specialDataItem) {
                                        //可改
                                        /** 要保存，如果报价后核心有返回该特约，特约内容取保存的，提核页面默认展示该特约，如果报价后核心没有返回该特约，则清空该特约 */
                                        angular.forEach($scope.clauseListTemp, function (clauseListItem) {
                                            /*  ---  Subsection comment block  ---  */
                                            //1. 必填不可改特约,不需要保存，特约内容去核心返回的 
                                            if (specialDataItem.isNeeded === '1' && specialDataItem.isModify === '0') {
                                                // 不需要保存，特约内容取核心返回的 
                                            } else {
                                                if (clauseListItem.riskCode === specialDataItem.riskCode && clauseListItem.clauseCode === specialDataItem.clauseCode && clauseListItem.checked) {
                                                    //fix 没有文本模板问题
                                                    clauseListItem.remark = specialDataItem.remark;
                                                    clauseListItem['subClauseContext'] = clauseListItem.clauseContext;

                                                    angular.extend(specialDataItem, clauseListItem);
                                                    // console.log('要保存');
                                                }
                                            }
                                            /*  ---  Subsection comment block  ---  */
                                        })
                                        /*  ---  Subsection comment block  ---  */
                                    })
                                    console.log('specialData:', $rootScope.baseBean.specialData);
                                }
                                $rootScope.copySpecialData = angular.copy($rootScope.baseBean.specialData);//备份特约
                                //0813特约信息保存，组合自定义修改过的数据和核心返回的数据-end
                               
                                //处理保费试算
                                if(data.resultCode == "0" || data.resultCode == "E00005") { // E00005  手续费超限额
                                    if(data.resultCode == "E00005"){
                                        $U.showToast("手续费已超限，请联系分公司车险部沟通确认！");
                                    }
                                    $rootScope.riskListMore=data.result.policyInfo.riskList;
                                    $rootScope.accidentList = data.result.policyInfo.accidentList||[]; //理赔信息
                                    $rootScope.jqViolationList = data.result.policyInfo.violationList||[]; //违法信息
                                    //评分信息
                                    if(data.result.policyInfo.riskList[0]&&data.result.policyInfo.riskList[0].precisionScoreList){
                                        $rootScope.precisionScoreList = data.result.policyInfo.riskList[0].precisionScoreList; //评分信息
                                    }else if(data.result.policyInfo.riskList[1]&&data.result.policyInfo.riskList[1].precisionScoreList){
                                        $rootScope.precisionScoreList = data.result.policyInfo.riskList[1].precisionScoreList; //评分信息
                                    }else{
                                        $rootScope.precisionScoreList = [];
                                    }
                                    $scope.calResultData = data.result.policyInfo;
                                    $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = true;
                                    // 报价之后允许 编辑折扣系数
                                    if($scope.pageCode=='PQUERY'||$scope.pageCode=='DRAFTS' ||$rootScope.newPolicyShow){
                                        $scope.isDiscountNoEdit = false; //允许编辑
                                    }
                                    // 新保报价 返回修改需显示 折扣系数
                                    $rootScope.newPolicyShow = true;
                                    Handle.setPremium(data.result.policyInfo.riskList);//resultCode == "0"  resultCode == "E00005"
                                    Handle.setFeeDiscount({
                                        riskList: data.result.policyInfo.riskList,
                                        base: data.result.policyInfo.base,
                                        quotationWay: opts.quotationWay || '0'
                                    });

                                    //车船税回填
                                    angular.forEach(data.result.policyInfo.riskList,function (item) {
                                        if(item.riskCode == "0301"){
                                            for(var name in item.vhlTax){
                                                if($rootScope.baseBean.jqRiskList.vhlTax.hasOwnProperty(name)){
                                                    $rootScope.baseBean.jqRiskList.vhlTax[name]=item.vhlTax[name];
                                                }
                                            }
                                        }
                                    });

                                    $timeout(function () {
                                        $rootScope.reCalPremiumFlag = false;
                                    },0);


                                } else if(data.resultCode == "3") { //转保
                                    //处理转保验证码
                                    $scope.verCodeObj = {};
                                    angular.forEach(data.result.policyInfo.riskList, function(item) {
                                        if(item.checkQuestion) { //存在验证码
                                            $scope.verCodeShowFlag = true;
                                            if(item.riskCode == "0301") {
                                                $scope.verCodeTarget = "JQ";
                                                $scope.verCodeObj.jq = {};
                                                $scope.verCodeObj.jq.checkQuestion = 'data:image/png;base64,' + item.checkQuestion;
                                            }
                                            if(item.riskCode == "0302") {
                                                $scope.verCodeTarget = "SY";
                                                $scope.verCodeObj.sy = {};
                                                $scope.verCodeObj.sy.checkQuestion = 'data:image/png;base64,' + item.checkQuestion;
                                            }
                                        }
                                        if(item.riskCode == "0302") {
                                            //存储商业险信息
                                            $scope.calPremiumResult.syCalData = item;
                                        } else if(item.riskCode == "0301") {
                                            //存储交强险信息
                                            $scope.calPremiumResult.jqCalData = item;
                                        }
                                    });
                                } else if(data.resultCode == "E21001") {//重复投保
                                    var reInsureList = data.result.policyInfo.reInsureList || [];
                                    $rootScope.accidentList = data.result.policyInfo.accidentList||[]; //理赔信息
                                    $scope.calResultData = data.result.policyInfo;  //保费试算结果

                                    //单交强
                                    if(data.result.policyInfo.reInsureList.length == 1 && data.result.policyInfo.reInsureList[0].kindCode=='0301'){
                                        //单交强险重复投保不可计算保费
                                        var startDate = $rootScope.baseBean.jqInsureStartTime;
                                        var expireDate = reInsureList[0].expireDate;//上年止期
                                        if(expireDate){
                                            startDate = Handle.translateTimeDate(startDate,false);
                                            expireDate =Handle.translateTimeDate(expireDate,false);
                                            var differday = $U.daysBetween(expireDate,startDate);
                                            if(differday>0){//上年保险止期 大于本次投保保险起期 不允许下一步  提示重复投保
                                                $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = false; //保费试算成功标志
                                                $rootScope.reCalPremiumFlag = true; //重新计算标志
                                                $rootScope.renisure = data.result.policyInfo.reInsureList;
                                                $rootScope.calResultData4repeatInsure = data.result.policyInfo;
                                                $state.go("tab.repeatInsure");
                                            }else{//脱保时 上年止期小于本次投保起期
                                                $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = true;
                                                // 报价之后允许 编辑折扣系数
                                                if($scope.pageCode=='PQUERY'||$scope.pageCode=='DRAFTS' ||$rootScope.newPolicyShow){
                                                    $scope.isDiscountNoEdit = false; //允许编辑
                                                }
                                                // 新保报价 返回修改需显示 折扣系数
                                                $rootScope.newPolicyShow = true;
                                                $rootScope.reCalPremiumFlag = false;
                                                Handle.setPremium(data.result.policyInfo.riskList);
                                                Handle.setFeeDiscount({
                                                    riskList: data.result.policyInfo.riskList,
                                                    base: data.result.policyInfo.base,
                                                    quotationWay: opts.quotationWay || '0',
                                                });
                                                if(data.errorMsg) {//有错误信息时
                                                    $handleService.showAlert('提示', data.errorMsg);
                                                }
                                            }
                                        }else{
                                            $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = false; //保费试算成功标志
                                            $rootScope.reCalPremiumFlag = true; //重新计算标志
                                            $rootScope.renisure = data.result.policyInfo.reInsureList;
                                            $rootScope.calResultData4repeatInsure = data.result.policyInfo;
                                            $state.go("tab.repeatInsure");
                                        }
                                    }
                                    //单商业
                                    else if(data.result.policyInfo.reInsureList.length == 1 && data.result.policyInfo.reInsureList[0].kindCode=='0302'){
                                       //单商业允许重复投保 无论返回上年止期是不是大于本次投保起期都可以到下一步  并铁跳到重复投保详细展示页面
                                        var startDate = $rootScope.baseBean.syInsureStartTime;
                                        var expireDate = reInsureList[0].expireDate;//上年止期
                                        if(expireDate){
                                            startDate = Handle.translateTimeDate(startDate,false);
                                            expireDate =Handle.translateTimeDate(expireDate,false);
                                            var differday = $U.daysBetween(expireDate,startDate);
                                            if(differday>0){//上年保险止期 大于本次投保保险起期 可以进去下一步 跳到重复投保页面
                                                $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = true;
                                                // 报价之后允许 编辑折扣系数
                                                if($scope.pageCode=='PQUERY'||$scope.pageCode=='DRAFTS' ||$rootScope.newPolicyShow){
                                                    $scope.isDiscountNoEdit = false; //允许编辑
                                                }
                                                // 新保报价 返回修改需显示 折扣系数
                                                $rootScope.newPolicyShow = true;
                                                $rootScope.reCalPremiumFlag = false;
                                                Handle.setPremium(data.result.policyInfo.riskList);
                                                Handle.setFeeDiscount({
                                                    riskList: data.result.policyInfo.riskList,
                                                    base: data.result.policyInfo.base,
                                                    quotationWay: opts.quotationWay || '0',
                                                });
                                                $rootScope.renisure = data.result.policyInfo.reInsureList;
                                                $rootScope.calResultData4repeatInsure = data.result.policyInfo;
                                                $state.go("tab.repeatInsure");
                                            }else{ //脱保时 上年止期小于本次投保起期
                                                $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = true;
                                                // 报价之后允许 编辑折扣系数
                                                if($scope.pageCode=='PQUERY'||$scope.pageCode=='DRAFTS' ||$rootScope.newPolicyShow){
                                                    $scope.isDiscountNoEdit = false; //允许编辑
                                                }
                                                // 新保报价 返回修改需显示 折扣系数
                                                $rootScope.newPolicyShow = true;
                                                $rootScope.reCalPremiumFlag = false;
                                                Handle.setPremium(data.result.policyInfo.riskList);
                                                Handle.setFeeDiscount({
                                                    riskList: data.result.policyInfo.riskList,
                                                    base: data.result.policyInfo.base,
                                                    quotationWay: opts.quotationWay || '0',
                                                });
                                            }
                                        }else{  // 没时间  算重复投保
                                            $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = true; //保费试算成功标志
                                            // 报价之后允许 编辑折扣系数
                                            if($scope.pageCode=='PQUERY'||$scope.pageCode=='DRAFTS' ||$rootScope.newPolicyShow){
                                                $scope.isDiscountNoEdit = false; //允许编辑
                                            }
                                            // 新保报价 返回修改需显示 折扣系数
                                            $rootScope.newPolicyShow = true;
                                            $rootScope.reCalPremiumFlag = false; //重新计算标志
                                            Handle.setPremium(data.result.policyInfo.riskList);
                                            Handle.setFeeDiscount({
                                                riskList: data.result.policyInfo.riskList,
                                                base: data.result.policyInfo.base,
                                                quotationWay: opts.quotationWay || '0',
                                            });
                                            if(data.errorMsg) {//有错误信息时
                                                $handleService.showAlert('提示', data.errorMsg);
                                            }
                                        }
                                    }
                                    //交商同保
                                    else if(data.result.policyInfo.reInsureList.length == 2){
                                        //交商同保重复投保不可计算保费
                                        var startDate = $rootScope.baseBean.jqInsureStartTime;
                                        var startDate0301 = $rootScope.baseBean.jqInsureStartTime;
                                        var startDate0302 = $rootScope.baseBean.syInsureStartTime;
                                        var expireDate0301='' ,expireDate0302='';
                                        var differday0301='',differday0302='';
                                        angular.forEach(data.result.policyInfo.reInsureList,function (item) {
                                            if(item.kindCode=='0301'){
                                                expireDate0301 =  item.expireDate;
                                                if(expireDate0301){//如果有止期
                                                    startDate0301 = Handle.translateTimeDate(startDate0301,false);
                                                    expireDate0301 =Handle.translateTimeDate(expireDate0301,false);
                                                    differday0301 = $U.daysBetween(expireDate0301,startDate0301);
                                                }
                                            }
                                            if(item.kindCode=='0302'){
                                                expireDate0302 =  item.expireDate;
                                                if(expireDate0302){//如果有止期
                                                    startDate0302 = Handle.translateTimeDate(startDate0302,false);
                                                    expireDate0302 =Handle.translateTimeDate(expireDate0302,false);
                                                    differday0302 = $U.daysBetween(expireDate0302,startDate0302);
                                                }
                                            }

                                        });
                                        if(!expireDate0301 || differday0301>0){ // 交强险 重复投保
                                            $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = false;
                                            $rootScope.reCalPremiumFlag = true;
                                            $rootScope.renisure = data.result.policyInfo.reInsureList;
                                            $rootScope.calResultData4repeatInsure = data.result.policyInfo;
                                            $state.go("tab.repeatInsure");
                                        }else{ // 交强险脱保  ---   只看商业险
                                            if(expireDate0302){
                                                if(differday0302>0){//上年保险止期 大于本次投保保险起期 可以进去下一步 跳到重复投保页面
                                                    $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = true;
                                                    // 报价之后允许 编辑折扣系数
                                                    if($scope.pageCode=='PQUERY'||$scope.pageCode=='DRAFTS' ||$rootScope.newPolicyShow){
                                                        $scope.isDiscountNoEdit = false; //允许编辑
                                                    }
                                                    // 新保报价 返回修改需显示 折扣系数
                                                    $rootScope.newPolicyShow = true;
                                                    $rootScope.reCalPremiumFlag = false;
                                                    Handle.setPremium(data.result.policyInfo.riskList);
                                                    Handle.setFeeDiscount({
                                                        riskList: data.result.policyInfo.riskList,
                                                        base: data.result.policyInfo.base,
                                                        quotationWay: opts.quotationWay || '0',
                                                    });
                                                    $rootScope.renisure = data.result.policyInfo.reInsureList;
                                                    $rootScope.calResultData4repeatInsure = data.result.policyInfo;
                                                    $state.go("tab.repeatInsure");
                                                }else{ //脱保时 上年止期小于本次投保起期
                                                    $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = true;
                                                    // 报价之后允许 编辑折扣系数
                                                    if($scope.pageCode=='PQUERY'||$scope.pageCode=='DRAFTS' ||$rootScope.newPolicyShow){
                                                        $scope.isDiscountNoEdit = false; //允许编辑
                                                    }
                                                    // 新保报价 返回修改需显示 折扣系数
                                                    $rootScope.newPolicyShow = true;
                                                    $rootScope.reCalPremiumFlag = false;
                                                    Handle.setPremium(data.result.policyInfo.riskList);
                                                    Handle.setFeeDiscount({
                                                        riskList: data.result.policyInfo.riskList,
                                                        base: data.result.policyInfo.base,
                                                        quotationWay: opts.quotationWay || '0',
                                                    });
                                                }
                                            }else{  // 没时间  算重复投保
                                                $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = true; //保费试算成功标志
                                                // 报价之后允许 编辑折扣系数
                                                if($scope.pageCode=='PQUERY'||$scope.pageCode=='DRAFTS' ||$rootScope.newPolicyShow){
                                                    $scope.isDiscountNoEdit = false; //允许编辑
                                                }
                                                // 新保报价 返回修改需显示 折扣系数
                                                $rootScope.newPolicyShow = true;
                                                $rootScope.reCalPremiumFlag = false; //重新计算标志
                                                Handle.setPremium(data.result.policyInfo.riskList);
                                                Handle.setFeeDiscount({
                                                    riskList: data.result.policyInfo.riskList,
                                                    base: data.result.policyInfo.base,
                                                    quotationWay: opts.quotationWay || '0',
                                                });
                                                if(data.errorMsg) {//有错误信息时
                                                    $handleService.showAlert('提示', data.errorMsg);
                                                }
                                            }
                                        }
                                    }
                                    else{
                                        $scope.hasCalPremiunFlag = $rootScope.hasCalPremiunFlag = true;
                                        // 报价之后允许 编辑折扣系数
                                        if($scope.pageCode=='PQUERY'||$scope.pageCode=='DRAFTS' ||$rootScope.newPolicyShow){
                                            $scope.isDiscountNoEdit = false; //允许编辑
                                        }
                                        // 新保报价 返回修改需显示 折扣系数
                                        $rootScope.newPolicyShow = true;
                                        $rootScope.reCalPremiumFlag = false;
                                        Handle.setPremium(data.result.policyInfo.riskList);
                                        Handle.setFeeDiscount({
                                            riskList: data.result.policyInfo.riskList,
                                            base: data.result.policyInfo.base,
                                            quotationWay: opts.quotationWay || '0',
                                        });
                                    }
                                } else if(data.resultCode == "E11012"){  //行业车型不一致
                                    if($U.isNotEmpty(data.result.policyInfo.carModelList)) {
                                        $scope.isSelectCar = true;
                                        $scope.VHL_LIST = data.result.policyInfo.carModelList;
                                    }
                                }else if(data.resultCode == "E00004"){
                                    //车船税回填
                                    angular.forEach(data.result.policyInfo.riskList,function (item) {
                                        if(item.riskCode == "0301"){
                                            for(var name in item.vhlTax){
                                                if($rootScope.baseBean.jqRiskList.vhlTax[name]){
                                                    $rootScope.baseBean.jqRiskList.vhlTax[name]=item.vhlTax[name];
                                                }
                                            }
                                        }
                                    });
                                    switch($rootScope.baseBean.jqRiskList.vhlTax.taxRelifFlag){
                                        case '01': $scope.jqTaxType = '拒缴';break;
                                        case '02': $scope.jqTaxType = '纳税';break;
                                        case '03': $scope.jqTaxType = '完税';break;
                                        case '04': $scope.jqTaxType = '减税';break;
                                        case '05': $scope.jqTaxType = '免税';break;
                                        case '06': $scope.jqTaxType = '补税并纳税';break;
                                    }
                                    $handleService.showAlert('提示',"平台返回纳税类型:" + $scope.jqTaxType + "，请返回车辆信息页面核实车船税信息！");
                                }else if(data.resultCode == "E00006"){  //保费小于0，不允许下一步管控
                                    $scope.noNext=true;
                                    $handleService.showAlert('提示',data.errorMsg);
                                }else if(data.resultCode == "E10001"){
                                    $handleService.showAlert('温馨提示',data.errorMsg, function () {
                                        if(!window.requestParam.webSources){
                                            // //判断新首页可见性
                                            // if($rootScope.isNewHome){
                                            //     $state.go("tab.mitNewIndex");
                                            // }else{
                                            //     $state.go("tab.mitIndex");
                                            // }
                                            $state.go("tab.mitNewIndex");
                                        }
                                    });
                                }else if(data.resultCode == "E11091" && !data.errorMsg){
                                    $handleService.showAlert('温馨提示',"报价失败，请稍后再试！");
                                } else {
                                    $handleService.showAlert('提示',data.errorMsg);
                                }

                            },
                            error: function (ex) {
                                $handleService.logger('error', ex);
                            }
                        });
                    });
            };

            //验证码
            $scope.checkVerCode = function() {

                if($scope.verCodeTarget == "SY") { //商业险
                    if($scope.verCodeObj.jq && $scope.verCodeObj.jq.checkQuestion && !$rootScope.baseBean.jqAnswer) { //交强险验证码未输入
                        $scope.verCodeTarget = "JQ";
                    } else {
                        $scope.calAmount();
                    }
                }else if($scope.verCodeTarget == "JQ") {
                    if($scope.verCodeObj.sy && $scope.verCodeObj.sy.checkQuestion && !$rootScope.baseBean.syAnswer) { //商业险验证码未输入
                        $scope.verCodeTarget = "SY";
                    } else {
                        $scope.calAmount();
                    }
                }
            };

            $scope.cancelVerCode = function() {
                $scope.verCodeObj = {};
                $scope.verCodeShowFlag = false;
            };

            $scope.goRepeatInsure = function() {
                $state.go("tab.repeatInsure");
            };

            //提交订单方法
            $scope.checkHandle = function () {
                if(!$rootScope.baseBean.isTwoNum && $rootScope.baseBean.is_twoNumber_success) {
                    $scope.CAR_CONFITM_FLAG = true;
                } else {
                    $location.path("tab/owConfirm");
                }



                //保存草稿到本地
                // $rootScope.saveDrafts();

                //跳转到-》信息确认页面
                // $location.path("tab/owConfirm");
            };

            /***********非车**************************/
            $scope.nocarList = [];  // 可以购买的非车产品
            $rootScope.nocarArr = []; //选中的非车险
            if($rootScope.switchBean.noCarPrdSwitch){
                Handle.getNocarListNew();
            }else{
                Handle.getNocarList();
            }
            

            //跳转到非车详情
            $scope.gotoNocarDetails = function(item) {
                $rootScope.nocarDetailsItem = item;
                $state.go("tab.nocarDetails");
            }

            //选择非车险
            $scope.selectNocarType = function(data, $event) {
                var newData = angular.copy(data);
                newData.rationList = [];
                $rootScope.reCalPremiumFlag = true; //重新计算标识
                if($event.target.checked) {
                    angular.forEach(data.rationList, function(item) { //获取选中的险种类型 基本型、豪华型和至尊型
                        if(data.rationCode == item.rationCode) {
                            item.waxBatch = newData.waxBatch;
                            newData.rationList[0] = item;
                            $rootScope.nocarArr.push(newData.rationList[0]);
                        }
                    });
                } else {
                    //获取险种
                    angular.forEach($rootScope.nocarArr, function(item, index) {
                        if(data.rationCode == item.rationCode) {
                            // $rootScope.nocarArr.splice(index, index+1);
                            $rootScope.nocarArr.splice(index, 1);
                        }
                    });
                }
                // 保存操作 为了切换页面后数据还在
                if($rootScope.switchBean.noCarPrdSwitch){ // 非车险
                    $rootScope.carBeans.noCarProductList = $rootScope.nocarArr;
                    $rootScope.carBeans.noCarRiskList = [];
                }else{
                    $rootScope.carBeans.noCarProductList = [];
                    $rootScope.carBeans.noCarRiskList = $rootScope.nocarArr;
                }
            }

            /*修改非车险种份数*/
            $scope.changeBatch = function(item, flag) {
                //减
                if(flag == "sub") {
                    if(Number(item.waxBatch) > 1) {
                        item.waxBatch --;
                    } else{
                        return
                    }
                } else if(flag == "add") {
                    if(Number(item.waxBatch) < Number(item.maxBatch)) {
                        item.waxBatch ++;
                    } else {
                        $U.showToast("产品份数已达到购买上限");
                        return;
                    }
                }

                //修改已选中非车险的险种份数 需要重新计算保费
                angular.forEach($rootScope.nocarArr, function(data) {
                    if(data.rationCode == item.rationCode) {
                        data.waxBatch = data.waxBatch = item.waxBatch;
                    }
                });
                //重新显示保费
                if(item.calType == "2") { //按座位数计算保费
                    item.totalPremium = Number(item.premium) * Number($rootScope.carBeans.vehicle.seatCount) * Number(item.waxBatch);
                } else {
                    item.totalPremium = Number(item.premium) * Number(item.waxBatch);
                }
                $rootScope.reCalPremiumFlag = true; //重新计算标识
                // 保存操作 为了切换页面后数据还在
                if($rootScope.switchBean.noCarPrdSwitch){ // 非车险
                    $rootScope.carBeans.noCarProductList = $rootScope.nocarArr;
                    $rootScope.carBeans.noCarRiskList = [];
                }else{
                    $rootScope.carBeans.noCarProductList = [];
                    $rootScope.carBeans.noCarRiskList = $rootScope.nocarArr;
                }
            }

            //切换选择上年方案或者是自选方案
            $scope.selectPolicyType = function(type, event) {
                $rootScope.renewalPolicyType = type;
                $(".price-item").removeClass("active");
                $(event.target).addClass("active");
            };
            /*****************************************/

            Handle.initPage();
        });
        return app;
    });