define(['services/app.service', 'filters/app.filters', 'services/app.sqlLite.service', 'services/app.car.beans', 'directives/app.directives','modalSelect'], function () {
    'use strict';
    var app = angular.module('app.moreInformations', ['app.handle.service', 'app.filters', 'app.sqlLite.service', 'app.directives', 'app.car.beans','ionic-modal-select']);
    //展业登录控制器
    app.controller('moreInformations', function ($scope, $rootScope, $handleService, $sqlSQLiteService, $templateCache, $location, $state, $http, $compile, $interFace, $carBeansService, $stateParams, $timeout, $sce,$ionicPopover) {

        //-------------------------------------------------begin 我的业绩------------------------------------------------------------//

        $stateParams.pageFlag=='app'?$scope.isApp=true:$scope.isApp=false;
        //Web OCR 身份证图片对象
        $scope.modyImg = {
            holdingAppImg: "", //投保人 控股股东 身份证图片
            principleAppImg: "",  //投保人 负责人 身份证图片
            agentAppImg:"", //投保人 客户经办人 身份证图片
            allBenifitAppImg:"", //投保人 受益所有人 身份证图片
            holdingInsureImg: "", //被保人 控股股东 身份证图片
            principleInsureImg: "",  //被保人 负责人 身份证图片
            agentInsureImg:"", //被保人 客户经办人 身份证图片
            allBenifitInsureImg:"" //被保人 受益所有人 身份证图片
        };

        $scope.expiry = {
            holdingApp: false,
            principleApp: false,
            agentApp: false,
            allBenifitApp: false,
            holdingInsure: false,
            principleInsure: false,
            agentInsure: false,
            allBenifitInsure: false
        };

        if($rootScope.carBeans.appCustRecordInfo.controllerend == '9999-12-31'){
            $scope.expiry.holdingApp=true;
        }else{
            $scope.expiry.holdingApp=false;
        }
        if($rootScope.carBeans.appCustRecordInfo.legalend == '9999-12-31'){
            $scope.expiry.principleApp=true;
        }else{
            $scope.expiry.principleApp=false;
        }
        if($rootScope.carBeans.appCustRecordInfo.businessend == '9999-12-31'){
            $scope.expiry.agentApp=true;
        }else{
            $scope.expiry.agentApp=false;
        }
        if($rootScope.carBeans.appCustRecordInfo.beneficiaryend == '9999-12-31'){
            $scope.expiry.allBenifitApp=true;
        }else{
            $scope.expiry.allBenifitApp=false;
        }
        if($rootScope.carBeans.insCustRecordInfo.controllerend == '9999-12-31'){
            $scope.expiry.holdingInsure=true;
        }else{
            $scope.expiry.holdingInsure=false;
        }
        if($rootScope.carBeans.insCustRecordInfo.legalend == '9999-12-31'){
            $scope.expiry.principleInsure=true;
        }else{
            $scope.expiry.principleInsure=false;
        }
        if($rootScope.carBeans.insCustRecordInfo.businessend == '9999-12-31'){
            $scope.expiry.agentInsure=true;
        }else{
            $scope.expiry.agentInsure=false;
        }
        if($rootScope.carBeans.insCustRecordInfo.beneficiaryend == '9999-12-31'){
            $scope.expiry.allBenifitInsure=true;
        }else{
            $scope.expiry.allBenifitInsure=false;
        }

        $scope.$watch('expiry.holdingApp',function(val){
            if(val){
                $rootScope.carBeans.appCustRecordInfo.controllerend = '9999-12-31';
                $rootScope.carBeans.appCustRecordInfo.controllerislong = '1';
            }else{
                $rootScope.carBeans.appCustRecordInfo.controllerislong = '0';
            }
        });
        $scope.$watch('expiry.principleApp',function(val){
            if(val){
                $rootScope.carBeans.appCustRecordInfo.legalend = '9999-12-31';
                $rootScope.carBeans.appCustRecordInfo.legalislong = '1';
            }else{
                $rootScope.carBeans.appCustRecordInfo.legalislong = '0';
            }
        });
        $scope.$watch('expiry.agentApp',function(val){
            if(val){
                $rootScope.carBeans.appCustRecordInfo.businessend = '9999-12-31';
                $rootScope.carBeans.appCustRecordInfo.businessislong = '1';
            }else{
                $rootScope.carBeans.appCustRecordInfo.businessislong = '0';
            }
        });
        $scope.$watch('expiry.allBenifitApp',function(val){
            if(val){
                $rootScope.carBeans.appCustRecordInfo.beneficiaryend = '9999-12-31';
                $rootScope.carBeans.appCustRecordInfo.beneficiaryislong = '1';
            }else{
                $rootScope.carBeans.appCustRecordInfo.beneficiaryislong = '0';
            }
        });
        $scope.$watch('expiry.holdingInsure',function(val){
            if(val){
                $rootScope.carBeans.insCustRecordInfo.controllerend = '9999-12-31';
                $rootScope.carBeans.insCustRecordInfo.controllerislong = '1';
            }else{
                $rootScope.carBeans.insCustRecordInfo.controllerislong = '0';
            }
        });
        $scope.$watch('expiry.principleInsure',function(val){
            if(val){
                $rootScope.carBeans.insCustRecordInfo.legalend = '9999-12-31';
                $rootScope.carBeans.insCustRecordInfo.legalislong = '1';
            }else{
                $rootScope.carBeans.insCustRecordInfo.legalislong = '0';
            }
        });
        $scope.$watch('expiry.agentInsure',function(val){
            if(val){
                $rootScope.carBeans.insCustRecordInfo.businessend = '9999-12-31';
                $rootScope.carBeans.insCustRecordInfo.businessislong = '1';
            }else{
                $rootScope.carBeans.insCustRecordInfo.businessislong = '0';
            }
        });
        $scope.$watch('expiry.allBenifitInsure',function(val){
            if(val){
                $rootScope.carBeans.insCustRecordInfo.beneficiaryend = '9999-12-31';
                $rootScope.carBeans.insCustRecordInfo.beneficiaryislong = '1';
            }else{
                $rootScope.carBeans.insCustRecordInfo.beneficiaryislong = '0';
            }
        });


        var Handle = (function (handle) {
            handle.initPage = function () {
                $scope.$watch("modyImg.holdingAppImg", function (file) {
                    if (file) {
                        $generalService.ocrGetInfo({
                            cardType:"2",
                            file:file,
                            success: function (data) {
                                Handle.ownfoHandle(2,data);
                            }
                        });
                    }
                });
                $scope.$watch("modyImg.principleAppImg", function (file) {
                    if (file) {
                        $generalService.ocrGetInfo({
                            cardType:"2",
                            file:file,
                            success: function (data) {
                                Handle.ownfoHandle(3,data);
                            }
                        });
                    }
                });
                $scope.$watch("modyImg.agentAppImg", function (file) {
                    if (file) {
                        $generalService.ocrGetInfo({
                            cardType:"2",
                            file:file,
                            success: function (data) {
                                Handle.ownfoHandle(4,data);
                            }
                        });
                    }
                });
                $scope.$watch("modyImg.allBenifitAppImg", function (file) {
                    if (file) {
                        $generalService.ocrGetInfo({
                            cardType:"2",
                            file:file,
                            success: function (data) {
                                Handle.ownfoHandle(5,data);
                            }
                        });
                    }
                });
                $scope.$watch("modyImg.holdingInsureImg", function (file) {
                    if (file) {
                        $generalService.ocrGetInfo({
                            cardType:"2",
                            file:file,
                            success: function (data) {
                                Handle.ownfoHandle(7,data);
                            }
                        });
                    }
                });
                $scope.$watch("modyImg.principleInsureImg", function (file) {
                    if (file) {
                        $generalService.ocrGetInfo({
                            cardType:"2",
                            file:file,
                            success: function (data) {
                                Handle.ownfoHandle(8,data);
                            }
                        });
                    }
                });
                $scope.$watch("modyImg.agentInsureImg", function (file) {
                    if (file) {
                        $generalService.ocrGetInfo({
                            cardType:"2",
                            file:file,
                            success: function (data) {
                                Handle.ownfoHandle(9,data);
                            }
                        });
                    }
                });
                $scope.$watch("modyImg.allBenifitInsureImg", function (file) {
                    if (file) {
                        $generalService.ocrGetInfo({
                            cardType:"2",
                            file:file,
                            success: function (data) {
                                Handle.ownfoHandle(10,data);
                            }
                        });
                    }
                });
            };


            //车主信息 赋值方法 -->OCR 调用
            handle.ownfoHandle = function (type, data) {
                switch (type) {
                    case 2:
                        $rootScope.carBeans.appCustRecordInfo.controllername = data.name; //投保人姓名
                        $rootScope.carBeans.appCustRecordInfo.controlleridno = data.id_number; //投保人身份证
                        break;
                    case 3:
                        $rootScope.carBeans.appCustRecordInfo.legalname = data.name; //被保人姓名
                        $rootScope.carBeans.appCustRecordInfo.legalidno = data.id_number; //被保人身份证
                        break;
                    case 4:
                        $rootScope.carBeans.appCustRecordInfo.businessname = data.name; //车主姓名
                        $rootScope.carBeans.appCustRecordInfo.businessidno = data.id_number; //车主身份证
                        break;
                    case 5:
                        $rootScope.carBeans.appCustRecordInfo.beneficiaryname = data.name; //投保人姓名
                        $rootScope.carBeans.appCustRecordInfo.beneficiaryidno = data.id_number; //投保人身份证
                        //受益所有人为空证件类型为身份证时赋值地址
                        if($rootScope.switchBean.idcardAreaSwitch && $rootScope.carBeans.appCustRecordInfo.beneficiaryidtype == '01'){
                            $rootScope.carBeans.appCustRecordInfo.beneficiaryaddress = data.address
                        }else{
                            $rootScope.carBeans.appCustRecordInfo.beneficiaryaddress = $rootScope.carBeans.appCustRecordInfo.beneficiaryaddress
                        }
                        break;
                    case 7:
                        $rootScope.carBeans.insCustRecordInfo.controllername = data.name; //被保人姓名
                        $rootScope.carBeans.insCustRecordInfo.controlleridno = data.id_number; //被保人身份证
                        break;
                    case 8:
                        $rootScope.carBeans.insCustRecordInfo.legalname = data.name; //车主姓名
                        $rootScope.carBeans.insCustRecordInfo.legalidno = data.id_number; //车主身份证
                        break;
                    case 9:
                        $rootScope.carBeans.insCustRecordInfo.businessname = data.name; //投保人姓名
                        $rootScope.carBeans.insCustRecordInfo.businessidno = data.id_number; //投保人身份证
                        break;
                    case 10:
                        $rootScope.carBeans.insCustRecordInfo.beneficiaryname = data.name; //被保人姓名
                        $rootScope.carBeans.insCustRecordInfo.beneficiaryidno = data.id_number; //被保人身份证
                        //受益所有人为空证件类型为身份证时赋值地址
                        if($rootScope.switchBean.idcardAreaSwitch && $rootScope.carBeans.insCustRecordInfo.beneficiaryidtype == '01'){
                            $rootScope.carBeans.insCustRecordInfo.beneficiaryaddress = data.address
                        }else{
                            $rootScope.carBeans.insCustRecordInfo.beneficiaryaddress = $rootScope.carBeans.insCustRecordInfo.beneficiaryaddress
                        }
                        break;
                }
            };

            //输入身份证号获取地址省市区
            handle.getAddress = function (type,d) {
                if($rootScope.carBeans[type].beneficiaryidtype == '01' && $rootScope.switchBean.idcardAreaSwitch && $rootScope.carBeans[type].beneficiaryidno.length>=6){
                    if(d && $rootScope.carBeans[type].beneficiaryaddress){
                        return;
                    }    
                    $handleService.http({
                        url: '/countryManager/getAreaName?idNo='+$rootScope.carBeans[type].beneficiaryidno,
                        method: 'GET',
                        success: function(data){
                            if(data.resultCode == '0'){
                                $rootScope.carBeans[type].beneficiaryaddress = data.result;
                            }
                        },
                        error: function (ex) {
                            $handleService.logger('error', ex);
                        }
                    })
                }
            }
            return handle;
        })(Handle||{});


        $scope.maxLength = function (a,b,c) {
            if(c=='app'){
                if(b == 2){
                    //控股股东证件
                    switch (a) {
                        case '01':$scope.idCardLength2 = '18'; break;//身份证
                        case '02':$scope.idCardLength2 = '20'; break;//护照
                        case '03':$scope.idCardLength2 = '20'; break;//军人证
                        case '04':$scope.idCardLength2 = '20'; break;//学生证
                        case '05':$scope.idCardLength2 = '20'; break;//台胞证
                        case '06':$scope.idCardLength2 = '20'; break;//港澳返乡证
                        case '07':$scope.idCardLength2 = '20'; break;//出生证
                        case '09':$scope.idCardLength2 = '18'; break;//统一社会信用代码
                        case '10':$scope.idCardLength2 = '18'; break;//组织机构代码
                        case '11':$scope.idCardLength2 = '10'; break;//工商注册号
                        case '12':$scope.idCardLength2 = '10'; break;//税务登记证号
                        case '13':$scope.idCardLength2 = '20'; break;//纳税人识别号
                        case '15':$scope.idCardLength2 = '18'; break;//港澳台居民居住证
                        case '99':$scope.idCardLength2 = '20'; break;//其他
                        default:$scope.idCardLength2 = ''; break;
                    }
                }else if(b == 3){
                    //负责人证件
                    switch (a) {
                        case '01':$scope.idCardLength3 = '18'; break;//身份证
                        case '02':$scope.idCardLength3 = '20'; break;//护照
                        case '03':$scope.idCardLength3 = '20'; break;//军人证
                        case '04':$scope.idCardLength3 = '20'; break;//学生证
                        case '05':$scope.idCardLength3 = '20'; break;//台胞证
                        case '06':$scope.idCardLength3 = '20'; break;//港澳返乡证
                        case '07':$scope.idCardLength3 = '20'; break;//出生证
                        case '09':$scope.idCardLength3 = '18'; break;//统一社会信用代码
                        case '10':$scope.idCardLength3 = '18'; break;//组织机构代码
                        case '11':$scope.idCardLength3 = '10'; break;//工商注册号
                        case '12':$scope.idCardLength3 = '10'; break;//税务登记证号
                        case '13':$scope.idCardLength3 = '20'; break;//纳税人识别号
                        case '15':$scope.idCardLength3 = '18'; break;//港澳台居民居住证
                        case '99':$scope.idCardLength3 = '20'; break;//其他
                        default:$scope.idCardLength3 = ''; break;
                    }
                }else if(b == 4){
                    //客户经办人证件
                    switch (a) {
                        case '01':$scope.idCardLength4 = '18'; break;//身份证
                        case '02':$scope.idCardLength4 = '20'; break;//护照
                        case '03':$scope.idCardLength4 = '20'; break;//军人证
                        case '04':$scope.idCardLength4 = '20'; break;//学生证
                        case '05':$scope.idCardLength4 = '20'; break;//台胞证
                        case '06':$scope.idCardLength4 = '20'; break;//港澳返乡证
                        case '07':$scope.idCardLength4 = '20'; break;//出生证
                        case '09':$scope.idCardLength4 = '18'; break;//统一社会信用代码
                        case '10':$scope.idCardLength4 = '18'; break;//组织机构代码
                        case '11':$scope.idCardLength4 = '10'; break;//工商注册号
                        case '12':$scope.idCardLength4 = '10'; break;//税务登记证号
                        case '13':$scope.idCardLength4 = '20'; break;//纳税人识别号
                        case '15':$scope.idCardLength4 = '18'; break;//港澳台居民居住证
                        case '99':$scope.idCardLength4 = '20'; break;//其他
                        default:$scope.idCardLength4 = ''; break;
                    }
                }else if(b == 5){
                    //受益所有人证件
                    switch (a) {
                        case '01':$scope.idCardLength5 = '18'; break;//身份证
                        case '02':$scope.idCardLength5 = '20'; break;//护照
                        case '03':$scope.idCardLength5 = '20'; break;//军人证
                        case '04':$scope.idCardLength5 = '20'; break;//学生证
                        case '05':$scope.idCardLength5 = '20'; break;//台胞证
                        case '06':$scope.idCardLength5 = '20'; break;//港澳返乡证
                        case '07':$scope.idCardLength5 = '20'; break;//出生证
                        case '09':$scope.idCardLength5 = '18'; break;//统一社会信用代码
                        case '10':$scope.idCardLength5 = '18'; break;//组织机构代码
                        case '11':$scope.idCardLength5 = '10'; break;//工商注册号
                        case '12':$scope.idCardLength5 = '10'; break;//税务登记证号
                        case '13':$scope.idCardLength5 = '20'; break;//纳税人识别号
                        case '15':$scope.idCardLength5 = '18'; break;//港澳台居民居住证
                        case '99':$scope.idCardLength5 = '20'; break;//其他
                        default:$scope.idCardLength5 = ''; break;
                    }
                }
            }else {
                if(b == 7){
                    //控股股东证件
                    switch (a) {
                        case '01':$scope.idCardLength7 = '18'; break;//身份证
                        case '02':$scope.idCardLength7 = '20'; break;//护照
                        case '03':$scope.idCardLength7 = '20'; break;//军人证
                        case '04':$scope.idCardLength7 = '20'; break;//学生证
                        case '05':$scope.idCardLength7 = '20'; break;//台胞证
                        case '06':$scope.idCardLength7 = '20'; break;//港澳返乡证
                        case '07':$scope.idCardLength7 = '20'; break;//出生证
                        case '09':$scope.idCardLength7 = '18'; break;//统一社会信用代码
                        case '10':$scope.idCardLength7 = '18'; break;//组织机构代码
                        case '11':$scope.idCardLength7 = '10'; break;//工商注册号
                        case '12':$scope.idCardLength7 = '10'; break;//税务登记证号
                        case '13':$scope.idCardLength7 = '20'; break;//纳税人识别号
                        case '15':$scope.idCardLength7 = '18'; break;//港澳台居民居住证
                        case '99':$scope.idCardLength7 = '20'; break;//其他
                        default:$scope.idCardLength7 = ''; break;
                    }
                }else if(b == 8){
                    //负责人证件
                    switch (a) {
                        case '01':$scope.idCardLength8 = '18'; break;//身份证
                        case '02':$scope.idCardLength8 = '20'; break;//护照
                        case '03':$scope.idCardLength8 = '20'; break;//军人证
                        case '04':$scope.idCardLength8 = '20'; break;//学生证
                        case '05':$scope.idCardLength8 = '20'; break;//台胞证
                        case '06':$scope.idCardLength8 = '20'; break;//港澳返乡证
                        case '07':$scope.idCardLength8 = '20'; break;//出生证
                        case '09':$scope.idCardLength8 = '18'; break;//统一社会信用代码
                        case '10':$scope.idCardLength8 = '18'; break;//组织机构代码
                        case '11':$scope.idCardLength8 = '10'; break;//工商注册号
                        case '12':$scope.idCardLength8 = '10'; break;//税务登记证号
                        case '13':$scope.idCardLength8 = '20'; break;//纳税人识别号
                        case '15':$scope.idCardLength8 = '18'; break;//港澳台居民居住证
                        case '99':$scope.idCardLength8 = '20'; break;//其他
                        default:$scope.idCardLength8 = ''; break;
                    }
                }else if(b == 9){
                    //客户经办人证件
                    switch (a) {
                        case '01':$scope.idCardLength9 = '18'; break;//身份证
                        case '02':$scope.idCardLength9 = '20'; break;//护照
                        case '03':$scope.idCardLength9 = '20'; break;//军人证
                        case '04':$scope.idCardLength9 = '20'; break;//学生证
                        case '05':$scope.idCardLength9 = '20'; break;//台胞证
                        case '06':$scope.idCardLength9 = '20'; break;//港澳返乡证
                        case '07':$scope.idCardLength9 = '20'; break;//出生证
                        case '09':$scope.idCardLength9 = '18'; break;//统一社会信用代码
                        case '10':$scope.idCardLength9 = '18'; break;//组织机构代码
                        case '11':$scope.idCardLength9 = '10'; break;//工商注册号
                        case '12':$scope.idCardLength9 = '10'; break;//税务登记证号
                        case '13':$scope.idCardLength9 = '20'; break;//纳税人识别号
                        case '15':$scope.idCardLength9 = '18'; break;//港澳台居民居住证
                        case '99':$scope.idCardLength9 = '20'; break;//其他
                        default:$scope.idCardLength9 = ''; break;
                    }
                }else if(b == 10){
                    //受益所有人证件
                    switch (a) {
                        case '01':$scope.idCardLength10 = '18'; break;//身份证
                        case '02':$scope.idCardLength10 = '20'; break;//护照
                        case '03':$scope.idCardLength10 = '20'; break;//军人证
                        case '04':$scope.idCardLength10 = '20'; break;//学生证
                        case '05':$scope.idCardLength10 = '20'; break;//台胞证
                        case '06':$scope.idCardLength10 = '20'; break;//港澳返乡证
                        case '07':$scope.idCardLength10 = '20'; break;//出生证
                        case '09':$scope.idCardLength10 = '18'; break;//统一社会信用代码
                        case '10':$scope.idCardLength10 = '18'; break;//组织机构代码
                        case '11':$scope.idCardLength10 = '10'; break;//工商注册号
                        case '12':$scope.idCardLength10 = '10'; break;//税务登记证号
                        case '13':$scope.idCardLength10 = '20'; break;//纳税人识别号
                        case '15':$scope.idCardLength10 = '18'; break;//港澳台居民居住证
                        case '99':$scope.idCardLength10 = '20'; break;//其他
                        default:$scope.idCardLength10 = ''; break;
                    }
                }
            }


        };

        //OCR 方法->OCR调用
        $scope.ocrHandle = function (type) {
            $handleService.appHandle.cameraHandle({
                success: function (img) {
                    $generalService.ocrImgUpload({
                        type: "2", // 1.行驶证 2.身份证 3.驾驶证 4.银行卡
                        img: img,
                        success: function (data) {
                            $handleService.logger('info', data);
                            if (data.type != '未知类型') {
                                Handle.ownfoHandle(type, data);
                            }
                            else {
                                $U.showToast('请选择带有清晰的证件号码的照片');
                            }
                        }
                    });
                }
            });
        };

        //同车主和投保人
        $scope.infoHandle = function (beans, type,flag) {
            if(flag=='app'){
                // 受益人信息 -->同投保人 -->赋值
                if($rootScope.baseBean.holdingSameApp && type==2){
                    $rootScope.carBeans.appCustRecordInfo.controllername=$rootScope.carBeans.applicant.name;
                    $rootScope.carBeans.appCustRecordInfo.controlleridtype=$rootScope.carBeans.applicant.identifyType;
                    $rootScope.carBeans.appCustRecordInfo.controlleridno=$rootScope.carBeans.applicant.identifyNumber;
                    $rootScope.carBeans.appCustRecordInfo.controllerend=$rootScope.carBeans.applicant.identifyExpiry;
                    if($rootScope.carBeans.appCustRecordInfo.controllerend=='9999-12-31'){
                        $rootScope.carBeans.appCustRecordInfo.controllerislong='1';
                        $scope.expiry.holdingApp=true;
                    }else{
                        $rootScope.carBeans.appCustRecordInfo.controllerislong='0';
                        $scope.expiry.holdingApp=false;
                    }
                }else if($rootScope.baseBean.principleSameApp && type==3){
                    $rootScope.carBeans.appCustRecordInfo.legalname=$rootScope.carBeans.applicant.name;
                    $rootScope.carBeans.appCustRecordInfo.legalidtype=$rootScope.carBeans.applicant.identifyType;
                    $rootScope.carBeans.appCustRecordInfo.legalidno=$rootScope.carBeans.applicant.identifyNumber;
                    $rootScope.carBeans.appCustRecordInfo.legalend=$rootScope.carBeans.applicant.identifyExpiry;
                    if($rootScope.carBeans.appCustRecordInfo.legalend=='9999-12-31'){
                        $rootScope.carBeans.appCustRecordInfo.legalislong='1';
                        $scope.expiry.principleApp=true;
                    }else{
                        $rootScope.carBeans.appCustRecordInfo.legalislong='0';
                        $scope.expiry.principleApp=false;
                    }
                }else if($rootScope.baseBean.agentSameApp && type==4){
                    $rootScope.carBeans.appCustRecordInfo.businessname=$rootScope.carBeans.applicant.name;
                    $rootScope.carBeans.appCustRecordInfo.businessidtype=$rootScope.carBeans.applicant.identifyType;
                    $rootScope.carBeans.appCustRecordInfo.businessidno=$rootScope.carBeans.applicant.identifyNumber;
                    $rootScope.carBeans.appCustRecordInfo.businessend=$rootScope.carBeans.applicant.identifyExpiry;
                    if($rootScope.carBeans.appCustRecordInfo.businessend=='9999-12-31'){
                        $rootScope.carBeans.appCustRecordInfo.businessislong='1';
                        $scope.expiry.agentApp=true;
                    }else{
                        $rootScope.carBeans.appCustRecordInfo.businessislong='0';
                        $scope.expiry.agentApp=false;
                    }
                }else if($rootScope.baseBean.allBenifitSameApp && type==5){
                    $rootScope.carBeans.appCustRecordInfo.beneficiaryname=$rootScope.carBeans.applicant.name;
                    $rootScope.carBeans.appCustRecordInfo.beneficiaryidtype=$rootScope.carBeans.applicant.identifyType;
                    $rootScope.carBeans.appCustRecordInfo.beneficiaryidno=$rootScope.carBeans.applicant.identifyNumber;
                    $rootScope.carBeans.appCustRecordInfo.beneficiaryend=$rootScope.carBeans.applicant.identifyExpiry;
                    $rootScope.carBeans.appCustRecordInfo.beneficiaryaddress=$rootScope.carBeans.applicant.address;
                    if($rootScope.carBeans.appCustRecordInfo.beneficiaryend=='9999-12-31'){
                        $rootScope.carBeans.appCustRecordInfo.beneficiaryislong='1';
                        $scope.expiry.allBenifitApp=true;
                    }else{
                        $rootScope.carBeans.appCustRecordInfo.beneficiaryislong='0';
                        $scope.expiry.allBenifitApp=false;
                    }
                }
            }else if(flag=='insure'){
                // 受益人信息 -->同投保人 -->赋值
                if($rootScope.baseBean.holdingSameInsure && type==2){
                    $rootScope.carBeans.insCustRecordInfo.controllername=$rootScope.carBeans.insured.name;
                    $rootScope.carBeans.insCustRecordInfo.controlleridtype=$rootScope.carBeans.insured.identifyType;
                    $rootScope.carBeans.insCustRecordInfo.controlleridno=$rootScope.carBeans.insured.identifyNumber;
                    $rootScope.carBeans.insCustRecordInfo.controllerend=$rootScope.carBeans.insured.identifyExpiry;
                    if($rootScope.carBeans.insCustRecordInfo.controllerend=='9999-12-31'){
                        $rootScope.carBeans.insCustRecordInfo.controllerislong='1';
                        $scope.expiry.holdingInsure=true;
                    }else{
                        $rootScope.carBeans.insCustRecordInfo.controllerislong='0';
                        $scope.expiry.holdingInsure=false;
                    }
                }else if($rootScope.baseBean.principleSameInsure && type==3){
                    $rootScope.carBeans.insCustRecordInfo.legalname=$rootScope.carBeans.insured.name;
                    $rootScope.carBeans.insCustRecordInfo.legalidtype=$rootScope.carBeans.insured.identifyType;
                    $rootScope.carBeans.insCustRecordInfo.legalidno=$rootScope.carBeans.insured.identifyNumber;
                    $rootScope.carBeans.insCustRecordInfo.legalend=$rootScope.carBeans.insured.identifyExpiry;
                    if($rootScope.carBeans.insCustRecordInfo.legalend=='9999-12-31'){
                        $rootScope.carBeans.insCustRecordInfo.legalislong='1';
                        $scope.expiry.principleInsure=true;
                    }else{
                        $rootScope.carBeans.insCustRecordInfo.legalislong='0';
                        $scope.expiry.principleInsure=false;
                    }
                }else if($rootScope.baseBean.agentSameInsure && type==4){
                    $rootScope.carBeans.insCustRecordInfo.businessname=$rootScope.carBeans.insured.name;
                    $rootScope.carBeans.insCustRecordInfo.businessidtype=$rootScope.carBeans.insured.identifyType;
                    $rootScope.carBeans.insCustRecordInfo.businessidno=$rootScope.carBeans.insured.identifyNumber;
                    $rootScope.carBeans.insCustRecordInfo.businessend=$rootScope.carBeans.insured.identifyExpiry;
                    if($rootScope.carBeans.insCustRecordInfo.businessend=='9999-12-31'){
                        $rootScope.carBeans.insCustRecordInfo.businessislong='1';
                        $scope.expiry.agentInsure=true;
                    }else{
                        $rootScope.carBeans.insCustRecordInfo.businessislong='0';
                        $scope.expiry.agentInsure=false;
                    }
                }else if($rootScope.baseBean.allBenifitSameInsure && type==5){
                    $rootScope.carBeans.insCustRecordInfo.beneficiaryname=$rootScope.carBeans.insured.name;
                    $rootScope.carBeans.insCustRecordInfo.beneficiaryidtype=$rootScope.carBeans.insured.identifyType;
                    $rootScope.carBeans.insCustRecordInfo.beneficiaryidno=$rootScope.carBeans.insured.identifyNumber;
                    $rootScope.carBeans.insCustRecordInfo.beneficiaryend=$rootScope.carBeans.insured.identifyExpiry;
                    $rootScope.carBeans.insCustRecordInfo.beneficiaryaddress=$rootScope.carBeans.insured.address;
                    if($rootScope.carBeans.insCustRecordInfo.beneficiaryend=='9999-12-31'){
                        $rootScope.carBeans.insCustRecordInfo.beneficiaryislong='1';
                        $scope.expiry.allBenifitInsure=true;
                    }else{
                        $rootScope.carBeans.insCustRecordInfo.beneficiaryislong='0';
                        $scope.expiry.allBenifitInsure=false;
                    }
                }
            }

        };
        
        $scope.default=function (val,b) {
            if($scope.isApp){
                if(val=='tes1'){
                    $rootScope.carBeans.appCustRecordInfo.controlleridno='';
                    $scope.maxLength(b,2);
                }else if(val=='tes2'){
                    $rootScope.carBeans.appCustRecordInfo.legalidno='';
                    $scope.maxLength(b,3);
                }else if(val=='tes3'){
                    $rootScope.carBeans.appCustRecordInfo.businessidno='';
                    $scope.maxLength(b,4);
                }else if(val=='tes4'){
                    $rootScope.carBeans.appCustRecordInfo.beneficiaryidno='';
                    $scope.maxLength(b,5);
                }
            }else{
                if(val=='tes1'){
                    $rootScope.carBeans.insCustRecordInfo.controlleridno='';
                    $scope.maxLength(b,7);
                }else if(val=='tes2'){
                    $rootScope.carBeans.insCustRecordInfo.legalidno='';
                    $scope.maxLength(b,8);
                }else if(val=='tes3'){
                    $rootScope.carBeans.insCustRecordInfo.businessidno='';
                    $scope.maxLength(b,9);
                }else if(val=='tes4'){
                    $rootScope.carBeans.insCustRecordInfo.beneficiaryidno='';
                    $scope.maxLength(b,10);
                }
            }

        };
        //获取点击身份
        $scope.getPersonel = function (type) {
            $scope.personelClick = type
        };
        //根据省份证号获取受益所有人地址
        $scope.getAdress = function() {
            Handle.getAddress($scope.personelClick)
        }

        $scope.moreMsgConfirm=function (form) {
            var options={};

            //校验表单准确性
            $handleService.validateForm.call(this, form);
            if (form.$valid){
                var TypeRegExp = {
                    //身份证
                    "IdCodeValid": function (code) {
                        return $U.IdCodeValid(code);
                    },
                    //护照
                    "02": /^([A-Z0-9]{4,20})$/,
                    //军人证
                    "03": /^([a-zA-Z0-9\(\)\（\）]{4,20})$/,
                    //学生证
                    "04": /^([a-zA-Z0-9\(\)\（\）]{4,20})$/,
                    //台胞证
                    "05": /^([0-9A-Z\(\)\（\）]{4,20})$/,
                    //港澳通行证
                    "06": /^((.){4,20})$/,
                    //出生证
                    "07": /^([a-zA-Z0-9]{1,20})$/,
                    //统一社会信用代码
                    "09": /^([A-Z0-9]{18})$/,
                    //组织机构代码
                    "10": /^([a-zA-Z0-9]{8}-[0-9|X]|[a-zA-Z0-9]{10}|[a-zA-Z0-9]{18})$/,
                    //工商注册号
                    "11": /^([a-zA-Z0-9]{4,20})$/,
                    //税务登记证号
                    "12": /^([a-zA-Z0-9]{4,20})$/,
                    //纳税人识别号
                    "13": /^([a-zA-Z0-9]{15}|[a-zA-Z0-9]{17}|[a-zA-Z0-9]{18}|[a-zA-Z0-9]{20})$/,
                    //港澳台居民居住证
                    "15": /^[1-9]\d{5}[1-9]\d{3}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}([0-9]|X)$/
                };
                var appRes1={} ,appRes2 ={} ,appRes3 ={},appRes4 ={};
                var typeRExp1 ='';
                var typeRExp2 ='';
                var typeRExp3 ='';
                var typeRExp4 ='';

                if($scope.isApp){
                    if($rootScope.carBeans.appCustRecordInfo.controlleridtype=='01'){
                        appRes1 =  TypeRegExp.IdCodeValid($rootScope.carBeans.appCustRecordInfo.controlleridno);
                    }else{
                        typeRExp1 = new RegExp(TypeRegExp[$rootScope.carBeans.appCustRecordInfo.controlleridtype] || /\S/);
                    }
                    if($rootScope.carBeans.appCustRecordInfo.legalidtype=='01'){
                        appRes2 =  TypeRegExp.IdCodeValid($rootScope.carBeans.appCustRecordInfo.legalidno);
                    }else{
                        typeRExp2 = new RegExp(TypeRegExp[$rootScope.carBeans.appCustRecordInfo.legalidtype] || /\S/);
                    }
                    if($rootScope.carBeans.appCustRecordInfo.businessidtype=='01'){
                        appRes3 =  TypeRegExp.IdCodeValid($rootScope.carBeans.appCustRecordInfo.businessidno);
                    }else{
                        typeRExp3 = new RegExp(TypeRegExp[$rootScope.carBeans.appCustRecordInfo.businessidtype] || /\S/);
                    }
                    if($rootScope.carBeans.appCustRecordInfo.beneficiaryidtype=='01'){
                        appRes4 =  TypeRegExp.IdCodeValid($rootScope.carBeans.appCustRecordInfo.beneficiaryidno);
                    }else{
                        typeRExp4 = new RegExp(TypeRegExp[$rootScope.carBeans.appCustRecordInfo.beneficiaryidtype] || /\S/);
                    }

                    if($rootScope.carBeans.appCustRecordInfo.controlleridtype=='01'){
                        if(appRes1.pass==false) {
                            $U.showToast('您的控股股东/实际控制人证件号码输入不正确');
                            return;
                        }
                    }
                    else if (typeRExp1.test($rootScope.carBeans.appCustRecordInfo.controlleridno) == false) {
                        $U.showToast('您的控股股东/实际控制人证件号码输入不正确');
                        return;
                    }

                    if($rootScope.carBeans.appCustRecordInfo.legalidtype=='01'){
                        if(appRes2.pass==false) {
                            $U.showToast('您的法定代表人/负责人证件号码输入不正确');
                            return;
                        }
                    }
                    else if (typeRExp2.test($rootScope.carBeans.appCustRecordInfo.legalidno) == false) {
                        $U.showToast('您的法定代表人/负责人证件号码输入不正确');
                        return;
                    }

                    if($rootScope.carBeans.appCustRecordInfo.businessidtype=='01'){
                        if(appRes3.pass==false) {
                            $U.showToast('您的客户经办人证件号码输入不正确');
                            return;
                        }
                    }
                    else if (typeRExp3.test($rootScope.carBeans.appCustRecordInfo.businessidno) == false) {
                        $U.showToast('您的客户经办人证件号码输入不正确');
                        return;
                    }

                    if($rootScope.carBeans.appCustRecordInfo.beneficiaryidtype=='01'){
                        if(appRes4.pass==false) {
                            $U.showToast('您的受益所有人证件号码输入不正确');
                            return;
                        }
                    }
                    else if (typeRExp4.test($rootScope.carBeans.appCustRecordInfo.beneficiaryidno) == false) {
                        $U.showToast('您的受益所有人证件号码输入不正确');
                        return;
                    }
                    if($rootScope.carBeans.appCustRecordInfo.beneficiaryaddress&&$rootScope.carBeans.appCustRecordInfo.beneficiaryaddress.length<6){
                        $U.showToast('请输入受益所有人地址信息');
                        return;
                    }
                    options.appCustRecordInfo=$rootScope.carBeans.appCustRecordInfo;
                    options.appCustRecordInfo.operator=$U.sessionHandle.getSession("SLS_INFO").salesmanCode;
                    options.appCustRecordInfo.syssource="eshopauto";
                    options.appCustRecordInfo.idno=$rootScope.carBeans.applicant.identifyNumber;
                    options.appCustRecordInfo.idtype=$rootScope.carBeans.applicant.identifyType;
                    options.appCustRecordInfo.clientname=$rootScope.carBeans.applicant.name;

                }else{
                    if($rootScope.carBeans.insCustRecordInfo.controlleridtype=='01'){
                        appRes1 =  TypeRegExp.IdCodeValid($rootScope.carBeans.insCustRecordInfo.controlleridno);
                    }else{
                        typeRExp1 = new RegExp(TypeRegExp[$rootScope.carBeans.insCustRecordInfo.controlleridtype] || /\S/);
                    }
                    if($rootScope.carBeans.insCustRecordInfo.legalidtype=='01'){
                        appRes2 =  TypeRegExp.IdCodeValid($rootScope.carBeans.insCustRecordInfo.legalidno);
                    }else{
                        typeRExp2 = new RegExp(TypeRegExp[$rootScope.carBeans.insCustRecordInfo.legalidtype] || /\S/);
                    }
                    if($rootScope.carBeans.insCustRecordInfo.businessidtype=='01'){
                        appRes3 =  TypeRegExp.IdCodeValid($rootScope.carBeans.insCustRecordInfo.businessidno);
                    }else{
                        typeRExp3 = new RegExp(TypeRegExp[$rootScope.carBeans.insCustRecordInfo.businessidtype] || /\S/);
                    }
                    if($rootScope.carBeans.insCustRecordInfo.beneficiaryidtype=='01'){
                        appRes4 =  TypeRegExp.IdCodeValid($rootScope.carBeans.insCustRecordInfo.beneficiaryidno);
                    }else{
                        typeRExp4 = new RegExp(TypeRegExp[$rootScope.carBeans.insCustRecordInfo.beneficiaryidtype] || /\S/);
                    }

                    if($rootScope.carBeans.insCustRecordInfo.controlleridtype=='01'){
                        if(appRes1.pass==false) {
                            $U.showToast('您的控股股东/实际控制人证件号码输入不正确');
                            return;
                        }
                    }
                    else if (typeRExp1.test($rootScope.carBeans.insCustRecordInfo.controlleridno) == false) {
                        $U.showToast('您的控股股东/实际控制人证件号码输入不正确');
                        return;
                    }

                    if($rootScope.carBeans.insCustRecordInfo.legalidtype=='01'){
                        if(appRes2.pass==false) {
                            $U.showToast('您的法定代表人/负责人证件号码输入不正确');
                            return;
                        }
                    }
                    else if (typeRExp2.test($rootScope.carBeans.insCustRecordInfo.legalidno) == false) {
                        $U.showToast('您的法定代表人/负责人证件号码输入不正确');
                        return;
                    }

                    if($rootScope.carBeans.insCustRecordInfo.businessidtype=='01'){
                        if(appRes3.pass==false) {
                            $U.showToast('您的客户经办人证件号码输入不正确');
                            return;
                        }
                    }
                    else if (typeRExp3.test($rootScope.carBeans.insCustRecordInfo.businessidno) == false) {
                        $U.showToast('您的客户经办人证件号码输入不正确');
                        return;
                    }

                    if($rootScope.carBeans.insCustRecordInfo.beneficiaryidtype=='01'){
                        if(appRes4.pass==false) {
                            $U.showToast('您的受益所有人证件号码输入不正确');
                            return;
                        }
                    }
                    else if (typeRExp4.test($rootScope.carBeans.insCustRecordInfo.beneficiaryidno) == false) {
                        $U.showToast('您的受益所有人证件号码输入不正确');
                        return;
                    }
                    if($rootScope.carBeans.insCustRecordInfo.beneficiaryaddress&&$rootScope.carBeans.insCustRecordInfo.beneficiaryaddress.length<6){
                        $U.showToast('请输入受益所有人地址信息');
                        return;
                    }
                    options.insCustRecordInfo=$rootScope.carBeans.insCustRecordInfo;
                    options.insCustRecordInfo.operator=$U.sessionHandle.getSession("SLS_INFO").salesmanCode;
                    options.insCustRecordInfo.syssource="eshopauto";
                    options.insCustRecordInfo.idno=$rootScope.carBeans.insured.identifyNumber;
                    options.insCustRecordInfo.idtype=$rootScope.carBeans.insured.identifyType;
                    options.insCustRecordInfo.clientname=$rootScope.carBeans.insured.name;
                }

                options.riskList=$rootScope.riskListMore;
                $handleService.logger('object', $rootScope.carBeans, '反洗钱请求参数');

                $handleService.http({
                    url: '/custRecordInfo',
                    data: options,
                    success: function (data) {
                        $handleService.logger('object', data, '反洗钱请求参数');
                        if(data.resultCode == '0'){
                            history.go(-1);
                        }else{
                            $U.showToast(data.errorMsg);
                        }
                    },
                    error: function (ex) {
                        $handleService.logger('error', ex);
                    }
                });

            }
        };


        Handle.initPage();
        
        
        


        //---------------------------------------------------end 我的业绩----------------------------------------------------------//

    });
    return app;
});