define(['services/app.service', 'filters/app.filters', 'services/app.sqlLite.service', 'services/app.car.beans', 'directives/app.directives'], function () {
   'use strict';
   var app = angular.module('app.recordController', ['app.handle.service', 'app.filters', 'app.sqlLite.service', 'app.directives', 'app.car.beans']);
   //展业登录控制器
   app.controller('recordController', function ($scope, $rootScope, $handleService, $sqlSQLiteService, $templateCache, $location, $state, $http, $compile, $interFace, $carBeansService, $stateParams, $timeout, $sce,$ionicPopover) {
      // $scope.MY_CAR_RECORD_LIST = {}; //我的车险业绩
      //-------------------------------------------------begin 我的业绩------------------------------------------------------------//


      $scope.vmhead = {};
      $scope.vm = {};
      $scope.vm.POLICYINFO_LIST = [];
      $scope.vm.ORDER_NO = $stateParams.ORDER_NO;
      $scope.vm.INSURANCE_NAME = $stateParams.INSURANCE_NAME;
      $scope.vm.TYPE = $stateParams.TYPE;
      $scope.carType = $stateParams.CAR_TYPE || $stateParams.TYPE;
      $scope.data_source =[];  //我的业绩: 默认查所有值
        // console.log($scope.carType);

       $scope.PackageList=[];//交叉销售  非车险广告列表
      $scope.currentPage = 1;
      //我的业绩车险是否加载完,做非车与车险tab切换记录,ion-infinite-scroll指令有bug
      $scope.CAR_RECORD_LOADED_END = false;
      //有没有车险更多数据,这个只控制ion-infinite-scroll指令
      $scope.carNoMorePage = false;
      //后台返回字符串,相加价格
      // $scope.mathAdd = function(num1, num2) {
      //     return Number(num1) + Number(num2);
      // };

      // 摩托车数据变量
       $scope.motorhead = {};
      $scope.motor = {};
      $scope.motor.policyinfo_list = [];
      $scope.curMotorPage = 1;
      //摩托车车险是否加载完
      $scope.Motor_RECORD_LOADED_END = false;
      //有没有车险更多数据,这个只控制ion-infinite-scroll指令
      $scope.motorNoMorePage = false;

      $scope.motor.ORDER_NO = $stateParams.ORDER_NO;
      $scope.motor.INSURANCE_NAME = $stateParams.INSURANCE_NAME;
      $scope.motor.TYPE = $stateParams.TYPE;

       $scope.isSY = false;
       $scope.isJQ = false;


      //非车记录
      $scope.toNoCarRecord = function () {
         //$scope.queryUrl = $sce.trustAsResourceUrl($interFace.noCarRcordQuery + $handleService.getBindSalesCodeOrSalesCode() + "&deptCode=" + $U.getDeptCode());
         $scope.queryUrl = $sce.trustAsResourceUrl($interFace.noCarRcordQuery + $U.getSlsCode() + "&deptCode=" + $U.getDeptCode());
         $scope.carNoMorePage = true;
      };
      //车险记录
      $scope.toCarRecord = function () {
	      $scope.carType='CAR';
         if ($scope.CAR_RECORD_LOADED_END) {

            $scope.carNoMorePage = true;
         }
         else {
            $scope.carNoMorePage = false;
         }
      };
      $scope.toMotorCarRecord = function(){
         $scope.carType='MOTOR';

	      if($scope.Motor_RECORD_LOADED_END){
		      $scope.motorNoMorePage = true;
	      }else{
		      $scope.motorNoMorePage = false;
	      }
      };

       //弹出框start
       // 方式2: fromTemplateUrl() method
       $ionicPopover.fromTemplateUrl('templates/common/my-popover.html', {
           scope: $scope
       }).then(function(popover) {
           $scope.popover = popover;

       });
       //点击右上角更多
       $scope.moreView =function ($event) {
           $scope.popover.show($event);
       }

       $scope.popoverMenuClick =function (index,item) {
           $scope.closePopover();
           switch (index){
               // 0 车险 APP
               case 0:
                   $scope.data_source =['eautomobile'];
                   break;
               // 1 全民优保
               case 1:
                   $scope.data_source =["peoplemark"];
                   break;
               // 2 B2B
               case 2:
                   $scope.data_source =["eshopauto"];
                   break;
               // 3 全部
               case 3:
                   $scope.data_source =[];
                   break;
               default:
                   break;
           }
           $handleService.scrollTop();
           $scope.currentPage  = 0;
           $scope.vm.POLICYINFO_LIST = [];
           $scope.carNoMorePage = false;
           $scope.CAR_RECORD_LOADED_END = false;
           $scope.curMotorPage = 0;
           $scope.motor.policyinfo_list = [];
           $scope.Motor_RECORD_LOADED_END = false;
           $scope.motorNoMorePage = false;
           $scope.loadMore();
           if($scope.carType=='CAR'){
               $scope.myCarTotalFee();
           }else if($scope.carType=='MOTOR'){
               $scope.myMotoTotalFee();
           }
       };

       $scope.closePopover = function() {
           $scope.popover.hide();
       };
       //Cleanup the popover when we're done with it!
       $scope.$on('$destroy', function() {
           $scope.popover.remove();
       });

       // Execute action on hide popover
       $scope.$on('popover.hidden', function() {
           //影藏之后执行的代码
       });

       $scope.$on('popover.shown', function() {
           // Execute action
           //显示后执行的代码

       });

       // Execute action on remove popover
       $scope.$on('popover.removed', function() {
           //跳出当前页时执行的代码
       });
       //弹出框end

       /**
        * TYPE=CAR
        * 获取业务员截止至昨日当年，当月，昨天。保费合计，单量合计
        */
        $scope.myCarTotalFee =function () {
            $handleService.http({
                url: '/policyOrder/statistics',
                data: {
                    dataSource: $scope.data_source,
                    insuredProduct: '0',
                    salesManCode: $U.getSlsCode()
                },
                success: function (data) {
                    $handleService.logger('object', data, '车险业绩保费统计请求成功');
                    if(data.resultCode=='0'){
                        $scope.vmhead =data.result;
                        $scope.myCarRecord();
                    }
                },
                error: function (ex) {
                    $handleService.logger('error', ex);
                }
            });
        }

       /**
        * TYPE=MOTO
        * 获取业务员截止至昨日当年，当月，昨天。保费合计，单量合计
        */
       $scope.myMotoTotalFee =function () {
           $handleService.http({
               url: '/policyOrder/statistics',
               data: {
                   dataSource: $scope.data_source,
                   insuredProduct: '1',
                   salesManCode: $U.getSlsCode()
               },
               success: function (data) {
                   $handleService.logger('object', data, '摩托车险业绩保费统计请求成功');
                   if(data.resultCode=='0'){
                       $scope.motorhead =data.result;
                       $scope.myMotorRecord();
                   }

               },
               error: function (ex) {
                   $handleService.logger('error', ex);
               }
           });
       }


      //车险业绩

      $scope.myCarRecord = function () {
         $handleService.http({
            url: '/policyOrder/queryPerformanceList',
             data: {
                 page: {
                     pageSize: 5,
                     pageNum: $scope.currentPage
                 },
                 insuredProduct: '0',//	0：机动车，1：摩托车
                 isPolicyFlag: '1',
                 salesManCode: $U.getSlsCode(),   //'107063619'//$U.getSession("SLS_CDE")
                 origSysList: $scope.data_source
             },
            success: function (cardata) {
                $handleService.logger('object', cardata, '车险业绩列表请求成功');
                if (cardata.resultCode == "0") {
                    if ($U.isNotEmpty(cardata)) {
                        if ($scope.currentPage > 1) {
                            if (cardata.result && cardata.result.length > 0) {
                                for (var i = 0; i < cardata.result.length; i++) {
                                    $scope.vm.POLICYINFO_LIST.push(cardata.result[i]);
                                }
                            }
                            if (!cardata.result || cardata.result && cardata.page.pageNum >= cardata.page.pageCount) {
                                $scope.carNoMorePage = true;
                                $scope.CAR_RECORD_LOADED_END = true;
                            }
                        }
                        else {
                            $scope.vm.POLICYINFO_LIST = cardata.result;
                            if (!cardata.result || cardata.result && cardata.page.pageNum >= cardata.page.pageCount) {
                                $scope.carNoMorePage = true;
                                $scope.CAR_RECORD_LOADED_END = true;
                            }
                        }
                        $scope.$broadcast('scroll.infiniteScrollComplete');

                    }else{
                        $scope.carNoMorePage = true;
                        $scope.CAR_RECORD_LOADED_END = true;
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                    }
                }
            },
            error: function (ex) {
               $handleService.logger('error', ex);
            }
         });

      };

      //摩托车业绩
      $scope.myMotorRecord = function(){
	      $handleService.http({
              url: '/policyOrder/queryPerformanceList',
		      data: {
			      // page: $scope.curMotorPage,
			      page: {
				      pageSize: 5,
				      pageNum: $scope.curMotorPage
			      },
                  insuredProduct: '1',//	0：机动车，1：摩托车,
                  isPolicyFlag: '1',
                  salesManCode: $U.getSlsCode(),   //'107063619'//$U.getSession("SLS_CDE")
                  origSysList: $scope.data_source
		      },
              /*摩托车暂用老接口*/
              // url: '/xszc/service/ydzyService',
              // method: 'POST',
              // contentType:'application/json',
              // headers: {
              //     method: 'applyPolicyList'
              // },
              // data: {
              //     // page: $scope.curMotorPage,
              //     page: {
              //         pageSize: 5,
              //         pageNum: $scope.curMotorPage
              //     },
              //     companyCode : $U.getDeptCode(),   //'0107010101'  ,//String($U.getCompleteDeptCode()),
              //     salesManCode: $U.getSlsCode()   //'107063619'//$U.getSession("SLS_CDE")
              // },

		      success: function (cardata) {
                  $handleService.logger('object', cardata, '摩托车险业绩列表请求成功');

                  if (cardata.resultCode == "0") {
                      if ($U.isNotEmpty(cardata)) {
                          if ($scope.curMotorPage > 1) {
                              if (cardata.result && cardata.result.length > 0) {
                                  for (var i = 0; i < cardata.result.length; i++) {
                                      $scope.motor.policyinfo_list.push(cardata.result[i]);
                                  }
                              }
                              if (!cardata.result || cardata.result && cardata.page.pageNum >= cardata.page.pageCount) {
                                  $scope.motorNoMorePage = true;
                                  $scope.Motor_RECORD_LOADED_END = true;
                              }
                          }
                          else {
                              $scope.motor.policyinfo_list = cardata.result;
                              if (!cardata.result || cardata.result && cardata.page.pageNum >= cardata.page.pageCount) {
                                  $scope.motorNoMorePage = true;
                                  $scope.Motor_RECORD_LOADED_END = true;
                              }
                          }
                          $scope.$broadcast('scroll.infiniteScrollComplete');

                      }else{
                          $scope.motorNoMorePage = true;
                          $scope.Motor_RECORD_LOADED_END = true;
                          $scope.$broadcast('scroll.infiniteScrollComplete');
                      }
                  }





                  // if ($U.isNotEmpty(data)) {
                  //     if ($scope.curMotorPage > 1) {
                  //         if (data.policyinfo_list && data.policyinfo_list.length > 0) {
                  //             for (var i = 0; i < data.policyinfo_list.length; i++) {
                  //                 $scope.motor.policyinfo_list.push(data.policyinfo_list[i]);
                  //             }
                  //         }
                  //         if (!data.policyinfo_list || data.policyinfo_list && data.policyinfo_list.length < 5) {
                  //             $scope.motorNoMorePage = true;
                  //             $scope.Motor_RECORD_LOADED_END = true;
                  //         }
                  //     }
                  //     else {
                  //         $scope.motor = data;
                  //         if (!data.policyinfo_list || data.policyinfo_list && data.policyinfo_list.length < 5) {
                  //             $scope.motorNoMorePage = true;
                  //             $scope.Motor_RECORD_LOADED_END = true;
                  //         }
                  //     }
                  //     $scope.$broadcast('scroll.infiniteScrollComplete');
                  //
                  // }else{
                  //     $scope.motorNoMorePage = true;
                  //     $scope.Motor_RECORD_LOADED_END = true;
                  //     $scope.$broadcast('scroll.infiniteScrollComplete');
                  // }

		      },
		      error: function (ex) {
			      $handleService.logger('error', ex);
		      }
	      });
      };




      $scope.recordEvent = function (order_no, insurance_name ,car_type) {
          
         $state.go('tab.trackRecordDetail', {ORDER_NO: order_no, INSURANCE_NAME: insurance_name , CAR_TYPE : car_type});

      };
      var timer = true;




      // 滑屏加载更多
      $scope.loadMore = function () {
         if($scope.carType=='CAR'){
	         $scope.currentPage++;
	         $scope.myCarRecord();
         }else if($scope.carType=='MOTOR'){
	         $scope.curMotorPage++;
	         $scope.myMotorRecord();
         }
      };


      //获取车险详细信息
      $scope.carRecordDetail = function () {
          console.log("carType == 'CAR'"+$scope.vm.ORDER_NO);
         if($scope.carType == 'CAR'){
	         $handleService.http({
		         url: '/policyOrder/orderDetail',
		         data: {
                     orderNo: $scope.vm.ORDER_NO
		         },
		         success: function (data) {
                     $handleService.logger('object', data, '车险业绩详情请求成功');
                     if (data.resultCode == "0") {
                         $scope.dataSY={};
                         $scope.dataJQ={};
                         $scope.syRiskList = [];//整理商业险列表详细信息
                         angular.forEach(data.result.riskList,function (item) {
                             if(item.riskCode=="0301"){
                                 angular.extend($scope.dataJQ, item);
                                 $scope.dataJQ.operateDate = data.result.base.operateDate;
                                 $scope.dataJQ.companyName = data.result.base.companyName;
                             }
                             if(item.riskCode=="0302"){
                                 angular.extend($scope.dataSY, item);
                                 $scope.dataSY.operateDate = data.result.base.operateDate;
                                 $scope.dataSY.companyName = data.result.base.companyName;
                             }

                             if($scope.vm.INSURANCE_NAME=='商业险'){
                                 $scope.isSY =true;
                             }
                             if($scope.vm.INSURANCE_NAME=='交强险'){
                                 $scope.isJQ =true;
                             }

                             $http.get('data/dept-data.json').success(function (deptdata) {
                                 var _sls_info = JSON.parse($U.getSession('SLS_INFO'));
                                 if (_sls_info) {
                                     data.result['insure_address_city'] = deptdata[$U.getTwoDeptID()];
                                 }
                                 angular.extend($scope.vm, data.result);
                             });
                         });

                         /*整理商业险列表详细信息*/
                         angular.forEach($scope.dataSY.coverageList, function (cvrTem) {
                             var _cvrName = $rootScope.BASE_BEAN.INS_CN_NAME[cvrTem.kindCode],
                                 _cvrAmt = cvrTem.sumInsured;
                             if (_cvrName) {
                                 if(cvrTem.kindCode=='030201'){
                                     $scope.syRiskList.push({
                                         kindCode: cvrTem.kindCode,
                                         sumInsured: _cvrAmt? "￥" + _cvrAmt : "",
                                         grossPremium: cvrTem.grossPremium,
                                         name: _cvrName,
                                         rate: cvrTem.rate,
                                         quantity: cvrTem.quantity,
                                         valueType: cvrTem.valueType,
                                         unitInsured: cvrTem.unitInsured||'0'
                                     });

                                     angular.forEach($scope.dataSY.coverageList, function (cvrTem2) {
                                         if (cvrTem2.kindCode == '021') {
                                             $scope.syRiskList.pop();
                                             $scope.syRiskList.push({
                                                 kindCode: cvrTem.kindCode,
                                                 sumInsured: _cvrAmt? "￥" + _cvrAmt : "",
                                                 // grossPremium: $U.accAdd(cvrTem.grossPremium,cvrTem2.grossPremium||'0'),
                                                 grossPremium: cvrTem.grossPremium,
                                                 name: _cvrName,
                                                 rate: cvrTem.rate,
                                                 quantity: cvrTem.quantity,
                                                 valueType: cvrTem.valueType,
                                                 unitInsured: cvrTem.unitInsured||'0'
                                             });

                                             $scope.syRiskList.push({
                                                 kindCode: cvrTem2.kindCode,
                                                 sumInsured: cvrTem2.rate+"%",
                                                 grossPremium: cvrTem2.grossPremium,
                                                 name: '免赔率',
                                                 rate: cvrTem2.rate,
                                                 quantity: cvrTem2.quantity,
                                                 valueType: cvrTem2.valueType,
                                                 unitInsured: cvrTem2.unitInsured||'0'
                                             });
                                         }
                                     })

                                 }else{
                                     $scope.syRiskList.push({
                                         kindCode: cvrTem.kindCode,
                                         sumInsured: _cvrAmt ? "￥" + _cvrAmt : "",
                                         grossPremium: cvrTem.grossPremium,
                                         name: _cvrName,
                                         rate: cvrTem.rate,
                                         quantity: cvrTem.quantity,
                                         valueType: cvrTem.valueType,
                                         unitInsured: cvrTem.unitInsured || '0'
                                     });
                                 }

                             }
                         })
                     }
                     else {
                         //查询失败时，增加默认提示信息
                         $U.showToast(data.errorMsg);
                     }
		         },
		         error: function (ex) {
			         $handleService.logger('error', ex);
		         }
	         });
         }else if($scope.carType == 'MOTOR'){
	         $handleService.motoHttp({
		         // url: 'mocks/mock-getMotorRecordDetail.json',
		         url: $interFace.motoMainFace,
		         method: 'post',
		         headers: {
			         method: 'appNoDetail'
		         },
		         data: {
			         proposalNo: $scope.motor.ORDER_NO,
			         SLS_CDE: String($U.getSlsCode())
			         // token: $handleService.sessionHandle.getSession('TOKEN'),
			         // emp_cde: $handleService.sessionHandle.getSession('SLS_CDE')
		         },
		         success: function (data) {
                     $handleService.logger('object', data, '摩托车业绩详情请求成功');
			         if ($U.isNotEmpty(data)) {
				         $http.get('data/dept-data.json').success(function (deptdata) {
					         var _sls_info = JSON.parse($U.getSession('SLS_INFO'));
					         if (_sls_info) {
						         data['insureAddressCity'] = deptdata[$U.getTwoDeptID()];
					         }
					         angular.extend($scope.motor, data);

				         });
			         }
		         },
		         error: function (ex) {
			         $handleService.logger('error', ex);
		         }
	         });
         }

         //获取非车险轮播图信息
         //  $handleService.http({
         //      url: $interFace.mitMainFace,
         //      method: 'post',
         //      headers: {
         //          method: 'queryNbzRationInfo'
         //      },
         //      data: {
         //          "companyCode":String($U.getDeptCode()).substring(0,4)
         //      },
         //      success: function (data) {
         //          if(data.success=='true'){
         //              $scope.PackageList=data.packageList;
			// 	  }
         //      },
         //      error: function (ex) {
         //          $handleService.logger('error', ex);
         //      }
         //  });

      }

      if ($scope.vm.ORDER_NO||$scope.motor.ORDER_NO) {
         $scope.carRecordDetail();
      }


      //获取投保记录
      if ($scope.vm.TYPE == "CAR") {
          $scope.myCarTotalFee();
          $scope.myMotoTotalFee();

      }



       //广告位  打开广告链接
       $scope.openImgUrl = function (url) {
           if(!url) {
               return;
           }
           var employCode = $U.sessionHandle.getSession("SLS_INFO").employCode;
           var url =url+"&salesCode=" + employCode;
           $handleService.openUrl(url, {
               shareFlag: false,
               otherOptions: {
               }
           });
       };
      //---------------------------------------------------end 我的业绩----------------------------------------------------------//

   });
   return app;
});