define(['services/app.service', 'services/app.car.beans', 'directives/app.directives', 'filters/app.filters'], function () {
    'use strict';
    var app = angular.module('app.specialAgreementJd.controller', ['ionic', 'app.handle.service', 'app.car.beans', 'app.directives', 'app.filters']);

    app.controller('specialAgreementJdController', function ($scope, $rootScope,$ionicPopup, $handleService,$interFace, $state, $stateParams,$carBeansService) {

        $scope.chooseData=[];//可选特约
        $scope.specialData=$rootScope.specialDataJd||[];//特约

        var Handle=function (handle) {
            handle.initPage=function () {
                if($stateParams.type=='sy'){
                    $scope.title='商业险特别约定';
                    angular.forEach($scope.specialData,function (item) {
                        if(item.riskCode=='0302'){
                            $scope.chooseData.push(item);
                        }
                    });

                }else{
                    $scope.title='交強险特别约定';
                    angular.forEach($scope.specialData,function (item) {
                        if(item.riskCode=='0301'){
                            $scope.chooseData.push(item);
                        }
                    })
                }

            };
            return handle;
        }(Handle || {});
        Handle.initPage();
        
    });
    return app;
});

