(function () {
   'use strict';
   var pathname = window.location.pathname,
      clientWidth = document.body.clientWidth;
   (function () { //默认初始化执行的方法
      var Controller = {
         initObjectHandle: function () {
            Date.prototype.format = function (format) {
               var o = {
                  "M+": this.getMonth() + 1, //month
                  "d+": this.getDate(), //day
                  "h+": this.getHours(), //hour
                  "m+": this.getMinutes(), //minute
                  "s+": this.getSeconds(), //second
                  "q+": Math.floor((this.getMonth() + 3) / 3), //quarter
                  "S": this.getMilliseconds() //millisecond
               }
               if (/(y+)/.test(format)) format = format.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
               for (var k in o)if (new RegExp("(" + k + ")").test(format))
                  format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
               return format;
            };
            //添加increment年
            Date.prototype.addYear = function (increment) {
               //  return new Date(this.getFullYear(), this.getMonth()+monthsIncrement, this.getDate());
               // var d1=new Date("2012/01/1 12:30:02");
               // var d2=new Date(d1);
               this.setFullYear(this.getFullYear() + increment);
               
               this.setSeconds(this.getSeconds() - 1);
               return this;
            };

            Date.prototype.addFullYear = function (increment) {
               //  return new Date(this.getFullYear(), this.getMonth()+monthsIncrement, this.getDate());
               // var d1=new Date("2012/01/1 12:30:02");
               // var d2=new Date(d1);
               this.setFullYear(this.getFullYear() + increment);

               this.setSeconds(this.getSeconds());
               return this;
            };
            //添加increment月
            Date.prototype.addMonth = function (increment) {
               return new Date(this.getFullYear(), this.getMonth() + increment, this.getDate());
            };
            Date.prototype.addDay = function (increment) {
               // t.setDate(t.getDate()+1)
               return new Date(this.getFullYear(), this.getMonth(), this.getDate() + increment);
            };
            Function.prototype.getName = function () {
               return this.name || this.toString().match(/function\s*([^(]*)\(/)[1]
            };
         }(),
         initParameter: function () { //1.存储请求参数-》到内存
            var strparam = decodeURIComponent(window.location.search),
               arrparam = [],
               parkeyv = [],
               objparam = {};
            if (strparam != '') {
               arrparam = strparam.split('?')[1].split('&');
               for (var i = 0; i < arrparam.length; i++) {
                  parkeyv = arrparam[i].split('=');
                  objparam[parkeyv[0]] = parkeyv[1];
               }
            }
            window.requestParam = objparam || {};
            window.sessionStorage.setItem('$linkParams', JSON.stringify(objparam) || {});
            // window.sessionStorage.setItem('SLS_INFO', JSON.stringify(objparam) || {});
         }()
      };
   })();

   $.fn.extend({
      ProgressBarWars: function (opciones) {
         var _self = this;
         var theidProgressBarWars = $(_self).attr("id");
         var styleUnique = Date.now();
         var StringStyle = "";
         var defaults = {
            text: "",
            porcentaje: "100",
            tiempo: 1000,
            color: "",
            estilo: "yoda",
            tamanio: "30%",
            alto: "6px",
            success: null
         };
         var opciones = $.extend({}, defaults, opciones);
         if (opciones.color != '') {
            StringStyle = "<style>.color" + styleUnique + "{ border-radius: 2px;display: block; width: 0%; box-shadow:0px 0px 10px 1px " + opciones.color + ", 0 0 1px " + opciones.color + ", 0 0 1px " + opciones.color + ", 0 0 1px " + opciones.color + ", 0 0 1px " + opciones.color + ", 0 0 1px " + opciones.color + ", 0 0 1px " + opciones.color + ";background-color: #fff;}</style>";
            opciones.estilo = "color" + styleUnique;
         }
         $(_self).before(StringStyle);
         $(_self).append('<span class="barControl" style="width:' + opciones.tamanio + ';"><div class="barContro_space"><span class="' + opciones.estilo + '" style="height: ' + opciones.alto + ';"  id="bar' + theidProgressBarWars + '"></span></div></span>');
         $(_self).append('<div class="pro-text">' + opciones.text + '</div>');
         $(_self).addClass("show-flex");
         $("#bar" + theidProgressBarWars).animate({width: opciones.porcentaje + "%"}, opciones.tiempo);
         this.mover = function (ntamanio) {
            $("#bar" + $(this).attr("id")).animate({width: ntamanio + "%"}, opciones.tiempo);
         };
         //动画执行完成后 执行 回调方法
         if (opciones.success) {
            window.setTimeout(function () {
               opciones.success();
            }, opciones.tiempo * 2);
         }
         return this;
      }
   });

   var Utils = {
      isEmpty: function (object) {
         if ((object == null
            || typeof(object) == "undefined")
            || (typeof(object) == "string" && object == "" && object != "undefined")
            || (typeof (object) == 'array' && object.length == 0)) {
            return true;
         } else if(typeof(object) == "string" && object.length > 0 ) {
            return false;
         }
         else if ($.isEmptyObject(object)) {
            return true;
         }
         else {
            return false;
         }
      },
      toArray: function (obj) {
         var arr = [];
         for (var item in obj) {
            arr.push(obj[item]);
         }
         return arr;
      },

      //获取完整机构代码 石梦星
      getDeptCode: function () {
         //新核心红包试算机构代码传新核心机构代码， isNewCoreFlag; //1：新核心标志， 0：老核心 newCoreDeptNo; //新核心机构代码 石梦星
         var slsInfo = JSON.parse(window.sessionStorage.getItem('SLS_INFO'));
         return slsInfo.deptCode;

      },

      //获取员工号
      getSlsCode: function() {
         var slsInfo = JSON.parse(window.sessionStorage.getItem('SLS_INFO'));
         return slsInfo.employCode;
      },
      //获取机构代码方法，机构代码前四位 false 是此机构，false不是此机构
      getDeptCodeNewFunc: function (a) {
         var slsInfo = JSON.parse(window.sessionStorage.getItem('SLS_INFO'));
         if ($U.isNotEmpty(slsInfo) && $U.isNotEmpty(slsInfo.deptCode)) {
            var sheader = slsInfo.deptCode.substr(0, 4);
            if(sheader==a){
	            return true;
            }
         }
         return false;
      },
      //获取两位机构标识，新核心需要截取3-4位，方便获取data文件夹的数据 石梦星
      getTwoDeptID: function () {
         //新核心取2-4位，旧核心区1-2位
         var slsInfo = JSON.parse(window.sessionStorage.getItem('SLS_INFO'));

            if ($U.isNotEmpty(slsInfo) && $U.isNotEmpty(slsInfo.deptCode)) {
               var sheader = slsInfo.deptCode.substr(2, 2);
               return sheader;

            }
      },
      isNotEmpty: function (object) {
         return !this.isEmpty(object);
      },
      getSession: function (key) {
         return window.sessionStorage.getItem(key);
      },
      sessionHandle: {
         saveSession: function (key, object) {
            if ($U.isNotEmpty(key)) {
               if(typeof object == "object"){
                  window.sessionStorage.setItem(key, JSON.stringify(object));
               }
               else {
                  window.sessionStorage.setItem(key, String(object));
               }
            }
         },
         getSession: function (key) {
            if ($U.isNotEmpty(key)) {
               var str_object = window.sessionStorage.getItem(key);
               try {
                  var obj = JSON.parse(str_object);
                  if(typeof obj == "object") { //如果是对象 那么返回对象，否则返回原数据
                     return obj;
                  }
                  return str_object;
               }
               catch (ex) {
                  return str_object;
               }
            }
         }
      },
      logger: function (text) {
         if(typeof text == "object"){
            text = JSON.stringify(text);
         }
         console.info('[' + (new Date).format('yyyy-MM-dd hh:mm:ss') + '] ' + text);
      },
      urlParam: function (name) {
         var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
         var r = window.decodeURIComponent(window.location.search).substr(1).match(reg);  //匹配目标参数
         if (r != null) return unescape(r[2]);
         return null; //返回参数值
      },
      randomString: function (length) {
         var length = length || 32,
            chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678',
            maxPos = chars.length,
            pwd = '';
         for (var i = 0; i < length; i++) {
            pwd += chars.charAt(Math.floor(Math.random() * maxPos));
         }
         return pwd;
      },
      timeStamp: function () {
         return new Date().getTime();
      },
      objSize: function (obj) {
         var size = 0, key;
         if (typeof obj === 'object') {
            for (key in obj) {
               if (obj.hasOwnProperty(key))
                  size++;
            }
         }
         return size;
      },
      showToast: function (text) {
         var tostId = this.randomString(),
            toast = $('<div id="' + tostId + '" class="app-toast"><a>' + text + '</a></div>').appendTo('body').fadeIn(500);
         window.setTimeout(function () {
            toast.fadeOut(1000);
            window.setTimeout(function () {
               toast.remove();
            }, 1000);
         }, 1800);
      },
      extend: function (options, opts) {
         for (var param in opts) {
            options[param] = opts[param];
         }
      },
      isPathName: function (params) {
         if (this.isNotEmpty(params)) {
            return pathname.indexOf(params) > -1 ? true : false;
         }
         return false;
      },
      /**
       *   格式化报价金额，保留几位小数(toFixed是五舍六入)，默认是两位小数，返回的是String类型
       *   premium: 要处理的数值，必选，数值或字符串类型，如：45.62或"45.62";
       *   format:  保留的小数位，可选，整数，默认是2，保留两位小数。
       *   autoNumber : 是否强制parseFloat返回，有的话，则为转化成数值类型，但这样的话类似1.00会转成1，去掉了小数点后的00
       */
      formatPremium: function (premium, format, autoNumber) {
         var newPre = (new Number(premium)).toFixed(format || (format == 0 ? 0 : 2));
         return autoNumber ? Number(newPre) : newPre;
      },
      
      /**
       * [formatNumber 千位分隔符]
       */
      formatNumber: function (num) {
         return (num + '').replace(/(^|\s)\d+(?=\.?\d*($|\s))/g, (parseInt(num + '') + '').replace(/(?=(?!\b)(\d{3})+\.?\b)/g, ','));
      },

      /**
       *  计算两个字符串日期之间相差的天数
       */
      daysBetween: function (day1, day2, splitFormat) {
         var self = this;
         if (typeof day1 == 'string' && typeof day2 == 'string') {
            splitFormat = splitFormat ? splitFormat : "-";
            var arrD1 = day1.split(splitFormat);
            var arrD2 = day2.split(splitFormat);
            if (arrD1 && arrD2) {
               var oDay1 = new Date(arrD1[0], arrD1[1] - 1, arrD1[2]);
               var oDay2 = new Date(arrD2[0], arrD2[1] - 1, arrD2[2]);
               var days = (oDay1.getTime() - oDay2.getTime()) / (1000 * 60 * 60 * 24);
               return self.formatPremium(days, 0);
            }
         }
      },
      /**
       *  数组去重
       */
      duplicateRemoval: function (arr) {
         var n = [];
         for (var i = 0; i < arr.length; i++) {
            if (n.indexOf(arr[i]) == -1) {
               n.push(arr[i]);
            }
         }
         return n;
      },
      /*解决除法浮点数问题*/
      accDiv: function (arg1,arg2){
         var t1=0,t2=0,r1,r2;
         try{t1=arg1.toString().split(".")[1].length}catch(e){}
         try{t2=arg2.toString().split(".")[1].length}catch(e){}

            r1=Number(arg1.toString().replace(".",""));
            r2=Number(arg2.toString().replace(".",""));

            //调用自身乘法运算
            return Utils.accMul((r1/r2), Math.pow(10,t2-t1));
      },
      /*解决乘法浮点数问题*/
      accMul: function (arg1,arg2) {
         var m=0,s1=arg1.toString(),s2=arg2.toString();
         try{m+=s1.split(".")[1].length}catch(e){}
         try{m+=s2.split(".")[1].length}catch(e){}
         return Number(s1.replace(".",""))*Number(s2.replace(".",""))/Math.pow(10,m);
      },
      accAdd: function(arg1,arg2){
         var r1,r2,m;
         try{r1=arg1.toString().split(".")[1].length}catch(e){r1=0}
         try{r2=arg2.toString().split(".")[1].length}catch(e){r2=0}
         m=Math.pow(10,Math.max(r1,r2));
         return Utils.accDiv((Utils.accMul(arg1,m)+Utils.accMul(arg2,m)),m)
      },
      //根据身份证号获取年龄
      GetAgeFromIdCard :function (identityCard) {
      var len = (identityCard + "").length;
      if (len == 0) {
         return 0;
      } else {
         if ((len != 15) && (len != 18))//身份证号码只能为15位或18位其它不合法
         {
            return 0;
         }
      }
      var strBirthday = "";
      if (len == 18)//处理18位的身份证号码从号码中得到生日和性别代码
      {
         strBirthday = identityCard.substr(6, 4) + "/" + identityCard.substr(10, 2) + "/" + identityCard.substr(12, 2);
      }
      if (len == 15) {
         strBirthday = "19" + identityCard.substr(6, 2) + "/" + identityCard.substr(8, 2) + "/" + identityCard.substr(10, 2);
      }
      //时间字符串里，必须是“/”
      var birthDate = new Date(strBirthday);
      var nowDateTime = new Date();
      var age = nowDateTime.getFullYear() - birthDate.getFullYear();
      //再考虑月、天的因素;.getMonth()获取的是从0开始的，这里进行比较，不需要加1
      if (nowDateTime.getMonth() < birthDate.getMonth() || (nowDateTime.getMonth() == birthDate.getMonth() && nowDateTime.getDate() < birthDate.getDate())) {
         age--;
      }
      return age;
   },
   getIdCardInfo: function(cardNo){
         var now = new Date();
         var year = now.getFullYear(), month = parseInt(now.getMonth()+1,10), day = parseInt(now.getDate(),10);
         var sex = '01', birthday = year + '-' + month + '-' + day, age = 0;
         if (cardNo.length == 15) {
           var re_fifteen = /^(\d{6})(\d{2})(\d{2})(\d{2})(\d{3})$/;
           var arr_data = cardNo.match(re_fifteen);
           year = '19' + arr_data[2];
           month = arr_data[3];
           day = arr_data[4];
           //获取性别
           if (parseInt(cardNo.substr(14, 1)) % 2 == 1) {
             //男
             sex = "01";
           } else {
             //女
             sex = "02";
           }
         } else if (cardNo.length == 18) {
           //获取出生日期
           year = cardNo.substring(6, 10);
           month = cardNo.substring(10, 12);
           day = cardNo.substring(12, 14);
           if (parseInt(cardNo.substr(16, 1)) % 2 == 1) {
             //男
             sex = "01";
           } else {
             //女
             sex = "01";
           }
         }

         birthday = year + '-' + month + '-' + day;
       
         var myDate = new Date();
         var myMonth = myDate.getMonth() + 1;
         var myDay = myDate.getDate();
         var age = myDate.getFullYear() - year - 1;
         if (month < myMonth || month == myMonth && day <= myDay) {
             age++;
         }
         return {
            age: age,
            sex: sex,
            birthday: birthday
         };
      },
      //根据生日获取年龄
      GetAgeFromBirthday :function (strBirthday){
      strBirthday = strBirthday || "";
      var returnAge;
      var strBirthdayArr=strBirthday.split("-");
      var birthYear = strBirthdayArr[0];
      var birthMonth = strBirthdayArr[1];
      var birthDay = strBirthdayArr[2];

      var d = new Date();
      var nowYear = d.getFullYear();
      var nowMonth = d.getMonth() + 1;
      var nowDay = d.getDate();

      if(nowYear == birthYear){
         returnAge = 0;//同年 则为0岁
      }
      else{
         var ageDiff = nowYear - birthYear ; //年之差
         if(ageDiff > 0){
            if(nowMonth == birthMonth) {
               var dayDiff = nowDay - birthDay;//日之差
               if(dayDiff < 0)
               {
                  returnAge = ageDiff - 1;
               }
               else
               {
                  returnAge = ageDiff ;
               }
            }
            else
            {
               var monthDiff = nowMonth - birthMonth;//月之差
               if(monthDiff < 0)
               {
                  returnAge = ageDiff - 1;
               }
               else
               {
                  returnAge = ageDiff ;
               }
            }
         }
         else
         {
            returnAge = -1;//返回-1 表示出生日期输入错误 晚于今天
         }
      }

      return returnAge;//返回周岁年龄

   },
   //身份证校验
      IdCodeValid:function(code){
         //身份证号合法性验证
         //支持15位和18位身份证号
         //支持地址编码、出生日期、校验位验证
         var city={11:"北京",12:"天津",13:"河北",14:"山西",15:"内蒙古",21:"辽宁",22:"吉林",23:"黑龙江 ",31:"上海",32:"江苏",33:"浙江",34:"安徽",35:"福建",36:"江西",37:"山东",41:"河南",42:"湖北 ",43:"湖南",44:"广东",45:"广西",46:"海南",50:"重庆",51:"四川",52:"贵州",53:"云南",54:"西藏 ",61:"陕西",62:"甘肃",63:"青海",64:"宁夏",65:"新疆",71:"台湾",81:"香港",82:"澳门",91:"国外 "};
         var row={
            'pass':true,
            'msg':'验证成功'
         };
         if(!code || !/^\d{6}(18|19|20)?\d{2}(0[1-9]|1[012])(0[1-9]|[12]\d|3[01])\d{3}(\d|[xX])$/.test(code)){
            row={
               'pass':false,
               'msg':'身份证号格式错误'
            };
         }else if(!city[code.substr(0,2)]){
            row={
               'pass':false,
               'msg':'身份证号地址编码错误'
            };
         }else{
            //18位身份证需要验证最后一位校验位
            if(code.length == 18){
               code = code.split('');
               //∑(ai×Wi)(mod 11)
               //加权因子
               var factor = [ 7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2 ];
               //校验位
               var parity = [ 1, 0, 'X', 9, 8, 7, 6, 5, 4, 3, 2 ];
               var sum = 0;
               var ai = 0;
               var wi = 0;
               for (var i = 0; i < 17; i++)
               {
                  ai = code[i];
                  wi = factor[i];
                  sum += ai * wi;
               }
               if(parity[sum % 11] != code[17].toUpperCase()){
                  row={
                     'pass':false,
                     'msg':'身份证号校验位错误'
                  };
               }
            }
         }
         return row;
      },
      // 0910新增地址信息校验
      checkAddress: function (opt) {
         var opts = {
            person: '',
            address: '',
            maxLength: 120,
            minLength: 12,
            limitLength: 60
         }
         var res = {
            chkres: true,
            errmsg: '',
         }
         opts = angular.extend(opts, opt);
         // var notAllowReg = /[\^、\&？\n、.......$￥；”]/;
         //不少于6个汉字或者12个英文字符，长度最多不能超过60个汉字或字符（一个中文2个字节）
         var chinesChar = /[\u4e00-\u9fa5]/; //中文字符
         var l = 0;
         angular.forEach(opts.address, function (item, index) {
            if (chinesChar.test(item)) {
               l += 2;
            } else {
               l++;
            }
         })
         var len = opts.address.length || 0; //不区分中英文字符
         if (len > opts.limitLength) {
            return {
               chkres: false,
               errmsg: opts.person + '地址长度为' + len + '，但是期望的最大长度为' + (opts.limitLength)
            };
         } else if (l < opts.minLength) {
            return {
               chkres: false,
               errmsg: opts.person + '地址不能少于' + (opts.minLength / 2) + '个汉字或' + opts.minLength + '位字符！'
            };
         }
         return res;
      },
   };
   window.Utils = window.$U = Utils;
   return Utils;
})();
