(function (window) {
   var appUpdate = {
      initialize: function () {
         window.IonicApp = {
            versionTooLow:false
         };
         this.bindEvents();
      },
      bindEvents: function () {
         document.addEventListener('chcp_updateLoadFailed', this.onUpdateLoadError, false);
      },
      onUpdateLoadError: function (event) {
         var error = event.detail.error;
         // 当检测出内核版本过小
         if (error && error.code == chcp.error.APPLICATION_BUILD_VERSION_TOO_LOW) {
            window.IonicApp.versionTooLow = true;
            window.IonicApp.versionError = error;
         }
      }
   };
   window.appUpdate = appUpdate;
})(window);
