define(['services/app.service', 'services/app.general.service', 'services/app.car.beans', 'directives/app.directives','filters/app.filters' ,'services/app.store'], function () {
    'use strict';
    var app = angular.module('app.deliveryRelationSuccess.controller', ['ionic', 'app.handle.service', 'app.directives','app.filters', 'app.general.service','ionic']);
    //投保查询控制器
    app.controller('deliveryRelationSuccessController', function ($generalService, $ionicPopup, $scope, $rootScope, $state, $stateParams, $handleService, $interFace,$location, store) {

        var Handle = (function (handle) {
            handle.initPage = function() {
            };
    
            return handle;
        })(Handle || {});
        $scope.kdClipboard = function() {
            //复制
            var options = {
                doms: ".copy-btn",
                text: "快递公司："+$rootScope.relationInfo.companyName+"；快递单号："+$rootScope.relationInfo.logisticCode,
                success: function () {
                    $U.showToast('快递单号复制成功')
                },
                error: function () {
                    $U.showToast('快递单号号复制失败,请手动复制')
                }
            };
            $handleService.copyClipboard(options);
        }
        Handle.initPage();
    });
    return app;
});