define([
    'services/app.service',
    'services/app.store',
    'services/app.general.service',
    'services/app.car.beans',
    'directives/app.directives'], function () {
    'use strict';
    var app = angular.module('app.motoCarSearch.controller', ['ionic', 'ngCordova', 'app.handle.service', 'app.general.service','app.directives', 'app.store','app.car.beans']);

    app.controller('motoCarSearchController', function ($rootScope, $scope,$generalService, $handleService, $cordovaFileTransfer, $interFace, $state,$http,$stateParams,$carBeansService) {

        $scope.data = $rootScope.motoRiskData;

        if($scope.data.riskList && $scope.data.riskList.length > 0) {
            angular.forEach($scope.data.riskList, function(item, index) {
               if(item.riskCode == "0301") {
                   $scope.data.jqRisk = item;
               } else if(item.riskCode == "0302") {
                   $scope.data.syRisk = item;
               }
            });
        }

        //续保
        $scope.runBefore = function () {
            $generalService.renewalParam($rootScope.motoRiskData);
            //交强险起期赋值
            // if($scope.data.jqRisk.startDate) {
            //     if($scope.data.jqRisk.effectFlag == "1") { //即时生效
            //         $rootScope.MotoCAR.INSRNC_BGN_TM_JS_JQ = $scope.data.jqRisk.startDate;
            //         $rootScope.MotoCAR.INSRNC_BGN_TM_JQ = '';
            //     } else {
            //         $rootScope.MotoCAR.INSRNC_BGN_TM_JQ = $scope.data.jqRisk.startDate;
            //         $rootScope.MotoCAR.INSRNC_BGN_TM_JS_JQ = '';
            //     }
            //
            //     //暂时规避即时起保问题
            //     $rootScope.MotoCAR.riskList[0].effectFlag2 = ($scope.data.jqRisk.effectFlag == "1");
            //     /*if(!$rootScope.MotoCAR.riskList[0].vhlTax) {
            //         $rootScope.MotoCAR.riskList[0].vhlTax = {};
            //     }
            //     $rootScope.MotoCAR.riskList[0].vhlTax.taxRelifFlag = $rootScope.MotoCAR.riskList[1].vhlTax.taxRelifFlag*/
            // }

            $state.go("tab.motoIndex");
        }

    });
    return app;
});

