    define([
        'services/app.service',
        'services/app.general.service',
        'directives/app.directives',
        'filters/app.filters',
        'services/app.sqlLite.service',
        'services/app.car.beans',
        'modalSelect',
        'ngUpload'
    ],
    function () {
        'use strict';
        var app = angular.module('app.motoInsurance.controller', [
            'app.handle.service',
            'app.general.service',
            'app.directives',
            'app.filters',
            'app.sqlLite.service',
            'app.car.beans',
            'ionic-modal-select',
            'ngCordova',
            'ngFileUpload'
        ]);
        //表单控制器
        app.controller('motoInsuranceController', function ($state,$scope, $rootScope, $http, $location, $handleService,$generalService, $interFace,$ionicHistory, $compile, $ionicActionSheet, $cordovaCamera, $sqlSQLiteService,Upload, $carBeansService,$timeout,$stateParams) {
            //----------------------------------------begin 变量-------------------------------------------//
            //从提核报价页返回，如果开通电子发票按默类型传 标识
            // $rootScope.motoNextPage = false;
            //路由
            $scope.$on('$stateChangeSuccess', function (ev, to, toParams, from, fromParams) {
                $rootScope.nextPage = to;
                $rootScope.prePage = from; //from为前一个页面的路由信息：url,cache,views,name
                //从提核报价页返回，如果开通电子发票按默类型传 标识
                // console.log($rootScope.nextPage.name,'$rootScope.nextPage.name')
                if($rootScope.nextPage&&$rootScope.nextPage.name=='tab.motoIndex'){
                    $rootScope.motoNextPage = true;
                }else{
                    $rootScope.motoNextPage = false;
                }
            });
            // console.log($rootScope.motoNextPage,'$rootScope.motoNextPage');
            var nowDate = new Date().format('yyyy-MM-dd hh:mm:ss');
            //即时生效时间
            $scope.MotoCAR.INSRNC_BGN_TM_JS_JQ = $rootScope.MotoCAR.INSRNC_BGN_TM_JS_JQ || nowDate;

            $scope.MotoCAR.INSRNC_BGN_TM_JQ = $rootScope.MotoCAR.INSRNC_BGN_TM_JQ || nowDate;
            // start
            /********************定义变量*************************/
            console.log('quote-info-$rootScope.carBeans.noCarProductList',$rootScope.carBeans.noCarProductList);
            //单保责任险标志
            $scope.pageCode = $stateParams.SU_CODE||''; //页面参数
            $scope.carCheckFlag = ($rootScope.carBeans.vehicle.carCheckReason == "1");
            $scope.calPremiumResult = { }; //保费试算保费结果
            $scope.hasCalPremiunFlagMoto = $rootScope.hasCalPremiunFlagMoto = false; //保费试算成功标志
            $scope.calResultData = {}; //保费试算结果
            $rootScope.MotoCAR.seatCount = 1; // 摩托车非车险1座$rootScope.carBeans.vehicle.seatCount
            $rootScope.calMoto =true;
            $scope.noNext=false;//保费小于0，不允许下一步管控
            $scope.jqTaxType = '';//平台返回交强险纳税类型
            $rootScope.reCalPremiumFlagMoto = false; //重新计算标志

            $rootScope.renewalPolicyType = false; //是否选择上年方案
            $rootScope.hasRenewalPolicy = false; //是否带出上年方案
            $scope.isGuangxi = $rootScope.IS_GUANGXI_05; //是否是广西 特殊化处理

            $scope.verCodeObj = {}; //存转保答案

            $scope.CAR_CONFITM_FLAG=false;  //两号弹层
            $scope.showMsg=true;  //验证有误提示语
            $scope.CAR_CONFIRM_SECTION=true; //两号查询弹层内容显示隐藏
            $scope.permitFalse=0;   //两号容错标记
            $scope.msgText='请补充完整车架号和发动机号后重新报价';

            $scope.hasPrevLoading = false; //带出上年方案loading
            $scope.isSelectCar = false; //是否显示车型编码
            $scope.VHL_LIST = [];
            $rootScope.fromMotoFlag = false; // 标记从moto进入,默认否
            $rootScope.goNextDisabledMoto = true; // 标记禁止提交按钮是否可用,默认禁止
            
            $rootScope.calResultData4repeatInsure = null; //报价结果供冲突投保页使用
            // 上一单购买的非车产品
            if($rootScope.switchBean.noCarPrdSwitch){
                $scope.preBuyedNocarList  =  $rootScope.carBeans.noCarProductList || [];
            }else{
                $scope.preBuyedNocarList  =  $rootScope.carBeans.noCarRiskList || [];
            }
            // 如果开通电子发票且是新保的且没有从本页面返回上一页修改 默认显示电子发票，
            if($rootScope.switchBean.motoElecInvoice && !$scope.pageCode && !$rootScope.motoNextPage){
                $rootScope.MotoCAR.applicant.invtype = '2';
            }

            var Handle=(function (handle) {
                 //设置险种保费
                 handle.setPremium = function(riskList) {
                     $rootScope.calPremiumResult = $scope.calPremiumResult = {}; //保存计算后的商业险保费
                     var deductiblePremium = 0; //不计免赔
                     angular.forEach(riskList, function(riskItem) {
                         if(riskItem.riskCode == "0302") {
                             //遍历商业险
                             angular.forEach(riskItem.coverageList, function(coverageItem, index) {
                                 if(coverageItem.relatedInd == '1') {
                                     deductiblePremium = $U.accAdd(deductiblePremium,coverageItem.nonDeductiblePremium||'0');
                                 }
                                 //险种金额
                                 $scope.calPremiumResult[coverageItem.kindCode] = coverageItem;
                             });

                             //存储商业险信息
                             $scope.calPremiumResult.syCalData = riskItem;
                             console.log($scope.calPremiumResult.syCalData,'666666');
                             //商业险系数
                             $scope.calPremiumResult.syAdjustInfo = riskItem.riskItemList;
                             //商业险总折扣
                             $scope.calPremiumResult.applySumDiscount = riskItem.applySumDiscount;
                             //商业险总价
                             $scope.calPremiumResult.syTotalPremium =  (riskItem.sumGrossPremium||"0");

                         } else if(riskItem.riskCode == "0301") {
                             //存储交强险信息
                             $scope.calPremiumResult.jqCalData = riskItem;
                             //交强险浮动系数
                             $scope.calPremiumResult.jqAdjustInfo = riskItem.floatInfo;
                             //交强险总折扣
                             $scope.calPremiumResult.jqApplySumDiscount = riskItem.applySumDiscount;
                             //交强险保费
                             $scope.calPremiumResult.jqTotalPremium = (riskItem.sumGrossPremium||"0");
                             //车船税
                             $scope.calPremiumResult.vhlTax = (riskItem.vhlTax||"0");
                         }
                     });
                     //不计免赔总价
                     $scope.calPremiumResult.deductible = deductiblePremium;

                     //非车险种保费
                     $scope.nocarTotalPremium = $scope.calResultData.base.noCarSumPremium||'0';

                     //非车险种
                     if($rootScope.switchBean.noCarPrdSwitch){
                         $rootScope.noCarRiskList = $scope.calResultData.noCarProductList || [];
                     }else{
                         $rootScope.noCarRiskList = $scope.calResultData.noCarRiskList || [];
                     }
                };
                // 请求start
                //获取非车险种
                handle.getNocarList = function() {
                    var nocartempList =[];
                    // //投保人为个人，使用性质非营运，车辆种类客车，核定座位数<=7 并且不是短期商业险
                    var has0621 = $rootScope.carBeans.base.busiAttrConfig.attachNatures=='01'&& $rootScope.carBeans.base.busiAttrConfig.useNatures == "02" && ($rootScope.baseBean.ownerAge >=18 &&$rootScope.baseBean.ownerAge <=70)&& $rootScope.carBeans.vehicle.carKindCode == "100" && Number($rootScope.MotoCAR.seatCount) <= 7 && (!$rootScope.baseBean.shortSY &&!$rootScope.baseBean.shortJQ);
                    var has0601 = $rootScope.carBeans.base.busiAttrConfig.attachNatures=='01'&& $rootScope.carBeans.base.busiAttrConfig.useNatures == "02" && ($rootScope.baseBean.ownerAge >=18 &&$rootScope.baseBean.ownerAge <=70)&& $rootScope.carBeans.vehicle.carKindCode == "100" &&(!$rootScope.baseBean.shortSY && !$rootScope.baseBean.shortJQ);
                    var has0107 = $rootScope.carBeans.base.busiAttrConfig.attachNatures=='01'&& $rootScope.carBeans.base.busiAttrConfig.useNatures == "02" &&  $rootScope.carBeans.vehicle.carKindCode == "100" &&(!$rootScope.baseBean.shortSY && !$rootScope.baseBean.shortJQ);

                    //当不满足非车标志时  不获取非车产品信息
                    // if(!hasNocarFlag) {
                    //     $scope.nocarList = [];
                    //     return;
                    // }
                    var riskStr = "";
                    if($rootScope.baseBean.jqOrigFlag && $rootScope.baseBean.syOrigFlag) {
                        riskStr = "";
                    } else if($rootScope.baseBean.jqOrigFlag) {
                        riskStr = "0301";
                    }
                    else if($rootScope.baseBean.syOrigFlag) {
                        riskStr = "0302";
                    }
                    var optionsOld = {
                        productCode: '04',//机动车传01，摩托车传04
                        applyRiskCode: riskStr,//险种代码
                        companyCode: $U.getDeptCode() // 机构代码
                    }
                    $handleService.http({
                        url: "/queryNoCarRationInfo",
                        data: optionsOld,
                        success: function(data) {
                            $handleService.logger("object", data, "获取非车险种");
                            if(data.resultCode == "0") {
                                nocartempList =  angular.copy(data.result||[]);
                                for(var i = 0;i<nocartempList.length;i++){
                                    if(nocartempList[i].riskCode=='0621'&& !has0621){
                                        nocartempList.splice(i, 1) ;
                                        i--;
                                        continue;
                                    }
                                    if(nocartempList[i].riskCode=='0601' && !has0601){
                                        nocartempList.splice(i, 1) ;
                                        i--;
                                        continue;
                                    }
                                    if(nocartempList[i].riskCode=='0107'&& !has0107){
                                        nocartempList.splice(i, 1) ;
                                        i--;
                                        continue;
                                    }
                                }
                                $handleService.logger("object", nocartempList, "非车险种条件过滤");
                                $scope.nocarList =  nocartempList ||[];
                                angular.forEach($scope.nocarList, function(item){
                                    item.waxBatch = item.waxBatch || 1;
                                    item.checked = false;
                                    if(item.calType == "2") {
                                        item.totalPremium = item.premium * $rootScope.MotoCAR.seatCount * Number(item.waxBatch);
                                    } else {
                                        item.totalPremium = item.premium * Number(item.waxBatch);
                                    }
                                });
                                Handle.initCheckedNocarList();
                            }

                        }
                    })
                }
                //获取非车险种 ---> 新交叉销售
                handle.getNocarListNew = function() {
                var nocartempList =[];
                var optionsNew = {
                    departmentCode: $U.getDeptCode(), // 机构代码,
                    useNature: $rootScope.carBeans.base.busiAttrConfig.useNatures, //使用性质
                    attachNature: $rootScope.carBeans.base.busiAttrConfig.attachNatures, //所属性质
                    tonCount:  $rootScope.carBeans.vehicle.tonCount, //吨位
                    seatCount: '1', //核定载客数
                    vehicleType: '400'
                };
                $handleService.http({
                    url: '/queryNoCarProducts',
                    data: optionsNew,
                    // data: {
                    //     "departmentCode": "0102010101",
                    //     "useNature": "02",
                    //     "attachNature": "01",
                    //     "vehicleType": "400"
                    //   },
                    success: function(data) {
                        $handleService.logger("object", data, "获取非车险种");
                        if(data.resultCode == "0") {
                            nocartempList =  angular.copy(data.result||[]);
                            angular.forEach(nocartempList,function(exItem){
                                // 修改exItem是为了让页面展示的正确
                                //exItem.clauseText = exItem.rationList[0].clauseText || clauseTextO[exItem.productCode]; // 默认选择方案一 所以[0]
                                exItem.maxBatch = exItem.rationList[0].maxBatch; // 默认选择方案一 所以[0]
                                exItem.waxBatch = exItem.waxBatch || 1; //默认份数
                                exItem.checked = false; // 默认不选中
                                if(exItem.calType == "2") {// 默认保费
                                    exItem.totalPremium = exItem.premium * $rootScope.MotoCAR.seatCount * Number(exItem.waxBatch) ;
                                } else {
                                    exItem.totalPremium = exItem.premium * Number(exItem.waxBatch);
                                }
                                // 修改inItem是为了报价传的险种信息正确
                                angular.forEach(exItem.rationList,function(inItem){
                                    inItem.productCode = exItem.productCode;
                                    inItem.productName = exItem.riskName;
                                    inItem.actualPremiumAmt = inItem.premium;
                                    inItem.releaiton = ["0107", "0840"].indexOf(inItem.riskCode) != -1 ? "0" : "14";
                                    inItem.noCarProductCoverage = inItem.noCarCoverageList;
                                })
                            });
                            $scope.nocarList =  nocartempList ||[];
                            // 特殊处理详情返回
                            if($rootScope.fromDetialsFlag){
                                $rootScope.MotoCAR.riskList[0].startDate2 = $rootScope.MotoCAR.startDate.replace(/\//g,'-');
                                $rootScope.fromDetialsFlag = false;
                            }
                            Handle.initCheckedNocarList();
                        }

                    }
                })
            }
                // 通过从暂存单带过来的信息或者其他地方缓存的信息, 初始化选中的非车产品
                console.log('$scope.preBuyedNocarList',$scope.preBuyedNocarList);
                handle.initCheckedNocarList = function(){
                    angular.forEach($scope.nocarList,function(exItem){ // 第一层: 循环可以购买的非车产品
                        angular.forEach($scope.preBuyedNocarList,function(inItem){ // 第二层: 循环缓存里已购买的非车产品
                            if(exItem.riskCode == inItem.riskCode){// 确定购买的产品
                                //循环捞出最大份数 和  noCarCoverageList
                                angular.forEach(exItem.rationList,function(inInItem){ // 可购买险种的方案list  match  缓存里已购买的非车产品
                                    if(inItem.rationCode == inInItem.rationCode){
                                        exItem.maxBatch = inInItem.maxBatch;  // 第三层
                                        exItem.noCarCoverageList = inInItem.noCarCoverageList;  // 第三层
                                        exItem.noCarProductCoverage = inInItem.noCarCoverageList;  // 第三层
                                        inItem.noCarCoverageList = inInItem.noCarCoverageList;  // 第三层
                                        inItem.noCarProductCoverage = inInItem.noCarCoverageList;  // 第三层
                                        $rootScope.nocarArr.push(inItem);
                                        exItem.checked = true;
                                        // 为了让页面展示正确
                                        exItem.waxBatch = inItem.waxBatch || 1; // 第二层  伍念bug修改
                                        exItem.calType  = inItem.calType;
                                        exItem.rationCode  = inItem.rationCode;
                                        exItem.premium  = inItem.premium || inItem.actualPremiumAmt;
                                       // exItem.clauseText = inItem.clauseText || clauseTextO[exItem.productCode];
                                        //非车险种保费显示
                                        if(exItem.calType == "2") {
                                            exItem.totalPremium =  Number(exItem.premium) * Number($rootScope.MotoCAR.seatCount) * Number(exItem.waxBatch);
                                        } else {
                                            exItem.totalPremium =  Number(exItem.premium) * Number(exItem.waxBatch);
                                        }
                                    }
                                });
                            }
                        });
                    });
                    console.log('$scope.nocarList',$scope.nocarList);

                };
                // 请求end
                handle.validateEvent = function () {
                    var vhls = $rootScope.MotoCAR.vehicle.frameNo;
                    //判断查询条件 非空再调用接口
                    if ($U.isEmpty(vhls)) {
                        $U.showToast('请输入车架号');
                        return false;
                    }
                    else {
                        //非两号时验证车架号
                        if(!/^[a-z0-9A-Z]+$/.test(vhls)) {
                            $U.showToast('车架号输入错误');
                            return;
                        }
                        var isReach = vhls.indexOf("I") + vhls.indexOf("O") + vhls.indexOf("Q");
                        if ($U.isEmpty($rootScope.MotoCAR.vehicle.brandName)) {
                            $U.showToast('请输入品牌型号');
                            return false;
                        }
                        else if (isReach > -3) { //车架号 不包含 I O Q
                            $U.showToast('您的车架号输入不正确');
                            return false;
                        }
                        else if ($U.isEmpty($rootScope.MotoCAR.vehicle.singeinDate)) {
                            $U.showToast('请选择初登日期');
                            return false;
                        }
                    }
                    return true;
                };
                handle.submitVali = function () {
                    //手机号验证规则
                    var regphone =/^([1][3-9][0-9]{9})$|^((\d){3}(\*){4}(\d){4})$/,
                        regtel =/^0\d{2,3}-?\d{7,8}$|^0\d{2}(\*){4,5}\d{4}$/;
                    //车型选择校验
                    if ($U.isEmpty($rootScope.MotoCAR.vehicle.brandName)) { //如果车型代码为空 未选择车型
                        $U.showToast('请选择车型');
                        return false;
                    }
                    var reg=/^[0-9]$/;
                    if(!reg.test($rootScope.MotoCAR.vehicle.seatCount)){
                        $U.showToast('仅限10座以下家庭自用客车投保！');
                        return false;
                    }
                    if($rootScope.MotoCAR.vehicle.seatCount<=0){
                        $U.showToast('仅限10座以下家庭自用客车投保！');
                        return false;
                    }
                    if($rootScope.MotoCAR.vehicle.exhaustScale<0){
                        $U.showToast('排量不可小于0');
                        return false;
                    }
                    if($rootScope.switchBean.motoElecInvoice&&$rootScope.MotoCAR.applicant.mobilePhone){
                        var num =$rootScope.MotoCAR.applicant.mobilePhone;
                        if($rootScope.MotoCAR.applicant.invtype == '2' && !regphone.test(num)){
                            $U.showToast('请输入11位电子发票手机号码');
                            return false;
                        }else if(!regphone.test(num)&& !regtel.test(num)){
                            $U.showToast('请输入11位手机号码或者区号+座机格式电子发票联系电话');
                            return false;
                        }
                    }
                    return true;
                };
                //返回首页 方法  --》全民营销 不需要跳转
                handle.goIndex = function () {
                    if (!window.requestParam.webSources) {
                        // //判断新首页可见性
                        // if($rootScope.isNewHome){
                        //     $state.go("tab.mitNewIndex");
                        // }else{
                        //     $state.go("tab.mitIndex");
                        // }
                        $state.go("tab.mitNewIndex");
                    }else{
                        $state.go("tab.motoIndex");
                    }
                };
                handle.motoHandle= function (data) {
                    //赋值-》车牌号
                    // $rootScope.CAR_BEANS.LCN_NO = data.vehicle_license_main_plate_num;
                    //赋值-》车架号
                    $rootScope.MotoCAR.vehicle.frameNo = data.vehicle_license_main_vin;
                    //赋值-》发动机号
                    $rootScope.MotoCAR.vehicle.engineNo = data.vehicle_license_main_engine_no;
                    //赋值-》品牌型号
                    $rootScope.MotoCAR.vehicle.brandName = data.vehicle_license_main_model;
                    //赋值-》发证日期
                    $rootScope.MotoCAR.vehicle.singeinDate = data.vehicle_license_main_register_date;
                    //赋值-》车主地址
                    $rootScope.MotoCAR.owner.address = data.address;
                    //给车型查询条件 赋值
                    // $rootScope.CAR_BEANS.CAR_SEARCH_INFO = data.vehicle_license_main_model;
                };
                handle.payHttp=function (opt,isLocation) {
                    $handleService.motoHttp({
                        url: $interFace.motoMainFace,
                        method: 'POST',
                        headers: {
                            method: 'payment'
                        },
                        data: opt,
                        success: function (data) {
                            $handleService.logger('object', data, '提交支付成功--》返回结果数据');
                            if(data.resultCode=='0'){
                                //增加逻辑  支付号包含 18HAIC 的，sysCode 传 08
                                var haicFlag = data.result.indexOf("18HAIC") > 0;
                                //第三方 页面 全部走新支付  渠道地址 传 06 写死
                                var payPath = "",
                                    payChannel = "&PayChannel=06",
                                    sysCode = "&sysCode" + haicFlag ? "08" : "06";
                                //直通支付 全民营销 需要添加 sysCode=05
                                if (window.requestParam.webSources) {
                                    payPath = $interFace.policyNewPay + data.result + payChannel + "&sysCode=" + (haicFlag ? "08" : "05");
                                }
                                else {
                                    payPath = $interFace.policyNewPay + data.result + payChannel + sysCode;
                                }

                                $handleService.logger("info", "支付跳转地址是:" + payPath);
                                //开始调支付
                                if (isLocation) {
                                    $handleService.openUrl(payPath, {
                                        shareFlag: false
                                    });
                                }
                                else {
                                    $handleService.showAlert('申请支付号',data.result,function () {
                                        Handle.goIndex();
                                    })
                                }

                            }
                            else{
                                $U.showToast(data.errorMsg);
                            }
                        },
                        error: function (ex, status) {
                            $handleService.logger('error', '支付异常' + status);
                        }
                    });
                };
                handle.queryCalList= function (opts) {
                    var options ={
                        companyCode: "",//机构代码
                        engineNo: "",//发动机号
                        frameNo: "",//车架号
                        licenseNo: "",//车牌号
                        modelCode: "",//车型代码
                        modelName: "",//	车型名称
                        registerDate: "",//初登日期
                        carKindCode: "400" //查询摩托车
                    };

                    angular.extend(options,opts);
                    //开始查询
                    $handleService.motoHttp({
                        url: $interFace.motoMainFace,   //$interFace.motoMainFace
                        // url : 'http://10.11.29.159:3101/xszc/service/ydzyService',
                        method: 'POST',
                        headers: {
                            method: 'vehicleModel'
                        },
                        data: options,
                        success: function (data) {
                            $handleService.logger('object', data, '车型查询数据处理--》');
                            if(data.resultCode=='0'){
                                var count = $U.isEmpty(data.result) ? 0 : data.result.length;
                                $handleService.logger('info', '车型查询返回数据成功，共 (' + count + ') 条');
                                if (!count) {
                                    $U.showToast("没查到相应车型，请检查您输入的品牌型号或车架号是否正确");
                                    return;
                                }
                                $scope.vm.isShowCarSel = true; //展示面板
                                $scope.vm.VHL_LIST = data.result;
                            }else{
                                $U.showToast("请检查您输入的品牌型号或车架号是否正确");
                            }

                        },
                        error: function (ex) {
                            $handleService.logger('error', ex);
                            $U.showToast("车型查询出错，请稍后再试");
                        }
                    });
                };
                return handle;
            })(Handle || {});
            // $rootScope.$on('$stateChangeSuccess', function (ev, to, toParams, from, fromParams) {
            //     $rootScope.prePage = from; //from为前一个页面的路由信息：url,cache,views,name
            // });
            //---------------------------------变量-start------------------------------------

            $scope.vm = {};

            //支付选择 返回首页按钮显示标识 ---》 全民营销 不需要
            $scope.cancelOrBack = window.requestParam.webSources ? true : false;

            $scope.scheItem={
                applyPolicyNo:'',
                userId:$rootScope.MotoCAR.base.operatorCode,
                telVerifyCode:''
            };

            //---------------------------------变量-end------------------------------------

            $scope.test=function () {
                if($rootScope.MotoCAR.riskList[0].effectFlag2==false){
                    $rootScope.MotoCAR.riskList[0].effectFlag='0';
                }else{
                    $rootScope.MotoCAR.riskList[0].effectFlag='1';
                }
            };

            //车型选择事件
            $scope.checkCarModel = function (t, VHL) {
                //处理减免税标志  01-拒缴 02-缴税 03-完税 04-减税 05-免税 06-补税并纳税
                if(VHL.fuelFlag == '0'){
                    $rootScope.MotoCAR.riskList[0].vhlTax.taxRelifFlag = '02';
                    // $rootScope.MotoCAR.taxRelifFlag = '02';
                }else if(VHL.fuelFlag == '1' || VHL.fuelFlag == '3'){
                    $rootScope.MotoCAR.riskList[0].vhlTax.taxRelifFlag = '05';
                    // $rootScope.MotoCAR.taxRelifFlag = '05';
                }else if(VHL.fuelFlag == '2' || VHL.fuelFlag == '4'){
                    $rootScope.MotoCAR.riskList[0].vhlTax.taxRelifFlag = '04';
                    // $rootScope.MotoCAR.taxRelifFlag = '04';
                }


                // $rootScope.MotoCAR.riskList[0].vhlTax.taxRelifFlag = VHL.FUELFLAG ;

                angular.forEach(VHL,function (item,index) {
                    angular.forEach($rootScope.MotoCAR.vehicle,function (date,ind) {
                        if(item && index==ind){
                            $rootScope.MotoCAR.vehicle[ind]=item;
                        }
                    })
                });
                $rootScope.MotoCAR.vehicle.modelName = $rootScope.MotoCAR.vehicle.brandName;
            };

            //车型选择-确定按钮
            $scope.chooseCarModel = function () {
                $scope.vm.vhlTax={};
                $timeout(function () {
                    $scope.vm.isShowCarSel = false;
                },350);

            };

            $scope.exchangeQuery = function () {

                // Handle.validateEvent();
                if (!Handle.validateEvent()) {
                    return;
                }
                Handle.queryCalList({
                    frameNo: $rootScope.MotoCAR.vehicle.frameNo, //车架号
                    engineNo: $rootScope.MotoCAR.vehicle.engineNo, //发动机号
                    registerDate: $rootScope.MotoCAR.vehicle.singeinDate,//初登日期
                    licenseNo:$rootScope.MotoCAR.vehicle.licenseNo || '*-*',
                    modelName:$rootScope.MotoCAR.vehicle.brandName
                });
            };

            $scope.calPrem=function () {
                if (!Handle.submitVali()) {
                    return;
                }
                if(!Handle.validateEvent()){
                    return;
                }
                var formFlag=$handleService.validateForm.call(this, $scope.form);
                //校验表单
                if (formFlag) {
                    //个代未开启时，去掉个代参数
                    if(!$rootScope.MotoCAR.showChannel) {
                        if(window.requestParam.webSources != "QMYX") {
                            $rootScope.MotoCAR.base.intermediaryCode = "";
                            $rootScope.MotoCAR.base.intermediaryName = "";
                        }
                    }
                    //协作人未开启时 去掉协作人参数
                    if(!$rootScope.MotoCAR.showAssist) {
                        $rootScope.MotoCAR.base.cooperateCode = "";
                        $rootScope.MotoCAR.base.cooperateName = "";
                    }

                    //平台电子保单标志
                    $rootScope.MotoCAR.riskList[0].electronicPolicyFlag = ($rootScope.MotoCAR.base.busiAttrConfig.policyStyles == '2')?'1': '0';
                    //华安电子保单
                    $rootScope.MotoCAR.riskList[0].electronicInd = ($rootScope.MotoCAR.base.busiAttrConfig.policyStyles == '1')?'1': null;


                    //保险起期
                    $rootScope.MotoCAR.riskList[0].startDate=$rootScope.MotoCAR.riskList[0].startDate2+':00';

                    $rootScope.MotoCAR.vehicle.licenseNo=$rootScope.MotoCAR.vehicle.licenseNo || '*-*';



                    //非车险种保费
                    if($rootScope.switchBean.noCarPrdSwitch){ // 非车险
                        $rootScope.MotoCAR.noCarProductList = $rootScope.nocarArr;
                        $rootScope.MotoCAR.noCarRiskList = [];
                    }else{
                        $rootScope.MotoCAR.noCarProductList = [];
                        $rootScope.MotoCAR.noCarRiskList = $rootScope.nocarArr;
                    }
                    $rootScope.MotoCAR.carRiskCode = '0301';
                    $rootScope._MotoCAR = $rootScope.MotoCAR; //受益人处理  $rootScope.beneficiaryMoto为false时不传受益人节点
                    $rootScope.beneficiaryMoto?'':delete $rootScope._MotoCAR.beneficiary;
                    //0813【交叉销售】车险增加符合交叉销售的标识_start
                    if($U.isNotEmpty($scope.nocarList)) {
                        var productCodeArr = [];
                        var productCodeStr = '';
                        angular.forEach($scope.nocarList, function(nocarItem){
                            productCodeArr.push(nocarItem.productCode.substr(1,4));
                        })
                        productCodeStr = productCodeArr.join(',');
                    }
                    $rootScope._MotoCAR.base.allowNocarListFlag = productCodeStr||'';
                    //0813【交叉销售】车险增加符合交叉销售的标识_end
                    //保费计算
                    $handleService.motoHttp({
                       url: $interFace.motoMainFace,   //$interFace.motoMainFace
                        // url : 'http://10.11.29.181:3100/xszc/service/ydzyService',
                        method: 'POST',
                        headers: {
                            method: 'calPrem'
                        },
                        data: $rootScope._MotoCAR,
                        success: function (data) {
                            $handleService.logger('object', $rootScope._MotoCAR, '保费计算参数--》');
                            $handleService.logger('object', data, '保费计算结果--》');
                            if(data.resultCode=='0'){
                                $scope.vm.vhlTax=data;
                                $scope.vm.vhlTax.totally=data.result.riskList[0].sumGrossPremium+data.result.riskList[0].vhlTax.sumPayTax || 0;
                                data.result.riskList[0].vhlTax.sumPayTax == 0 ? data.result.riskList[0].vhlTax.sumPayTax='0' : null;
                                $rootScope.MotoCAR.riskList[0].vhlTax.taxRelifFlag = data.result.riskList[0].vhlTax.taxRelifFlag;
                                $scope.calResultData = data.result;
                                $scope.hasCalPremiunFlagMoto = $rootScope.hasCalPremiunFlagMoto = true;
                                Handle.setPremium(data.result.riskList);
                                $timeout(function () {
                                    $rootScope.reCalPremiumFlagMoto = false;
                                    $rootScope.goNextDisabledMoto = false; // 提交按钮改为可用
                                }, 0);
                            }else if( data.resultCode == 'E11091' ){
                                $handleService.showAlert('提示',data.errorMsg);
                            }else{
                                $U.showToast(data.errorMsg);
                            }

                        },
                        error: function (ex) {
                            $handleService.logger('error', ex);
                        }
                    });
                }

            };

            $scope.owMotoSubmit = function(form) {
                if (!Handle.submitVali()) {
                    return;
                }
                if($U.isEmpty($scope.vm.vhlTax)){
                    $U.showToast('请进行保费计算');
                    return;
                }
                var formFlag=$handleService.validateForm.call(this, form);
                var baseData = {
                    followId:$scope.vm.vhlTax.followId,
                    newBrandName:$rootScope.MotoCAR.newBrandName,
                    refereeId : window.requestParam.refereeId,
                    handleText: $rootScope.baseBean.handleText, //提核说明
                };
                var data = angular.merge(baseData,$scope.calResultData);
                data.applicant.invtype = $rootScope.MotoCAR.applicant.invtype;
                data.applicant.mobilePhone = $rootScope.MotoCAR.applicant.mobilePhone;
                $handleService.logger('object', data, '提核参数--》');
                //校验表单
                if(formFlag){
                    $handleService.motoHttp({
                        url: $interFace.motoMainFace,
                        // url : 'http://10.11.29.181:3100/xszc/service/ydzyService',
                        method: 'POST',
                        headers: {
                            method: 'underwriting'
                        },
                        data: data,
                        success: function (data) {
                            $handleService.logger('object', data, '提核结果--》');
                            $scope.vm.submitResult=data;
                            if(data.resultCode=='0'){
                                // $rootScope.MotoCAR = angular.copy(motoCar);
                                $scope.scheItem.applyPolicyNo=data.result.underwriteResultList[0].proposalNo;
                                // start
                                // 有errorMsg则显示
                                if(data.result.underwriteResultList.length>1&&data.result.underwriteResultList[1].underwriteErrorList[0].errorMsg){
                                    //非车错误内容
                                    $rootScope.unwListFC = data.result.underwriteResultList[1].underwriteErrorList;
                                    $handleService.showAlert('核保状态提示', '', function () {
                                        setTimeout(function(){
                                            // 提示完弹出去支付选框
                                            $scope.alertPopup = $handleService.showAlert('<div class="poput-select-pay-title">请选择操作</div>', "", null, {
                                                cssClass: "pay-popup",
                                                okType: "hidden-box",
                                                templateUrl: "templates/common/oder-pay-style.html",
                                                scope: $scope
                                            });
                                        },500)
                                    }, {
                                        templateUrl: "templates/common/underwriting-moto-status.html",
                                        scope: $scope
                                    }); 
                                    // end
                                } else {
                                    $scope.alertPopup = $handleService.showAlert('<div class="poput-select-pay-title">请选择操作</div>', "", null, {
                                        cssClass: "pay-popup",
                                        okType: "hidden-box",
                                        templateUrl: "templates/common/oder-pay-style.html",
                                        scope: $scope
                                    });
                                }
                            }else if(data.resultCode=='E12003'){
                                // $rootScope.MotoCAR = angular.copy(motoCar);
                                var text='';
                                angular.forEach(data.result.underwriteResultList[0].underwriteErrorList,function (item,index,arr) {
                                    text += item.errorMsg+';<br/>';
                                });
                                $handleService.showAlert("转人工核保",text,function () {
                                    if(data.result.underwriteResultList[0].proposalNo){
                                        $rootScope.JQ_NUM=data.result.underwriteResultList[0].proposalNo;
                                        $state.go("tab.motoOrderno");
                                    }
                                });
                            }else if(data.resultCode=='E12002'){
                                var text='';
                                angular.forEach(data.result.underwriteResultList[0].underwriteErrorList,function (item,index,arr) {
                                    text += item.errorMsg+';<br/>';
                                });
                                $handleService.showAlert("下发修改",text);
                            }else if(data.resultCode=='99'){
                                $handleService.showAlert("请确认核保失败信息",data.errorMsg,function () {
                                    Handle.goIndex();
                                });
                            }else{
                                $handleService.showAlert("请确认核保失败信息",data.errorMsg);
                            }

                        },
                        error: function (ex) {
                            $handleService.logger('error', ex);
                        }
                    });
                }

            };


            $scope.payOders = function (scheItem, isLocation) {
                //关闭模式框
                $handleService.closeModule($scope.alertPopup);

                Handle.payHttp(scheItem,isLocation)


            };

            //返回首页 方法
            $scope.returnMixIndex = function () {
                $handleService.closeModule($scope.alertPopup);
                Handle.goIndex();
            };

            //OCR 调用相机方法
            $scope.ocrTackPhoto = function () {
                $handleService.appHandle.cameraHandle({
                    success: function (img) {
                        $rootScope.ocrImgUrl = img;
                        $generalService.ocrImgUpload({
                            type: "1", // 1.行驶证 2.身份证 3.驾驶证 4.银行卡
                            img: img,
                            success: function (data) {
                                $handleService.logger('info', data);
                                if (data.type != '未知类型') {
                                    Handle.motoHandle(data);
                                }
                                else {
                                    $U.showToast('请选择带有清晰的证件号码的照片');
                                }
                            }
                        });
                    }
                });
            };

            //清除退回
            $scope.gotoIndex = function() {
                $ionicHistory.clearCache();
                // //判断新首页可见性
                // if($rootScope.isNewHome){
                //     $state.go("tab.mitNewIndex");
                // }else{
                //     $state.go("tab.mitIndex");
                // }
                $state.go("tab.mitNewIndex");
            };


            //----------------------------------------end   车辆信息页面----------------------------------------//
            // start
            /***********非车**************************/
            $scope.nocarList = [];  // 可以购买的非车产品
            $rootScope.nocarArr = []; //选中的非车险
            if($rootScope.switchBean.noCarPrdSwitch){
                Handle.getNocarListNew();
            }else{
                Handle.getNocarList();
            }


            //跳转到非车详情
            $scope.gotoNocarDetails = function(item) {
                $rootScope.nocarDetailsItem = item;
                $rootScope.fromMotoFlag = true; // 标记从moto进入
                $state.go("tab.nocarDetails");
            }

            //选择非车险
            $scope.selectNocarType = function(data, $event) {
                var newData = angular.copy(data);
                newData.rationList = [];

                $rootScope.hasCalPremiunFlagMoto = true; //保费试算成功标志
                $rootScope.reCalPremiumFlagMoto = true; //重新试算标识
                $rootScope.goNextDisabledMoto = true; //提交按钮置灰

                if($event.target.checked) {
                    angular.forEach(data.rationList, function(item) { //获取选中的险种类型 基本型、豪华型和至尊型
                        if(data.rationCode == item.rationCode) {
                            item.waxBatch = newData.waxBatch;
                            newData.rationList[0] = item;
                            $rootScope.nocarArr.push(newData.rationList[0]);
                        }
                    });
                } else {
                    //获取险种
                    angular.forEach($rootScope.nocarArr, function(item, index) {
                        if(data.rationCode == item.rationCode) {
                            $rootScope.nocarArr.splice(index, index+1);
                        }
                    });
                }
                // 保存操作 为了切换页面后数据还在
                if($rootScope.switchBean.noCarPrdSwitch){ // 非车险
                    $rootScope.carBeans.noCarProductList = $rootScope.nocarArr;
                    $rootScope.carBeans.noCarRiskList = [];
                }else{
                    $rootScope.carBeans.noCarProductList = [];
                    $rootScope.carBeans.noCarRiskList = $rootScope.nocarArr;
                }
            }

            /*修改非车险种份数*/
            $scope.changeBatch = function(item, flag) {
                //减
                if(flag == "sub") {
                    if(Number(item.waxBatch) > 1) {
                        item.waxBatch --;
                    } else{
                        return
                    }
                } else if(flag == "add") {
                    if(Number(item.waxBatch) < Number(item.maxBatch)) {
                        item.waxBatch ++;
                    } else {
                        $U.showToast("产品份数已达到购买上限");
                        return;
                    }
                }

                //修改已选中非车险的险种份数 需要重新计算保费
                angular.forEach($rootScope.nocarArr, function(data) {
                    if(data.rationCode == item.rationCode) {
                        data.waxBatch = data.waxBatch = item.waxBatch;
                    }
                });
                //重新显示保费
                if(item.calType == "2") { //按座位数计算保费
                    item.totalPremium = Number(item.premium) * Number($rootScope.MotoCAR.seatCount) * Number(item.waxBatch);
                } else {
                    item.totalPremium = Number(item.premium) * Number(item.waxBatch);
                }
                $rootScope.reCalPremiumFlagMoto = true; //重新计算标识
                $rootScope.goNextDisabledMoto = true; //提交按钮置灰
            }

            //切换选择上年方案或者是自选方案
            $scope.selectPolicyType = function(type, event) {
                $rootScope.renewalPolicyType = type;
                $(".price-item").removeClass("active");
                $(event.target).addClass("active");
            };
            /*****************************************/
            // end
            
            /*  ---  APP摩托车增加发票节点（发票样式：普通发票、电子发票；发票名称类型：个人）_1029_start  ---  */
            //监听纳税人信息改变
            $scope.changeTaxType = function () {
                var value = $rootScope.MotoCAR.applicant.taxType;
                if (value == '02') { //小规模纳税人
                    $rootScope.MotoCAR.applicant.invtype = '0'; //普通发票
                } else if (value == '01') { //一般纳税人
                    $rootScope.MotoCAR.applicant.invtype = '1'; //专用发票
                }
            };
            /*  ---  APP摩托车增加发票节点（发票样式：普通发票、电子发票；发票名称类型：个人）_1029_end  ---  */
            
        });
        return app;
    });
