define(['services/app.service',
   'services/app.general.service',
   'services/app.sqlLite.service',
   'services/app.car.beans',
   'services/app.store',
   'directives/app.directives'], function () {
   'use strict';
   var app = angular.module('app.compController', ['ionic','app.handle.service','app.general.service', 'app.directives', 'app.car.beans']);
   //投保查询控制器
   app.controller('oderDetailsCtrl', function ($ionicPopup,$rootScope, $scope, $handleService,$generalService, $interFace, $state, store) {
      $scope.vm = {};
      $scope.vm.state = store.state;
      $scope.vm.isShowPayBtn = false;
      $scope.goBack=function () {
          store.orderData=null;
          history.back(-1);
      };
      $scope.judgeData=false;
      $scope.isBeijing = $rootScope.IS_BEIJING_07; //是否是北京 石梦星
      $scope.refreshPage=function (type) {
         //影藏支付按钮
         $scope.vm.isShowPayBtn = false;
         if(store.orderData&&!type){
            $scope.vm.orderList = store.orderData;
            return;
         }
         store.searchData.coreflag = $U.sessionHandle.getSession("SLS_INFO").isNewCoreFlag || "0";  //新老核心标志 0为老核心 1为新核心
         $handleService.http({
            url: $interFace.mitMainFace,
            method: 'POST',
            headers: {
               method: 'queryTPolicyStatusNewBusiness'
            },
            data: store.searchData,
            success: function(data) {

               $handleService.logger('object', data, '投保进度查询返回结果');


               if (data.success == "true") {
                  //--------------------------------begin 批量查询红包--------------------------------//
                  var APP_LIST = [],
                      params = {},
                      hack_result = [];
                  angular.forEach(data.DATA, function(item) {
                     APP_LIST.push({
                        APP_NO: item.PLY_APP_NO
                     });
                  });
                  params["APP_LIST"] = APP_LIST;
                  params["SLS_CDE"]=$U.getSession('SLS_CDE');

                  $handleService.logger('object', params, '投保进度查询-->红包查询参数');
                  $handleService.http({
                     url: $interFace.mitMainFace,
                     method: 'POST',
                     headers: {
                        //getRedBagInfo
                        method: 'getRedBagInfo'
                     },
                     data: params,
                     success: function(redpag) {
                        $handleService.logger('object', redpag, '投保进度查询-->红包查询结果');
                        if ($U.isNotEmpty(redpag) && redpag.success == "true") {
                           angular.forEach(data.DATA, function(oder) { //循环投保进度查询结果
                              angular.forEach(redpag.result, function(rp) { //循环 红包接口结果
                                 if (oder.PLY_APP_NO == rp.APP_NO) {
                                    oder.VHL_FRM = rp.VHL_FRM; //车架号
                                    oder.ODER_FLAG = rp.FLAG; //核保是否是两单同时核保
                                    if($U.isNotEmpty(rp.RED_BAG)){
                                       oder.IS_HAVE_REDP = true;
                                       oder.RED_BAG = rp.RED_BAG; //红包金额
                                    }
                                    else {
                                       oder.IS_HAVE_REDP = false;
                                    }
                                 }
                              });
                              hack_result.push(oder);
                           });
                        } else {
                           hack_result = data.DATA;
                        }

                      //  store.order.set({list:hack_result});
                        store.orderData=hack_result;
                        $scope.vm.orderList = hack_result;
                       // $scope.vm.orderList=hack_result;
                        /********************begin 跳转详情页***********************/
                        //     $rootScope.CAR_ODER_DETAILS = hack_result;
                        //  $scope.CAR_ODER_DETAILS = hack_result;
                        // $state.go('tab.oderDetails');
                        //进行列表加载
                        // $http.get('templates/common/car-oder-list.html').success(function(html) {
                        //     window.setTimeout(function() {
                        //         angular.element('.car-oder-details').empty().append($compile(html)($scope));
                        //     }, 0);
                        // });
                        /********************end    跳转详情页***********************/
                     },
                     error: function(ex) {
                        $handleService.logger('error', ex);
                     }
                  });
                  //--------------------------------end  批量查询红包--------------------------------//
               }
               else {
                  // $U.showToast(data.msg);
                  $scope.judgeData=true;
               }
            },
            error: function(ex) {
               $handleService.logger('error', ex);
            }
         });
      };
      $scope.refreshPage();
      //------------------------------------------ begin 订单支付选择 ------------------------------------------//
      //勾选订单方法
      $scope.CAR_ODER_PAYS = {};
      $scope.checkOrder = function (order) {
         $handleService.logger('object', order, '所选订单详细');
         //保存订单对象
         if (order.$CHECK_PAY) {
            $scope.CAR_ODER_PAYS[order.PLY_APP_NO] = order;
            $handleService.logger('info', "此单支付:" + order.PLY_APP_NO);
         }
         else {
            delete $scope.CAR_ODER_PAYS[order.PLY_APP_NO];
            $handleService.logger('info', "此单取消支付:" + order.PLY_APP_NO);
         }
         //显示支付按钮
         $U.isNotEmpty($scope.CAR_ODER_PAYS) ? $scope.vm.isShowPayBtn = true : $scope.vm.isShowPayBtn = false;
      };
      //勾选 红包 方法
      $scope.checkIsUseHongbao = function (index) {
         var order = store.orderData[index],
            wrap = angular.element('#' + order.PLY_APP_NO),
            eRealFee = wrap.find(".realFeeText");
         if (order.$isUseHongbao) {
            eRealFee.text($U.formatPremium(order.PREMIUM - order.RED_BAG));
         }
         else {
            eRealFee.text(order.PREMIUM);
         }
      };
      //------------------------------------------ end   订单支付选择 ------------------------------------------//

      /*
       1.登录之后调取当前机构是否有红包权限，所有的红包接口调用之前都必须满足条件：1.机构有红包权限，2.非个人代理出单
       2.保费试算之后调用红包试算，并交强、商业分开真是红包金额
       3.提核成功返回limit，判断红包金额是否<=limit,如果是则调用保存红包接口
       4.投保进度查询页面：调用投保进度查询之后调用查询红包接口，讲每一单的红包信息匹配到每个投保单号，此接口会返回当前投保单是否为交商同保标志。
       5.支付：
       5.1.单交强或者单商业，勾选红包，走新支付平台，不勾选红包，走旧支付平台。
       5.2.交商同保出单
       5.2.1.合并支付，只能同一个车的交商同保才可以合并支付，否则文案提示“只能同时支付交商同保的两张投保单”。
       5.2.2.交商合并支付，都不勾选红包，则走旧支付平台；都勾选红包，走新支付平台。
       5.2.3.交商合并支付，其中一单勾选红包，提示文案“您的交强险（或商业险）没有同时使用红包缴费，不能享受已获得红包优惠，请确认！”，走旧支付平台
       5.2.4.交商分开支付，如果不勾选红包，直接支付，走旧支付平台；如果勾选红包，提示文案“您的交强险（或商业险）没有同时使用红包缴费，不能享受已获得红包优惠，请确认！”，走旧支付平台。
       5.2.5.获取支付码成功，rechargeStatus返回为1，走新支付平台，否则提示文案rechargeMessage字段内容，走旧支付平台。
       5.3.走旧支付平台，即使勾选了红包，是否充值字段isRecharge也传0。
       */
      //提交支付-》调用支付接口
      $scope.doPay = function () {
         var payOder = $U.toArray($scope.CAR_ODER_PAYS);
         $handleService.logger('object', payOder, '支付数据');
         var paysize = payOder.length; //支付单量
         //-------------------------------------------begin 校验-------------------------------------------//
         //1.最多同时两单合并支付
         if (paysize > 2) {
            $U.showToast('只能同时支付交商同保的两张投保单');
            return;
         }
         //2.合并支付的 必须是同一个车架号
         if (paysize == 2) {
            if (payOder[0].VHL_FRM != payOder[1].VHL_FRM) {
               $U.showToast('必须是同一台车才可以合并支付');
               return;
            }
         }
         //-------------------------------------------end    校验-------------------------------------------//
         var payObject = {
            cJsFlag: '0',//是否交商同保 车险必传【1：交商同保、0：非交商同保】
            isRedBag: '0',//是否使用红包【1：是、0：否】
            isRemind:false,
            TEL_VERIFY_CODE: payOder[0].TEL_VERIFY_CODE,//北京短信验证码 石梦星
            oderList: payOder //订单集合
         };
         if (paysize == 1) {  //1.单保交强险 或者商业险的时候  2.分开支付的时候
            payObject.cJsFlag = '0';
            //支持红包 再去校验 并且提示
            if(payOder[0].IS_HAVE_REDP){
               //0.1 单保交强险 或者商业险的时候
               if (payOder[0].ODER_FLAG == '0') {
                  //是否勾选红包
                  if (payOder[0].$isUseHongbao) {
                     payObject.isRedBag = '1';
                     $handleService.logger('object',payObject,'支付单为单保交强或者单保商业--》已勾选红包--》走【新】支付');
                  }
                  else {
                     payObject.isRedBag = '0';
                     $handleService.logger('object',payObject,'支付单为单保交强或者单保商业--》未勾选红包--》走【旧】支付');
                  }
               }
               //0.2 投了两单 分开支付的时候
               else {
                  payObject.isRedBag = '0';
                  payObject.isRemind = true;
                  $handleService.logger('object',payObject,'支付单为购买两单，分开支付--》无论是否勾选红包，走【旧】支付--》');
               }
            }
            else {
               payObject.isRedBag = '0';
               $handleService.logger('object',payObject,'支付单根本未存入红包--》走【旧】支付--》');
            }
         }
         else if (paysize == 2) {  //交商同保 前面已经校验过了 可以忽略校验同一台车
            payObject.cJsFlag = '1';
            //交商同保  必须两个都 存入了红包  再去校验
            if(payOder[0].IS_HAVE_REDP && payOder[1].IS_HAVE_REDP){
               if (payOder[0].$isUseHongbao == payOder[1].$isUseHongbao && payOder[0].$isUseHongbao) { //两单同时使用红包
                  payObject.isRedBag = '1';
                  $handleService.logger('object',payObject,'支付单为购买两单，合并支付--》交商同时勾选红包，走【新】支付--》');
               }
               else if ((payOder[0].$isUseHongbao && !payOder[1].$isUseHongbao) || (!payOder[0].$isUseHongbao && payOder[1].$isUseHongbao)) { //有一单使用了 红包
                  payObject.isRedBag = '0';
                  payObject.isRemind = true;
                  $handleService.logger('object',payObject,'支付单为购买两单，合并支付--》交商仅有一单勾选红包，走【旧】支付--》');
               }
               else { //都不用红包
                  payObject.isRedBag = '0';
                  $handleService.logger('object',payObject,'支付单为购买两单，合并支付--》两单都不选红包，走【旧】支付--》');
               }
            }
            else {
               payObject.isRedBag = '0';
               $handleService.logger('object',payObject,'支付单为购买两单交商同保，但有一单或者都没存入红包--》不支持红包，走【旧】支付--》');
            }
         }

         //开始 支付 -------》如果 需要 提醒用户 弹出提醒
         if(payObject.isRemind){
            $handleService.showConfirm({
               template: "您投保的交强险和商业险需同时一起勾选后提交支付，才能使用积分抵扣保费，不能分开支付。",
               sure: function () {
                  $generalService.serverPay(payObject);
               },
               cancle: function () {
                  return;
               }
            });
         }
         else {
            $generalService.serverPay(payObject);
         }
      };

      //撤单方法
      $scope.revokeOder = function (index) {
         var order = store.orderData;
         $handleService.showConfirm({
            title: '撤单前确认',
            template: '您确定撤销此单么？',
            sure: function () {
               //开始撤单
               $handleService.http({
                  url: $interFace.mitMainFace,
                  method: 'POST',
                  headers: {
                     method: 'cancelNewBusiness'
                  },
                  data: {APP_INFO: [order[index]]},
                  success: function (data) {
                     if (data.success == "true") {
                        delete $scope.CAR_ODER_PAYS[order.PLY_APP_NO];
                        $U.isNotEmpty($scope.CAR_ODER_PAYS) ? $scope.vm.isShowPayBtn = true : $scope.vm.isShowPayBtn = false;
                        order.splice(index,1);
                        //移除当前节点

                        // var _el = angular.element('#' + oder.PLY_APP_NO);
                        // _el.addClass('a-bounceoutR');
                        // window.setTimeout(function() {
                        //     _el.remove();
                        // }, 800);
                     }
                     $U.showToast(data.msg);
                  },
                  error: function (ex) {
                     $handleService.logger('error', '撤单异常' + ex);
                  }
               });
            }
         });
      };


      //退回修改
      $scope.returnToModify=function (item) {
         $handleService.showConfirm({
            title: '退回修改前确认',
            template: '确定退回修改吗？',
            sure: function () {
               $state.go('tab.owinfo', {SU_CODE: 'PQUERY',PLY_APP_NO:item.PLY_APP_NO,PROD_NO:item.PROD_NO});
            }
         });
      };


   })
   return app;
});