define([
        'services/app.service',
        'services/app.general.service',
        'directives/app.directives',
        'filters/app.filters',
        'services/app.car.beans',
        'modalSelect',
        'ngUpload'
    ],
    function () {
       'use strict';
       var app = angular.module('app.owInfo.controller', [
          'app.handle.service',
          'app.general.service',
          'app.directives',
          'app.filters',
          'app.car.beans',
          'ionic-modal-select',
          'ngFileUpload'
       ]);
       //表单控制器
       app.controller('owInfoController', function ($scope, $rootScope, $http,$location, $state, $stateParams, $handleService, $generalService, $interFace, Upload, $carBeansService, $q) {
          //----------------------------------------begin 变量----------------------------------------//
          console.log('own-info-$rootScope.carBeans.noCarProductList',$rootScope.carBeans.noCarProductList);
          var pageCode = $stateParams.SU_CODE;  //页面路由参数 SU_CODE
          $scope.pageCode = $stateParams.SU_CODE;  //页面路由参数 SU_CODE
          var plyAppNo = $stateParams.PLY_APP_NO; //投保单号
          var prodcNo = $stateParams.PROD_NO;  //产品编号
          $scope.ocr = false;
          $scope.canClick = true;//点击穿透
          $scope.agentOptions = [];  //个人代理
          $scope.assistOptions = []; //协作人
          $rootScope.address = '';//行驶证地址
          $rootScope.ownerAddress = '';//代替车主行驶证详细地址字段
            $scope.isShowCar = false;
            $rootScope.vhlList = [];
            $scope.idCardLength = '';
            $rootScope.previousState = 'from';  //判断缓存是否保留标志
           $rootScope.beneficiaryFlag = true;  //受益人数据缓存标志
            if(navigator.userAgent.indexOf("Html5Plus") > -1){
                $rootScope.browser = "QmybAPP";
            }
           $rootScope.renewalMemory = true;//下个页面返回此页不覆盖续保数据标志
            //车主证件类型默认处理

            //所属性质  false-个人  true-机关团体
           if(window.requestParam.webSources != "QMYX"){
               $rootScope.isQMYX = false;
               $rootScope.carBeans.owner.insuredTypeCode = $rootScope.carBeans.base.busiAttrConfig.attachNatures.split('')[1];
           }else{
                $rootScope.isQMYX = true;
               window.requestParam.attachNatures ? $rootScope.carBeans.owner.insuredTypeCode = window.requestParam.attachNatures.split('')[1] : '';
                $rootScope.carBeans.base.busiAttrConfig.attachNatures = window.requestParam.attachNatures;
           }
            $scope.isCarMass = $rootScope.carBeans.owner.insuredTypeCode=='2' || $rootScope.carBeans.owner.insuredTypeCode=='3';
            if($rootScope.carBeans.applicant.name==''&& $rootScope.carBeans.applicant.identifyNumber=='') {
                $scope.isCarMass ? $rootScope.carBeans.applicant.insuredType = '2' : $rootScope.carBeans.applicant.insuredType = '1';
                $scope.isCarMass ? $rootScope.carBeans.insured.insuredType = '2' : $rootScope.carBeans.insured.insuredType = '1';
            }
           //企业机关
           if($rootScope.carBeans.owner.insuredTypeCode != "1") {
               var ceritTypeArr = ["13", "09", "10","11","12", "99"]; //企业机关证件类型可以选择的值
               if(ceritTypeArr.indexOf($rootScope.carBeans.owner.identifyType) == -1) {
                   $rootScope.carBeans.owner.identifyType = ceritTypeArr[0];
               }
           } else { //个人
               var ceritTypeArr = ["01", "06", "05", "02", "99","03","04","07","15"]; //个人证件类型可以选择的值
               if(ceritTypeArr.indexOf($rootScope.carBeans.owner.identifyType) == -1) {
                   $rootScope.carBeans.owner.identifyType = ceritTypeArr[0];
               }
           }
           // 四川交管需求相关字段
           if(!$rootScope.scjg){
                $rootScope.scjg = {
                    isShowClOpt: false,
                    licenseColorCode: '',
                    licenseTypeCode: '',
                };
           }
           // 颜色默认值
           if(['01','04','06','07'].indexOf($rootScope.carBeans.vehicle.licenseColorCode)!=-1 && !$rootScope.scjg.licenseColorCode){
                $rootScope.scjg.licenseColorCode = $rootScope.carBeans.vehicle.licenseColorCode;
           }
           

            // if($rootScope.carBeans.applicant.name==''&&$rootScope.carBeans.applicant.identifyNumber=='') {
            //   $scope.hasAppName = false; //是否存在投保人
            // }  else {
            //    $scope.hasAppName = true; //是否存在投保人
            // }
            // 证件类型位数控制
            $scope.maxLength = function (a) {
                switch (a) {
                    case '01':$scope.idCardLength = '18'; break;//身份证
                    case '02':$scope.idCardLength = '20'; break;//护照
                    case '03':$scope.idCardLength = '20'; break;//军人证
                    case '04':$scope.idCardLength = '20'; break;//学生证
                    case '05':$scope.idCardLength = '20'; break;//台胞证
                    case '06':$scope.idCardLength = '20'; break;//港澳返乡证
                    case '07':$scope.idCardLength = '20'; break;//出生证
                    case '09':$scope.idCardLength = '18'; break;//统一社会信用代码
                    case '10':$scope.idCardLength = '18'; break;//组织机构代码
                    case '11':$scope.idCardLength = '10'; break;//工商注册号
                    case '12':$scope.idCardLength = '10'; break;//税务登记证号
                    case '13':$scope.idCardLength = '20'; break;//纳税人识别号
                    case '15':$scope.idCardLength = '18'; break;//港澳台居民居住证
                    case '99':$scope.idCardLength = '20'; break;//其他
                    default:$scope.idCardLength = ''; break;
                }
            }

            /*江苏交管 相关变量*/
            $scope.jsJg = {
                show: false,
                vehicleIdentify: false, //车辆识别
                frameNo: false,
                VHL: {},
                vcodeBase64: '', // 验证码图片
                ciQueryCode: '', // 查询码
                checkCode: '', // 验证码
                carList: [], // 查询车型列表
                loseFocus: function () {
                    var frameNo = $rootScope.carBeans.vehicle.frameNo;
                    if ($U.isEmpty(frameNo)) {
                        $U.showToast('请输入车架号');
                        return;
                    }
                    else {
                        if (!/^[a-z0-9A-Z]+$/.test(frameNo)) {
                            $U.showToast('车架号输入错误');
                            return;
                        }
                        var isReach = frameNo.indexOf("I") + frameNo.indexOf("O") + frameNo.indexOf("Q");
                        if (isReach > -3) { //车架号 不包含 I O Q
                            $U.showToast('您的车架号输入不正确');
                            return;
                        }
                    }

                    var _this = this;
                    _this.carList = [];
                    _this.checkCode = '';
                    // 请求验证码
                    $handleService.http({
                        url: "/quote/jsCarQuery",
                        method: 'POST',
                        data: {
                            frameNo: frameNo,
                            licenseNo: ''
                        },
                        success: function (data) {
                            if (data.resultCode == '0') {
                                _this.show = true;
                                _this.vcodeBase64 = 'data:image/png;base64,' + data.result.checkCode;
                                _this.ciQueryCode = data.result.ciQueryCode;
                            } else {
                                $U.showToast(data.errorMsg);
                            }
                        },
                        error: function (ex) {
                            $handleService.logger('error', '异常' + ex);
                        }
                    });
                },
                jsCarShow:function(){//检查为江苏交管，并且车牌为苏开头， 1112期添加
                    if($rootScope.switchBean.jsCarQuery =='1' && $rootScope.carBeans.vehicle.licenseNo.indexOf('苏')>-1){
                        this.frameNo = this.vehicleIdentify = true;
                    }else{
                        this.frameNo = this.vehicleIdentify = false;
                    }
                },
                // onChange: function () {
                //     if (this.vehicleIdentify) {
                //         this.frameNo = true;
                //     } else {
                //         this.frameNo = false;
                //     }
                // },
                queryCarList: function () {
                    // 校验验证码
                    if(!$scope.jsJg.checkCode){
                        $U.showToast('请输入验证码');
                        return;
                    }
                    if(!/[a-zA-Z0-9]{4}/.test($scope.jsJg.checkCode)){
                        $U.showToast('验证码格式错误，请重新输入');
                        return;
                    }
                    var _this = this;
                    _this.VHL = {};
                    $handleService.http({
                        url: "/quote/jsCarValidate",
                        method: 'POST',
                        data: {
                            frameNo: $rootScope.carBeans.vehicle.frameNo,
                            checkCode: $scope.jsJg.checkCode,
                            ciQueryCode: $scope.jsJg.ciQueryCode,
                            licenseNo: ''
                        },
                        success: function (data) {
                            if (data.resultCode == '0') {
                                if(data.result.vehicleCheckVoList && data.result.vehicleCheckVoList.length > 0){
                                    _this.carList = data.result.vehicleCheckVoList;
                                }else if(data.errorMsg){
                                    $U.showToast(data.errorMsg);
                                    if(data.result.jsCarQueryRespVo){
                                        _this.vcodeBase64 = 'data:image/png;base64,' + data.result.jsCarQueryRespVo.checkCode;
                                        _this.ciQueryCode = data.result.jsCarQueryRespVo.ciQueryCode;
                                    }
                                }else{
                                    $U.showToast('未查询到车型信息');
                                }
                            } else {
                                $U.showToast(data.errorMsg);
                            }
                        },
                        error: function (ex) {
                            $handleService.logger('error', '异常' + ex);
                        }
                    });
                },
                checkCarModel: function (t, VHL) {
                    // 选择车辆
                    this.VHL = VHL;
                },
                chooseCarModel: function () {
                    var vhl = this.VHL;
                    if(!vhl || !vhl.engineNo){
                        $U.showToast('请选择车型');
                        return;
                    }
                    this.show = false;
                    // 赋值操作 modelCode保留为空，让业务员选择车型
                    angular.extend($rootScope.carBeans.owner, {
                        name: vhl.owner
                    });
                    angular.extend($rootScope.carBeans.vehicle, {
                        licenseNo: vhl.licenseNo,
                        brandName: vhl.modelCode, // 车型查询出使用modelCode查询
                        //modelCode: vhl.modelCode,
                        modelCode: null, //保留为空，让业务员选择车型
                        completeKerbMass: vhl.completeKerbMass,
                        engineNo: vhl.engineNo,
                        singeinDate: vhl.singeinDate,
                        exhaustScale: vhl.exhaustScale,
                        factory: vhl.factory,
                        licenseTypeCode: vhl.licenseTypeCode,
                        seatCount: vhl.seatCount,
                        tonCount: vhl.tonCount,
                        chgOwnerDate: vhl.transferDate,
                        chgOwnerFlag: vhl.transferDate?'1':'0',
                        vehicleCategory: vhl.vehicleCategory,
                        useNatureShow: vhl.useNatureShow || '02', // 使用性质 默认非营业
                        fuelFlag: vhl.fuelFlag,
                        //jsQueryFlag: '1' //标志已查询江苏交管 不再传标志，后端江苏交管查询再次覆盖
                    });
                }
            };
           if($rootScope.switchBean.jsCarQuery =='1' && $rootScope.carBeans.vehicle.licenseNo.indexOf('苏')>-1){
               $scope.jsJg.frameNo = $scope.jsJg.vehicleIdentify = true;
           }else{
               $scope.jsJg.frameNo = $scope.jsJg.vehicleIdentify = false;
           }
            /*广东交管 相关变量*/
            $scope.gdJg = {
                show: false,
                vehicleIdentify: false, //车辆识别
                frameNo: false,
                VHL: {},
                carList: [], // 查询车型列表
                defer: null,
                loseFocus: function () {
                    var _this = this;
                    _this.defer = $q.defer();
                    var frameNo = $rootScope.carBeans.vehicle.frameNo;
                    if ($U.isEmpty(frameNo)) {
                        $U.showToast('请输入车架号');
                        return;
                    }
                    else {
                        if (!/^[a-z0-9A-Z]+$/.test(frameNo)) {
                            $U.showToast('车架号输入错误');
                            return;
                        }
                        var isReach = frameNo.indexOf("I") + frameNo.indexOf("O") + frameNo.indexOf("Q");
                        if (isReach > -3) { //车架号 不包含 I O Q
                            $U.showToast('您的车架号输入不正确');
                            return;
                        }
                    }

                    var licenseNo = $rootScope.carBeans.vehicle.licenseNo;
                    if ($U.isEmpty(licenseNo)) {
                        $U.showToast('请输入车牌号');
                        return;
                    } else {
                        //汉字+大写字母+4位数字或字母+汉字、数字、字母 \\\\7<=车牌总位数<=10
                        // var reg = /^[\u4e00-\u9fa5]{1}[A-Za-z]{1}[A-Za-z_0-9]{4}([\u4e00-\u9fa5]|[A-Za-z0-9]){1,4}?$/;
                        var reg=/^([\u4e00-\u9fa5]{1}([\u4e00-\u9fa5]|[A-Z0-9]){6,9})|([A-Z]{2}([\u4e00-\u9fa5]|[A-Z0-9]){5,8})|(([\u4e00-\u9fa5]|[A-Z0-9]){6,9}[\u4f7f]{1})$/;
                        if (!reg.test(licenseNo)) {
                            $U.showToast('您的车牌号输入不正确');
                            return;
                        }
                    }

                    _this.carList = [];
                    _this.queryCarList();
                    return _this.defer.promise;
                },
                onChange: function () {
                    if (this.vehicleIdentify) {
                        this.frameNo = true;
                    } else {
                        this.frameNo = false;
                    }
                },
                queryCarList: function () {
                    var _this = this;
                    _this.VHL = {};
                    $handleService.http({
                        url: "/vehicleInfo/gdVehicleModel",
                        method: 'POST',
                        data: {
                            frameNo: $rootScope.carBeans.vehicle.frameNo,
                            licenseNo: $rootScope.carBeans.vehicle.licenseNo,
                            companyCode: $U.getDeptCode()
                        },
                        success: function (data) {
                            if (data.resultCode == '0') {
                                if (data.result.pmVehicleInfoList && data.result.pmVehicleInfoList.length > 0) {
                                    _this.carList = data.result.pmVehicleInfoList;
                                    if(_this.carList.length==1){
                                        _this.checkCarModel(_this.carList[0]);
                                        _this.chooseCarModel();
                                    }else{
                                        _this.show = true;
                                    }
                                } else if (data.errorMsg) {
                                    $U.showToast(data.errorMsg);
                                    _this.defer.resolve();
                                } else {
                                    $U.showToast('未查询到车型信息');
                                    _this.defer.resolve();
                                }
                            } else {
                                $U.showToast(data.errorMsg);
                                _this.defer.reject();
                            }
                        },
                        error: function (ex) {
                            $handleService.logger('error', '异常' + ex);
                            _this.defer.reject();
                        }
                    });
                },
                checkCarModel: function (VHL) {
                    // 选择车辆
                    this.VHL = VHL;
                },
                chooseCarModel: function () {
                    var _this = this;
                    var vhl = _this.VHL;
                    if (!vhl || !vhl.engineNo) {
                        $U.showToast('请选择车型');
                        return;
                    }
                    _this.show = false;


                    /*
                    必返回字段：frameNo, licenseNo, llicenseTypeCode, engineNo, vehicleCategory, enrollDate, model
                    非必返回字段：transferDate, completeKerbMass, seatCount, tonCount, exhaustScale, factory, carKindCode, carKindCodeShow
                    */

                    //赋值并缓存交管数据，以交管数据为准
                    //修正字段名
                    vhl.singeinDate = vhl.enrollDate; //初登日期
                    vhl.chgOwnerDate = vhl.transferDate; //过户日期
                    $rootScope.carBeans.vehicle.jgVehicleModel = {};
                    angular.forEach($rootScope.carBeans.vehicle, function (value, key) {
                        if (vhl.hasOwnProperty(key) && (vhl[key] || vhl[key] == 0)) {
                            if(key!='licenseNo'&&!((key=='completeKerbMass' && !vhl[key]) || (key=='tonCount' && !vhl[key]) || (key=='seatCount' && !vhl[key]) || (key=='exhaustScale' && !vhl[key]))){
                                //赋值并缓存交管车型数据
                                $rootScope.carBeans.vehicle[key] = $rootScope.carBeans.vehicle.jgVehicleModel[key] = vhl[key];
                            }
                        }
                    });



                    $rootScope.carBeans.vehicle.chgOwnerFlag = '0'; //默认非过户车
                    $rootScope.carBeans.vehicle.brandName = vhl.model; //model只用于查车型
                    $rootScope.carBeans.vehicle.jgVehicleModel.model = vhl.model; //用于判断品牌名是否被覆盖，以便自动查询车型
                    $rootScope.carBeans.vehicle.gdQueryFlag = '1'; //标志已查询广东交管


                    if(vhl.licenseNo && vhl.licenseNo != $rootScope.carBeans.vehicle.licenseNo){
                        $handleService.showConfirm({
                            title: '温馨提示',
                            template: '您录入的车牌号码与交管平台返回的车牌号码不一致，请核实。交管返回的车牌号码：'+vhl.licenseNo,
                            buttons: [{ //Array[Object] (可选)。放在弹窗footer内的按钮。
                                text: '关闭',
                                type: 'button-cfirm-cancle',
                                onTap: function (e) {
                                    return false;
                                }
                            }, {
                                text: '使用交管车牌号',
                                type: 'button-cfirm-ok',
                                onTap: function (e) {
                                    return true;
                                }
                            }],
                            sure: function(){
                                $rootScope.carBeans.vehicle.licenseNo = $rootScope.carBeans.vehicle.jgVehicleModel.licenseNo = vhl.licenseNo;
                                _this.defer.resolve();
                            },
                            cancle: function () {
                                _this.defer.resolve();
                            }
                        })
                    }else{
                        $rootScope.carBeans.vehicle.licenseNo = $rootScope.carBeans.vehicle.jgVehicleModel.licenseNo = vhl.licenseNo;
                        _this.defer.resolve();
                    }

                }
            };


            $scope.nellieList = [{val:1,modelCode:true},{val:1,modelCode:true},{val:1,modelCode:true},{val:1,modelCode:true},{val:1,modelCode:true},{val:1,modelCode:true}];




            //Web OCR 身份证图片对象
            $scope.modyImg = {
                owImg: "",  //车主身份证图片
                appImg: "", //投保人身份证图片
                recImg: ""  //被保险人身份证图片
            };
            //----------------------------------------end    变量----------------------------------------//


            var Handle = (function (handle) {
                //初始化 页面 方法
                handle.initPage = function () {
                    //初始化动态Form 解决安卓 Bug
                    $handleService.initFormApp();
                    //区分web版本 和 App 版本
                    //web 版本 全名营销
                    if (window.requestParam.webSources) {
                        if (window.requestParam.webSources == "QMYX") {
                            //人人团时 显示交商配置险种信息
                            $rootScope.isShowSYCheck = true;
                            $rootScope.isShowJQCheck = true;
                            if(window.requestParam.interSalesmanCode){
                                $rootScope.carBeans.base.interSalesmanCode = window.requestParam.interSalesmanCode;
                            }

                            //外网访问的情况下  处理登录该处理的问题
                            //1.机构业务员信息存储
                            $handleService.sessionHandle.saveSession("SLS_INFO", {
                                employCode: window.requestParam.employCode,  // 业务员编码
                                deptCode: window.requestParam.deptCode,  //机构编码
                                isNewCoreFlag: "1",
                                newCoreDeptNo: window.requestParam.deptCode
                            });
                            $U.sessionHandle.saveSession("SLS_CDE",window.requestParam.employCode);
                            //3.提核传 推荐人ID
                            $rootScope.carBeans.refereeId = window.requestParam.refereeId;
                            //存cookie  为了支付
                            $handleService.setCookie("currentInfo",(window.requestParam.refereeId || ''));
                            //5.控制电子保单
                            $rootScope.carBeans.base.busiAttrConfig.policyStyles = $rootScope.carBeans.base.busiAttrConfig.policyStyles|| window.requestParam.elecPolicySy || "";
                            $rootScope.baseBean.syElectronicPolicy=window.requestParam.elecPolicyShangYe || '0'; //商业险电子保单
                            $rootScope.baseBean.jqElectronicPolicy=window.requestParam.elecPolicyJiaoQiang || '0'; //交强险电子保单
                            $rootScope.carBeans.peopleMarket = {
                                businessCode: "QMYX",   // 业务来源    string    QMYX: 人人团 HWEB: APP
                                refereeId: "",
                                outDf: "",
                                outUserId: "",
                                issueCode: "", //
                                cooperateCode: "", //客户源
                                attachNatures:window.requestParam.attachNatures||"" //所属性质
                            };
                            $rootScope.carBeans.peopleMarket.refereeId = window.requestParam.refereeId||"";
                            //流程初始化 暂存单编辑操作需要关联暂存单号
                            $handleService.initProcess($stateParams.TEMP_NO);
                            //机构判断
                            $handleService.deptJudge();
                        }
                    }
                    //处理全民营销的退回修改
                    //逻辑：需要根据单查询后台数据 进行赋值
                    if(window.requestParam && window.requestParam.webSources == "QMYX") {
                        var arrparam  = [];
                        var strparam =window.requestParam.appNoList;
                        if (strparam) {
                            if(strparam.indexOf(",")>-1){
                                arrparam = strparam.split(',');
                            }else{
                                arrparam.push(strparam);
                            }
                        }
                        Handle.qmysHandle({
                            appNoList: arrparam, //投保单号列表
                            orderNo: window.requestParam.orderNo //订单号orderNo
                        });
                    }

                    //------------------------------------- begin 其他信息 初始化 -------------------------------------//

                    //车牌信息
                    if($rootScope.carBeans.vehicle.licenseNo == "*-*") {
                        $rootScope.carBeans.vehicle.licenseNo = "";
                    }
                    //河北车船税解缴改革,行驶证地址处理
                    if($rootScope.carBeans.owner.provinceCode){
                        if($rootScope.carBeans.owner.provinceName){
                            $rootScope.address = $rootScope.carBeans.owner.provinceName+' '+$rootScope.carBeans.owner.cityName+' '+$rootScope.carBeans.owner.areaName;
                        }else{
                            $rootScope.address = $rootScope.address || '';
                        }
                    }else{
                        $rootScope.carBeans.owner.provinceCode = '130000';//默认河北省
                        $rootScope.carBeans.owner.cityCode = '130100';
                        $rootScope.carBeans.owner.areaCode = '130102';
                    }
                    //开关配置
                    $handleService.getConfigSwitch(function() {
                        //只允许电子保单样式
                        if($rootScope.switchBean.elecPolicySwitch) {
                            $rootScope.carBeans.base.busiAttrConfig.policyStyles = '1';
                        }
                        if(pageCode=='RENEWAL' && $rootScope.switchBean.gdCarQuery == '1'){
                            $scope.gdJg.vehicleIdentify = true;
                        }else if((pageCode=='DRAFTS' || pageCode=='PQUERY')&& $rootScope.switchBean.gdCarQuery == '1' && $rootScope.carBeans.vehicle.licenseNo  && $rootScope.carBeans.vehicle.licenseNo != '*-*'){
                            $scope.gdJg.vehicleIdentify = true;
                        }
                    });
                    // 证件类型输入位数控制
                    $scope.maxLength($rootScope.carBeans.owner.identifyType);
                    //获取特约
                    Handle.getClauseList();
                    //获取车主地址
                    Handle.getAddress('owner',true)
                    //------------------------------------- end   其他信息 初始化 -------------------------------------//
                };
                handle.infoHandle = function (beans) {
                    var _val_beans = angular.copy(beans);
                    // 投保人信息 -->同车主 -->赋值
                    beans.applicant.insuredType =  $scope.isCarMass ? '2':'1';

                    /** 投保人姓名 */
                    beans.applicant.name = _val_beans.owner.name;
                    /**投保人证件类型*/
                    beans.applicant.identifyType = _val_beans.owner.identifyType;
                    /** 投保人证件号码 */
                    beans.applicant.identifyNumber = _val_beans.owner.identifyNumber;
                    /** 投保人联系人电话 */
                    beans.applicant.phone = _val_beans.owner.mobilePhone;
                    /** 投保人邮箱 */
                    beans.applicant.email = _val_beans.owner.email;
                    /** 性别 */
                    beans.applicant.gender = _val_beans.owner.gender;
                    /** 出生日期 */
                    beans.applicant.birthday = _val_beans.owner.birthday;
                    if(!$rootScope.switchBean.driLicenseSwitch){//河北机构不同步车主地址
                        beans.applicant.address = _val_beans.owner.address
                    }
                    // }
                    // 被保人信息 -->同车主 -->赋值
                    //被保人类别
                    beans.insured.insuredType = $scope.isCarMass ? '2':'1';
                    /** 被保人姓名 */
                    beans.insured.name = _val_beans.owner.name;
                    /** 被保人证件类型 */
                    beans.insured.identifyType = _val_beans.owner.identifyType;
                    /** 被保人证件号码 */
                    beans.insured.identifyNumber = _val_beans.owner.identifyNumber;
                    /** 被保人联系人电话 */
                    beans.insured.phone = _val_beans.owner.mobilePhone;

                    /** 被保人邮箱 */
                    beans.insured.email = _val_beans.owner.email;
                    /** 性别 */
                    beans.insured.gender = _val_beans.owner.gender;
                    /** 出生日期 */
                    beans.insured.birthday = _val_beans.owner.birthday;
                    if(!$rootScope.switchBean.driLicenseSwitch){//河北机构不同步车主地址
                        beans.insured.address = _val_beans.owner.address;
                    }
                };
                handle.qmysHandle = function (opts) {

                    var options = {
                        appNoList: [], //投保单号列表
                        orderNo: "" //订单号
                    };
                    var salesmanCode=window.requestParam.issueCode||"";
                    angular.extend(options, opts);
                    $handleService.logger("object", options, "退回修改参数");
                    if ($scope.pageCode == "PQUERY") { //退回修改 标识
                        $handleService.http({
                            url: "/correct?operatorCode="+salesmanCode,
                            method: 'POST',
                            data: options,
                            success: function (data) {
                                $handleService.logger("object", data, "退回修改数据");
                                if(data.resultCode=='0'){
                                    $handleService.reModifyPolicyData(data.result, true);
                                }else{
                                    $U.showToast(data.errorMsg);
                                }
                            },
                            error: function (ex) {
                                $handleService.logger('error', '退回修改异常' + ex);
                            }
                        });
                    };
                };
                 //通过身份证号默认地址省市区
                handle.getAddress = function (type,d) {
                    if($rootScope.carBeans[type].identifyType == '01' && $rootScope.switchBean.idcardAreaSwitch && $rootScope.carBeans[type].identifyNumber.length>=6){
                        if(d && $rootScope.carBeans[type].address){
                            return;
                        }
                        $handleService.http({
                            url: '/countryManager/getAreaName?idNo='+$rootScope.carBeans[type].identifyNumber,
                            method: 'GET',
                            success: function(data){
                                if(data.resultCode == '0'){
                                    $rootScope.carBeans[type].address = data.result;
                                }
                            },
                            error: function (ex) {
                                $handleService.logger('error', ex);
                            }
                        })
                    }
                };
                //车主信息 赋值方法 -->OCR 调用
                handle.ownfoHandle = function (type, data) {
                    switch (type) {
                        case 1:
                            $rootScope.carBeans.owner.name = data.name; //车主姓名
                            $rootScope.carBeans.owner.identifyNumber = data.id_number; //车主身份证
                            //车主地址为空证件类型为身份证时赋值地址
                            if($rootScope.switchBean.idcardAreaSwitch && $rootScope.carBeans.owner.identifyType == '01'){
                                $rootScope.carBeans.owner.address = data.address
                            }else{
                                $rootScope.carBeans.owner.address = $rootScope.carBeans.owner.address
                            }
                            break;
                        case 2:
                            $rootScope.carBeans.applicant.name = data.name; //投保人姓名
                            $rootScope.carBeans.applicant.identifyNumber = data.id_number; //投保人身份证
                            break;
                        case 3:
                            $rootScope.carBeans.insured.name= data.name; //被保人姓名
                            $rootScope.carBeans.insured.identifyNumber = data.id_number; //被保人身份证
                            break;
                        case 4:
                            $rootScope.carBeans.vehicle.licenseNo = data.vehicle_license_main_plate_num; // 车牌号
                            $rootScope.carBeans.vehicle.frameNo = data.vehicle_license_main_vin; // 车架号
                            $rootScope.carBeans.vehicle.engineNo = data.vehicle_license_main_engine_no; // 发动机
                            $rootScope.carBeans.vehicle.brandName = data.vehicle_license_main_model; // 品牌型号
                            $rootScope.carBeans.vehicle.singeinDate = data.vehicle_license_main_register_date; // 发证日期
                            $rootScope.carBeans.owner.address = data.address; // 车主地址
                            //江苏机构，车牌号为苏的要显示 车架号
                            if($rootScope.switchBean.jsCarQuery =='1' && $rootScope.carBeans.vehicle.licenseNo.indexOf('苏')>-1){
                                $scope.jsJg.frameNo = $scope.jsJg.vehicleIdentify = true;
                            }else{
                                $scope.jsJg.frameNo = $scope.jsJg.vehicleIdentify = false;
                            }
                            $scope.queryRenewal();// OCR后调用查询续保 两号查询
                            break;
                    }
                };
                //车主年龄处理
                handle.getOwnerAge = function () {
                    if($rootScope.carBeans.owner.identifyType =='01'){
                        $rootScope.baseBean.ownerAge = $U.GetAgeFromIdCard($rootScope.carBeans.owner.identifyNumber);
                    }else if($rootScope.carBeans.owner.identifyType =='15'){
                        var cardInfo = $U.getIdCardInfo($rootScope.carBeans.owner.identifyNumber);
                        $rootScope.carBeans.owner.age = $rootScope.baseBean.ownerAge = cardInfo.age;
                        $rootScope.carBeans.owner.birthday = cardInfo.birthday;
                        $rootScope.carBeans.owner.sex = cardInfo.sex;
                    }else{
                        $rootScope.baseBean.ownerAge = $U.GetAgeFromBirthday($rootScope.carBeans.owner.birthday);
                    }
                };
                //获取两号标志
                handle.getTwoNumFlag = function () {
                    if($rootScope.carBeans.vehicle.maskFrameNo&&$rootScope.carBeans.vehicle.maskEngineNo){
                        $rootScope.baseBean.is_twoNumber_success = true;
                    }else{
                        $rootScope.baseBean.is_twoNumber_success = false;//两号是否查询成功
                    }
                };

                //投被保人是否同车主 赋值
                handle.appAndInsureIsSameOwer = function () {
                    if($rootScope.carBeans.applicant.name==''&&$rootScope.carBeans.applicant.identifyNumber=='') {
                        $scope.hasAppName = false; //是否存在投保人
                        //投保人 被保人信息处理
                        Handle.infoHandle($rootScope.carBeans);
                        //当投保人姓名为空时 投保人同车主  被保人同车主
                        $rootScope.baseBean.appIsSameDriver = true;
                        $rootScope.baseBean.insuredSameDriver = true;
                    }  else {
                        $scope.hasAppName = true; //是否存在投保人
                    }
                };
                //新核心字段个代和协作人信息，试算传给后端 石梦星
                handle.personalAgentAndHelpPeopleForNewHexin = function () {
                    //业务员姓名
                    //将选择的个人代理编码和名称赋值
                    if(window.requestParam && window.requestParam.webSources == "QMYX") {
                        $rootScope.carBeans.base.intermediaryCode = window.requestParam.agentCode || "";
                        $rootScope.carBeans.base.intermediaryName = "";
                    }
                    //通过协作人编码找到协作人名称
                    if (!$U.isEmpty($rootScope.carBeans.base.cooperateCode)) {
                        //将选择的协作人编码和名称赋值
                        for (var helpPeopleIndex in $scope.assistOptions) {
                            var helpPeopleModel = $scope.assistOptions[helpPeopleIndex];
                            if (helpPeopleModel.cooperateCode == $rootScope.carBeans.base.cooperateCode) {
                                $rootScope.carBeans.base.cooperateName = helpPeopleModel.cooperateName;
                            }
                        }
                    }
                };

                //获取特约
                handle.getClauseList = function() {
                    $handleService.http({
                        url: "/clause/getClauseList?dptNo=" + $U.getDeptCode(),
                        method: 'GET',
                        complete: function () {
                            $handleService.showLoading('show');
                        },
                        success: function (data) {
                            $handleService.logger('object', data, '获取特约信息');
                            $rootScope.baseBean.hasYingyunTY = false; //非营业特约标志
                            $rootScope.clauseList = data.clauseList||[]; //存储特约
                            angular.forEach(data.clauseList, function(item) {
                                if(item.clauseCode == "HA0004N") { //
                                    $rootScope.baseBean.hasYingyunTY = true;
                                }
                                angular.forEach($rootScope.baseBean.clauseList, function(itemS, index) {
                                    if(item.clauseCode == itemS.clauseCode) {
                                        angular.extend(itemS, item);
                                    }
                                });
                            });
                        },
                        error: function (ex) {
                            $handleService.logger('error', ex);
                        }
                    });
                };
                handle.dutyFree = function (dutyFlag) {
                    //条件：1.非云南机构 2.并且 不是续保单 去判断减免税标识
                    //本地算税机构
                    var taxType = "",   //减免税类型
                        dedueCde = "",   //减免税原因
                        dedueDes = "",   //减免税描述
                        dedueTyp = "";   //减免税方案

                    switch (dutyFlag) {
                        // 0：不属于减免税
                        case "0":
                            taxType = "02";
                            dedueDes = "纳税车型";
                            break;
                        // 1：第三批能源免税车型
                        case "1":
                        case "3":
                            taxType = "05"; // 免税
                            dedueDes = "免税车型";
                            dedueCde = "E"; // 减免税车原因
                            dedueTyp = "E"; // 减免税车方案 免税
                            break;
                        // 2：第三批减税车型
                        case "2":
                        case "4":
                            // 如果第三批车辆初登日期在20150911以前，不减税
                            taxType = "04"; // 减税
                            dedueDes = "减税车型";
                            dedueCde = "E"; // 减免税车原因
                            dedueTyp = "A"; // 减免税车方案 比例减免
                            break;
                        default:
                            taxType = "02";
                            dedueDes = "纳税车型";
                            break;
                    }

                    return {
                        taxRelifFlag: taxType
                    };
                };
                handle.licenseNoCheck = function () {
                    $handleService.http({
                        url: "/vehicleInfo/queryLicenseNo?deptCode="+$U.getDeptCode(),
                        method: 'GET',
                        success: function (data) {
                            $handleService.logger('object', data, '获取车牌区域');
                            if(data.resultCode=='0'){
                                $rootScope.carBeans.vehicle.licenseNo=data.result;
                                //江苏交管查询由手动触发改为自动触发 1112
                                if($rootScope.switchBean.jsCarQuery =='1' && $rootScope.carBeans.vehicle.licenseNo.indexOf('苏')>-1){
                                    $scope.jsJg.frameNo = $scope.jsJg.vehicleIdentify = true;
                                }else{
                                    $scope.jsJg.frameNo = $scope.jsJg.vehicleIdentify = false;
                                }
                            }
                        },
                        error: function (ex) {
                            $handleService.logger('error', ex);
                        }
                    });
                };
                handle.imgChoose_Html5Plus = function (type, certificateType) {//
                    function showActionSheet() {
                       var actionbuttons = [{ title: "拍照" }, { title: "相册选取" }];
                       var actionstyle = { cancel: "取消", buttons: actionbuttons };
                       window.plus.nativeUI.actionSheet(actionstyle, function (e) {
                          if (e.index == 1) {
                             getImage_Html5Plus(imgFunc);
                          } else if (e.index == 2) {
                             galleryImg_Html5Plus(imgFunc);
                          }
                       });
                    }
                    function imgFunc(error, content) {
                       if (error == 1) {
                          $handleService.showAlert('提示', content || '拍照失败');
                       } else {
                             // todo  调用  OCR  伍念
                             $generalService.ocrImgUpload({
                                type: certificateType, // 1.行驶证 2.身份证 3.驾驶证 4.银行卡
                                img: content,
                                success: function (data) {
                                    $handleService.logger('info', data);
                                    if (data.type != '未知类型') {
                                        Handle.ownfoHandle(type, data);
                                        $scope.ocr = true;
                                    }
                                    else {
                                        $U.showToast('请选择带有清晰的证件号码的照片');
                                        $scope.ocr = false;
                                    }
                                }
                            });
                       }
                    };
                    showActionSheet();
                 }
                return handle;
            })(Handle || {});
            Handle.initPage();

            //----------------------------------------begin 车主信息页面----------------------------------//

            //----------------------------------------begin 监听----------------------------------------//
            // 改变号牌颜色 联动号牌类型
            $scope.colorChange = function(){
               switch($rootScope.scjg.licenseColorCode){
                   case "01":// 蓝---02小型汽车
                        $rootScope.scjg.licenseTypeCode = "02";
                        break;
                   case "04":// 黄-----01 大型汽车
                        $rootScope.scjg.licenseTypeCode = "01";
                        break;
                   case "06":// 渐变绿-----52 小型新能源汽车
                        $rootScope.scjg.licenseTypeCode = "52";
                        break;
                   case "07":// 黄绿双拼----51 大型新能源汽车
                        $rootScope.scjg.licenseTypeCode = "51";
                        break;
                   default:
                        $rootScope.scjg.licenseTypeCode = "";
                        break;
               }
            }
            // 监听车牌
            $scope.$watch("carBeans.vehicle.licenseNo", function (licenseNo) {
                $rootScope.scjg.isShowClOpt = false;
                if($rootScope.switchBean.queryCarInsuranceSwitch &&  (/^川.{1,}$/g).test(licenseNo)){
                    // 开关1 && 以"川"开头
                    if((/^川.*挂$/g).test(licenseNo)){// 川--挂  15
                        $rootScope.scjg.licenseTypeCode = '15';
                    }
                    else if((/^川.*学$/g).test(licenseNo)){// 川--学  16
                        $rootScope.scjg.licenseTypeCode = '16';
                    }
                    else if((/^川.*警$/g).test(licenseNo)){// 川--警  23
                        $rootScope.scjg.licenseTypeCode = '23';
                    }
                    else{
                        $rootScope.scjg.isShowClOpt = true;
                        $scope.colorChange();
                       // $rootScope.carBeans.vehicle.licenseColorCode = "";
                    }
                }
            })
            
            //监听 OCR 文件变化 ---》 非原生  web 访问时的OCR
            //1.车主身份证OCR
            $scope.$watch("modyImg.owImg", function (file) {
                if (file) {
                    $generalService.ocrGetInfo({
                        cardType:"2",  //身份证
                        file:file,
                        success: function (data) {
                            Handle.ownfoHandle(1,data);
                        }
                    });
                }
            })
            //获取点击身份
            $scope.getPersonel = function (type) {
                $scope.personelClick = type
            }
            //获取省市区地址
            $scope.getAdress = function() {
                Handle.getAddress($scope.personelClick)
            }
            //选择城市
            $scope.selctCountry = function(){
                if($scope.canClick){//解决点击穿透
                    var oneLevelId = $('#show_contact').attr('data-province-code');
                    var twoLevelId = $('#show_contact').attr('data-city-code');
                    var threeLevelId = $('#show_contact').attr('data-district-code');
    
                    new IosSelect(3, 
                        [iosProvinces, iosCitys, iosCountys],
                        {
                            title: '地址选择',
                            itemHeight: 35,
                            relation: [1, 1],
                            oneLevelId: $rootScope.carBeans.owner.provinceCode,
                            twoLevelId: $rootScope.carBeans.owner.cityCode,
                            threeLevelId: $rootScope.carBeans.owner.areaCode,
                            callback: function (selectOneObj, selectTwoObj, selectThreeObj) {
                                $scope.canClick = false;//解决点击穿透
                                $rootScope.carBeans.owner.provinceCode = selectOneObj.id;//赋值
                                $rootScope.carBeans.owner.provinceName = selectOneObj.value;
                                // $('#provinceCode').attr('data-province-name', selectOneObj.value);
                                $rootScope.carBeans.owner.cityCode = selectTwoObj.id; 
                                $rootScope.carBeans.owner.cityName = selectTwoObj.value;
                                // $('#cityCode').attr('data-city-name', selectTwoObj.value);
                                $rootScope.carBeans.owner.areaCode = selectThreeObj.id; 
                                $rootScope.carBeans.owner.areaName = selectThreeObj.value;
                                // $('#areaCode').attr('data-area-name', selectThreeObj.value);
                                // $('#show_contact').attr('data-province-code', selectOneObj.id);
                                // $('#show_contact').attr('data-city-code', selectTwoObj.id);
                                // $('#show_contact').attr('data-district-code', selectThreeObj.id);
                                $('#show_contact').val(selectOneObj.value + ' ' + selectTwoObj.value + ' ' + selectThreeObj.value);
                                $rootScope.address = $('#show_contact').val();
                                setTimeout(function(){//解决点击穿透
                                    $scope.canClick = true
                                },400)
                            }
                    });
                }

            }
            // 监听行车证
            $scope.$watch("modyImg.owImg4", function (file) {
                if (file) {
                    $generalService.ocrGetInfo({
                        cardType:"1",  //行车证
                        file:file,
                        success: function (data) {
                            Handle.ownfoHandle(4,data);
                        }
                    });
                }
            });
            $scope.ocrHandleQmybApp = function(type, certificateType){
                Handle.imgChoose_Html5Plus(type, certificateType);
            }
            //2.投保人身份证OCR
            $scope.$watch("modyImg.appImg", function (file) {
                if (file) {
                    $generalService.ocrGetInfo({
                        cardType:"2",
                        file:file,
                        success: function (data) {
                            Handle.ownfoHandle(2,data);
                        }
                    });
                }
            });
            //3.被保险人身份证OCR
            $scope.$watch("modyImg.recImg", function (file) {
                if (file) {
                    $generalService.ocrGetInfo({
                        cardType:"2",
                        file:file,
                        success: function (data) {
                            Handle.ownfoHandle(3,data);
                        }
                    });
                }
            });
            //3.车架号修改广东交管查询状态重置
            $rootScope.$watch("carBeans.vehicle.frameNo", function(val){
                $rootScope.carBeans.vehicle.gdQueryFlag = '';
            });
            //----------------------------------------end 监听----------------------------------------//

            //清除数据
            $scope.clearAll = function() {
                $rootScope.baseBean = angular.copy(BaseBean);
                $rootScope.carBeans = angular.copy(CarBeans);
                //$rootScope.carBeans = angular.copy(riskObj);
                $rootScope.baseBean.syRiskList = angular.copy(SY_RISK);
                $rootScope.baseBean.jqRiskList = angular.copy(JQ_RISK);
            };

            //切换证件类型
            $scope.default = function (val, b) {
                if (val == 'tes1') {
                    $rootScope.carBeans.owner.identifyNumber = '';
                    $rootScope.carBeans.owner.birthday = '';
                    $rootScope.tes1 = false;
                }else if(val == 'tes10'){
                    $rootScope.carBeans.owner.identifyNumber='';
                    $rootScope.carBeans.owner.birthday='';
                }
                $scope.maxLength(b);
            };
            //获取车牌区域
            $scope.licenseNoCheck=function () {
                if(!$rootScope.carBeans.vehicle.licenseNo){
                    Handle.licenseNoCheck();
                }else if($rootScope.switchBean.jsCarQuery =='1' && $rootScope.carBeans.vehicle.licenseNo.indexOf('苏')>-1){
                    //江苏交管查询由手动触发改为自动触发 1112
                    if($rootScope.switchBean.jsCarQuery =='1' && $rootScope.carBeans.vehicle.licenseNo.indexOf('苏')>-1){
                        $scope.jsJg.frameNo = $scope.jsJg.vehicleIdentify = true;
                    }else{
                        $scope.jsJg.frameNo = $scope.jsJg.vehicleIdentify = false;
                    }
                }

            };
            
            //OCR 方法->OCR调用
            $scope.ocrHandle = function (type, certificateType) {
                /*
                  type: 返回结果后,需要被处理的信息信息类型
                  certificateType: ORC扫描的证件类型, 默认2身份证
                */
                certificateType = certificateType || '2';
                $handleService.appHandle.cameraHandle({
                    success: function (img) {
                        $generalService.ocrImgUpload({
                            type: certificateType, // 1.行驶证 2.身份证 3.驾驶证 4.银行卡
                            img: img,
                            success: function (data) {
                                $handleService.logger('info', data);
                                if (data.type != '未知类型') {
                                    Handle.ownfoHandle(type, data);
                                    $scope.ocr = true;
                                }
                                else {
                                    $U.showToast('请选择带有清晰的证件号码的照片');
                                    $scope.ocr = false;
                                }
                            }
                        });
                    }
                });
            };
            //车牌号输入完成失去焦点后开始请求两号
            $scope.carCheck=function () {
                if($rootScope.carBeans.vehicle.licenseNo==''){
                    return;
                }
                //汉字+大写字母+4位数字或字母+汉字、数字、字母 \\\\7<=车牌总位数<=10
                var reg=/^([\u4e00-\u9fa5]{1}([\u4e00-\u9fa5]|[A-Z0-9]){6,9})|([A-Z]{2}([\u4e00-\u9fa5]|[A-Z0-9]){5,8})|(([\u4e00-\u9fa5]|[A-Z0-9]){6,9}[\u4f7f]{1})$/;
                // var reg=/^([\u4e00-\u9fa5]{1}|[A-Z]{2})([\u4e00-\u9fa5]|[A-Z0-9]){1}[A-Z0-9]{4,7}([\u4e00-\u9fa5]|[A-Z0-9]){1}?$/;
                if(reg.test($rootScope.carBeans.vehicle.licenseNo)){//!reg.test(value)
                    // Handle.renewal($rootScope.CAR_BEANS.LCN_NO);
                    // $scope.queryTwoNumber($rootScope.carBeans.vehicle.licenseNo);
                    if($rootScope.switchBean.jsCarQuery =='1' && $rootScope.carBeans.vehicle.licenseNo.indexOf('苏')>-1){
                        $scope.jsJg.frameNo = $scope.jsJg.vehicleIdentify = true;
                    }else if($scope.switchBean.gdCarQuery == '1'){
                        $scope.gdJg.vehicleIdentify = true;
                    }
                    $scope.queryRenewal();

                }else{
                    $U.showToast('您的车牌号输入不正确');
                }
                //每次修改车牌号流程初始化
                $handleService.clearImageIdAndQuotationNo();
                // $handleService.initProcess();
            };
            //车主信息提交方法
            $scope.owinfoSubmit = function (form) {
                //投保时长
                HandleService.operateTime({
                    operatId: "02"
                });
                //监听车牌  判断是否是新车
                if(($rootScope.carBeans.vehicle.licenseNo == '' || $rootScope.carBeans.vehicle.licenseNo == '*-*') && $rootScope.switchBean.frameNoSwitch == '1'){
                    $rootScope.isNewCarFlag = true;
                }else{
                    $rootScope.isNewCarFlag = false;
                    $rootScope.carBeans.base.frmNoFlag = '';
                }
                //个人代理选择校验
                if ($rootScope.baseBean.isCmpnyAgt && !$rootScope.carBeans.base.intermediaryCode) {
                    $U.showToast('请选择渠道协议');
                    return;
                }

                $handleService.validateForm.call(this, form);
                //校验表单
                if (form.$valid) {
                    var TypeRegExp = {
                        //身份证
                        "IdCodeValid": function (code) {
                            return $U.IdCodeValid(code);
                        },
                        //护照
                        "02": /^([A-Z0-9]{4,20})$/,
                        //军人证
                        "03": /^([a-zA-Z0-9\(\)\（\）]{4,20})$/,
                        //学生证
                        "04": /^([a-zA-Z0-9\(\)\（\）]{4,20})$/,
                        //台胞证
                        "05": /^([0-9A-Z\(\)\（\）]{4,20})$/,
                        //港澳通行证
                        "06": /^((.){4,20})$/,
                        //出生证
                        "07": /^([a-zA-Z0-9]{1,20})$/,
                        //统一社会信用代码
                        "09": /^([A-Z0-9]{18})$/,
                        //组织机构代码
                        "10": /^([a-zA-Z0-9]{8}-[0-9|X]|[a-zA-Z0-9]{10}|[a-zA-Z0-9]{18})$/,
                        //工商注册号
                        "11": /^([a-zA-Z0-9]{4,20})$/,
                        //税务登记证号
                        "12": /^([a-zA-Z0-9]{4,20})$/,
                        //纳税人识别号
                        "13": /^([a-zA-Z0-9]{15}|[a-zA-Z0-9]{17}|[a-zA-Z0-9]{18}|[a-zA-Z0-9]{20})$/,
                        //港澳台居民居住证
                        "15": /^[1-9]\d{5}[1-9]\d{3}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{3}([0-9]|X)$/
                    };
                    var Idres ={}; //身份证验证返回
                    var typeRExp=''; //取匹配的正则
                    var carReg=/^([\u4e00-\u9fa5]{1}([\u4e00-\u9fa5]|[A-Z0-9]){6,9})|([A-Z]{2}([\u4e00-\u9fa5]|[A-Z0-9]){5,8})|(([\u4e00-\u9fa5]|[A-Z0-9]){6,9}[\u4f7f]{1})$/;
                    if($rootScope.carBeans.owner.identifyType =='01'){
                        Idres = TypeRegExp.IdCodeValid($rootScope.carBeans.owner.identifyNumber);
                    }else{
                        typeRExp = new RegExp(TypeRegExp[$rootScope.carBeans.owner.identifyType] || /\S/);  //获取证件正则
                    }

                    //验证车牌
                    if(($rootScope.carBeans.vehicle.licenseNo||"") != "" && ($rootScope.carBeans.vehicle.licenseNo||"") != "*-*") {
                        if(!carReg.test($rootScope.carBeans.vehicle.licenseNo)) {
                            $U.showToast('您的车牌号码输入不正确');
                            return;
                        }
                    }
                    //车主个人
                    if($rootScope.carBeans.owner.insuredTypeCode == "1") {
                        if(!/^[\u4e00-\u9fa5 •\·]{2,10}$/.test($rootScope.carBeans.owner.name)) {
                            $U.showToast('您的车主姓名输入有误');
                            return;
                        }
                    } else {
                        //企业机关
                        if(!/^[\u4e00-\u9fa5 •\·\(\)\（\）A-Za-z]{2,25}$/.test($rootScope.carBeans.owner.name)) {
                            $U.showToast('您的车主姓名输入有误');
                            return;
                        }
                    }
                    //身份证单独校验
                    if($rootScope.carBeans.owner.identifyType=='01'){
                        if(Idres.pass==false) {
                            $U.showToast('您的车主证件号码输入不正确');
                            return;
                        }
                    }
                    else if (typeRExp.test($rootScope.carBeans.owner.identifyNumber) == false) {
                        $U.showToast('您的车主证件号码输入不正确');
                        return;
                    }
                    if($rootScope.carBeans.owner.mobilePhone){
                        var num =$rootScope.carBeans.owner.mobilePhone;
                        var regphone =/^([1][3-9][0-9]{9})$|^((\d){3}(\*){4}(\d){4})$/;
                        var regtel =/^0\d{2,3}-?\d{7,8}$|^0\d{2}(\*){4,5}\d{4}$/;
                        if(!regphone.test(num) && !regtel.test(num)){
                            $U.showToast('请输入11位手机号码或者区号+座机格式联系电话');
                            return;
                        }
                    }
                    
                    /*  ---  Subsection comment block  ---  */
                    //车主地址验证0910
                    if ($rootScope.carBeans.owner.address && $rootScope.switchBean.driLicenseSwitch) {
                        var r = $U.checkAddress({
                            person: '车主',
                            address: $rootScope.carBeans.owner.address
                        })
                        if (!r.chkres && r.errmsg) {
                            $U.showToast(r.errmsg);
                            return;
                        }
                    }
                    /*  ---  Subsection comment block  ---  */

                    //投被保人信息处理 车主数据校验正确后再赋值给投、被保人
                    Handle.appAndInsureIsSameOwer();

                    var _valiFunc = function () {
                        $handleService.logger('object', $rootScope.carBeans, '车主信息页面数据');
                        var slsInfo = JSON.parse(window.sessionStorage.getItem('SLS_INFO'));
                        $rootScope.carBeans.base.companyCode = $U.getDeptCode();
                        //如果是掌上宝就取登录的业务员编号  否则就是人人团 赋值为空
                        slsInfo.salesmanCode ? ($rootScope.carBeans.base.operatorCode = slsInfo.salesmanCode) : $rootScope.carBeans.base.operatorCode=''; //操作员
                        $rootScope.carBeans.base.salesmanCode = $U.getSlsCode(); //业务员或销售助理代码
                        //  $handleService.saveTmp();
                        console.log($rootScope.carBeans)
                        //广东本地旧车自动交管查询
                        if($rootScope.switchBean.gdCarQuery == '1' && $rootScope.carBeans.vehicle.gdQueryFlag != '1' &&  $rootScope.carBeans.vehicle.licenseNo && $rootScope.carBeans.vehicle.licenseNo.slice(0, 1) == '粤'){
                            $scope.gdJg.loseFocus()
                                .then(function(){
                                    $location.path("tab/carinfo");//跳转车辆信息
                                }, function(error){
                                    // 用两号数据查的交管信息 , 查询失败了停留在原页面, 不跳转 , 并清空两号数据
                                    if($rootScope.baseBean.is_twoNumber_success){
                                        $rootScope.baseBean.is_twoNumber_success = false;
                                        //  清空2号数据
                                        $rootScope.carBeans.vehicle.frameNo = $rootScope.carBeans.vehicle.engineNo =$rootScope.carBeans.vehicle.maskEngineNo = $rootScope.carBeans.vehicle.maskFrameNo= "";
                                    }else{
                                        $location.path("tab/carinfo");//跳转车辆信息
                                    }
                                });
                        }else{
                            $location.path("tab/carinfo");//跳转车辆信息
                        }
                    };
                    Handle.personalAgentAndHelpPeopleForNewHexin();
                    Handle.getOwnerAge();  // 车龄处理
                    Handle.getTwoNumFlag();//获取两号标志
                    $rootScope.baseBean.shortJQBtn = '0'; //跳转到车辆信息页面时将短期交强险开关关闭
                    $rootScope.baseBean.shortSYBtn = '0'; //跳转到车辆信息页面时将短期商业险开关关闭
                    _valiFunc();
                }
            };

            $rootScope.$on('$stateChangeSuccess', function (ev, to, toParams, from, fromParams) {
                $rootScope.prePage = from; //from为前一个页面的路由信息：url,cache,views,name
            });

            //免两号异步查询 接口1: 续保查询  伍念
            $scope.queryRenewal = function(){
                if($rootScope.switchBean.newTwoNoSwitch!='1'){// 开关关闭 走老方法
                    $scope.queryTwoNumber();
                    return;
                }
                if(pageCode=='RENEWAL'){
                    return;
                }
                $rootScope.isShowTwoNoQueryBtn = false;
                //加载框文案
                $rootScope.loadingStr ='续保查询中';
                var data = {
                    licenseNo: $rootScope.carBeans.vehicle.licenseNo,
                    insuredProduct:'0'
                }
                $handleService.http({
                    url: "/renewal/queryPolicyInfo?flowId=" + $rootScope.flowId,
                    method: 'POST',
                    data: data,
                    success: function (data) {
                        //加载框文案
                        if (data.resultCode == "0") { // 能查到续保信息
                            // 设置该车辆有续保信息的标志
                            $handleService.uMengListen("twoNumber");
                            if(data.result.length > 1){
                                $rootScope.vhlList = angular.copy(data.result);
                                $scope.isShowCar = true;
                            }else{
                                if(data.result[0].vehicle && data.result[0].vehicle.licenseNo=='*-*'){
                                    // 新车次年续保车牌号更新
                                    data.result[0].vehicle.licenseNo = $rootScope.carBeans.vehicle.licenseNo;
                                }
                                $rootScope.dataList=data.result[0];
                                $rootScope.isShowTwoNoQueryBtn = false;
                                $state.go('tab.licensePlate');
                            }

                        }else{ // 未查到续保信息
                            // 继续调用接口2
                            $scope.queryPolicyInfoWithTwoNo();
                            $rootScope.isShowTwoNoQueryBtn = true;
                            //   $rootScope.carBeans.vehicle.frameNo = '';//车架号
                            //   $rootScope.carBeans.vehicle.engineNo = '';//发动机号
                            //   $rootScope.carBeans.vehicle.singeinDate = '';//初登日期
                            //   $rootScope.carBeans.vehicle.modelName = '';//品牌型号
                        }
                        $rootScope.loadingStr ='正在加载';
                    },
                    error: function (ex) {
                        $handleService.logger('error', ex);
                        //加载框文案
                        $rootScope.loadingStr ='正在加载';
                    }
                });
            }
            //免两号异步查询 接口2: 两号==>续保查询  伍念
            $scope.queryPolicyInfoWithTwoNo = function(){
                if(pageCode=='RENEWAL'){
                    return;
                }
                $rootScope.loadingStr ='两号续保查询中';
                $handleService.http({
                    url: "/renewal/queryPolicyInfoWithTwoNo?flowId=" + $rootScope.flowId + "&licenseNo="+$rootScope.carBeans.vehicle.licenseNo+"&salesCode=" + $U.getSlsCode() +"&companyCode=" + $U.getDeptCode(),
                    method: 'GET',
                    hasShowLoadding: false,
                    success: function (data) {
                        //加载框文案
                        if (data.resultCode == "0") {
                            $handleService.uMengListen("twoNumber");
                            if(data.dateSource=='1'){  //续保数据
                                if(data.result.policyInfos.length > 1){
                                    $rootScope.vhlList = angular.copy(data.result.policyInfos);
                                    $scope.isShowCar = true;
                                }else{
                                    $rootScope.dataList=data.result.policyInfos[0];
                                    $state.go('tab.licensePlate');
                                }
                                if($rootScope.dataList.vehicle && $rootScope.dataList.vehicle.licenseNo=='*-*'){
                                    // 新车次年续保车牌号更新
                                    $rootScope.dataList.vehicle.licenseNo = $rootScope.carBeans.vehicle.licenseNo;
                                }

                            }else {
                                $rootScope.isShowTwoNoQueryBtn = true;  // 已经获取了车辆信息
                                if(data.result.carModelQueryRespDtoList.length){
                                    $rootScope.dataList.vehicle = data.result.carModelQueryRespDtoList[0];
                                }else{
                                    $rootScope.dataList.vehicle = data.result.carModelQueryRespDtoList;
                                }
                                var vehicle = $rootScope.dataList.vehicle;
                                if($rootScope.dataList.vehicle && $rootScope.dataList.vehicle.licenseNo=='*-*'){
                                    // 新车次年续保车牌号更新
                                    $rootScope.dataList.vehicle.licenseNo = $rootScope.carBeans.vehicle.licenseNo;
                                }

                                angular.extend($rootScope.carBeans.vehicle, $rootScope.dataList.vehicle);

                                $rootScope.baseBean.is_twoNumber_success = true;
                                //wll
                                var vehicleTypeFlag = $rootScope.carBeans.vehicle.jqxClassId;
                                if(vehicleTypeFlag){
                                    var carshow = $rootScope.BASE_BEAN.CLASSIDTOCARKINDSHOW[vehicleTypeFlag];
                                    if($rootScope.BASE_BEAN.CLASSIDTOCARKINDSHOW[vehicleTypeFlag]>20){//货车
                                        $rootScope.carBeans.vehicle.carKindCode='200';
                                    }else if($rootScope.BASE_BEAN.CLASSIDTOCARKINDSHOW[vehicleTypeFlag]<20){ //客车
                                        $rootScope.carBeans.vehicle.carKindCode='100';
                                        $rootScope.baseBean.syRiskList[11].checked=false;
                                    }
                                    $rootScope.carBeans.vehicle.carKindCodeShow =carshow;
                                }else{
                                    $rootScope.carBeans.vehicle.carKindCode='';
                                    $rootScope.carBeans.vehicle.carKindCodeShow='';
                                }
                                //wll
                                // 纳税类型
                                angular.extend($rootScope.baseBean.jqRiskList.vhlTax, Handle.dutyFree(vehicle.fuelFlag));
                                $rootScope.baseBean.jqRiskList.vhlTax.fuelType = vehicle.powerTypeCode;
                                $U.showToast('请继续完善您的信息');
                            }
                        }else{
                            $U.showToast('请继续完善您的信息');
                            $rootScope.carBeans.vehicle.frameNo = '';//车架号
                            $rootScope.carBeans.vehicle.engineNo = '';//发动机号
                            $rootScope.carBeans.vehicle.singeinDate = '';//初登日期
                            $rootScope.carBeans.vehicle.modelName = '';//品牌型号
                        }
                        $rootScope.loadingStr ='正在加载';
                    },
                    error: function (ex) {
                        $handleService.logger('error', ex);
                        //加载框文案
                        $rootScope.loadingStr ='正在加载';
                    }
                });
            }

            //两号查询方法 石梦星
            $scope.queryTwoNumber = function (onlyTwoNo) {
                $rootScope.isShowTwoNoQueryBtn = false;
                if(pageCode=='RENEWAL'){
                    return;
                }
                
                //加载框文案
                $rootScope.loadingStr ='续保查询中';

                //新车和续保不查询两号
                $handleService.http({
                    url: "/renewal/queryPolicyInfoWithTwoNo?flowId=" + $rootScope.flowId + "&licenseNo="+$rootScope.carBeans.vehicle.licenseNo+"&salesCode=" + $U.getSlsCode() +"&companyCode=" + $U.getDeptCode()+"&onlyTwoNo=" + onlyTwoNo,
                    method: 'GET',
                    timeout: 20000,//20秒超时处理0813
                    success: function (data) {
                        $handleService.logger('object', data, '两号查询接口');
                        //加载框文案
                        if (data.resultCode == "0") {
                            $handleService.uMengListen("twoNumber");
                            if(data.dateSource=='1'){  //续保
                                if(data.result.policyInfos.length > 1){
                                    $rootScope.vhlList = angular.copy(data.result.policyInfos);
                                    $scope.isShowCar = true;
                                }else{
                                    $rootScope.dataList=data.result.policyInfos[0];
                                    $state.go('tab.licensePlate');
                                }
                                if($rootScope.dataList.vehicle && $rootScope.dataList.vehicle.licenseNo=='*-*'){
                                    // 新车次年续保车牌号更新
                                    $rootScope.dataList.vehicle.licenseNo = $rootScope.carBeans.vehicle.licenseNo;
                                }

                                // $rootScope.checkResult=true;
                            }else { //两号数据
                                if(data.result.carModelQueryRespDtoList.length){
                                    $rootScope.dataList.vehicle = data.result.carModelQueryRespDtoList[0];
                                }else{
                                    $rootScope.dataList.vehicle = data.result.carModelQueryRespDtoList;
                                }
                                var vehicle = $rootScope.dataList.vehicle;
                                if($rootScope.dataList.vehicle && $rootScope.dataList.vehicle.licenseNo=='*-*'){
                                    // 新车次年续保车牌号更新
                                    $rootScope.dataList.vehicle.licenseNo = $rootScope.carBeans.vehicle.licenseNo;
                                }

                                angular.extend($rootScope.carBeans.vehicle, $rootScope.dataList.vehicle);
                                $rootScope.baseBean.is_twoNumber_success = true;
                                //wll
                                var vehicleTypeFlag = $rootScope.carBeans.vehicle.jqxClassId;
                                if(vehicleTypeFlag){
                                    var carshow = $rootScope.BASE_BEAN.CLASSIDTOCARKINDSHOW[vehicleTypeFlag];
                                    if($rootScope.BASE_BEAN.CLASSIDTOCARKINDSHOW[vehicleTypeFlag]>20){//货车
                                        $rootScope.carBeans.vehicle.carKindCode='200';
                                    }else if($rootScope.BASE_BEAN.CLASSIDTOCARKINDSHOW[vehicleTypeFlag]<20){ //客车
                                        $rootScope.carBeans.vehicle.carKindCode='100';
                                        $rootScope.baseBean.syRiskList[11].checked=false;
                                    }
                                    $rootScope.carBeans.vehicle.carKindCodeShow =carshow;
                                }else{
                                    $rootScope.carBeans.vehicle.carKindCode='';
                                    $rootScope.carBeans.vehicle.carKindCodeShow='';
                                }
                                //wll
                                // 纳税类型
                                angular.extend($rootScope.baseBean.jqRiskList.vhlTax, Handle.dutyFree(vehicle.fuelFlag));
                                $rootScope.baseBean.jqRiskList.vhlTax.fuelType = vehicle.powerTypeCode;
                                $U.showToast('请继续完善您的信息');
                            }

                            // data.dateSource =='2' ? $rootScope.baseBean.is_twoNumber_success = true :$rootScope.baseBean.is_twoNumber_success = false;//两号是否查询成功
                        }else{
                            $U.showToast('请继续完善您的信息');
                            if(!$scope.ocr){
                                $rootScope.carBeans.vehicle.frameNo = '';//车架号
                                $rootScope.carBeans.vehicle.engineNo = '';//发动机号
                                $rootScope.carBeans.vehicle.singeinDate = '';//初登日期
                                $rootScope.carBeans.vehicle.modelName = '';//品牌型号
                                $rootScope.baseBean.is_twoNumber_success = false;
                            }
                            
                        }
                        $rootScope.loadingStr ='正在加载';
                    },
                    error: function (ex) {
                        // $handleService.logger('error', ex);
                        //加载框文案
                        $rootScope.loadingStr ='正在加载';
                        $U.showToast("服务请求超时啦,未查询到两号数据哟~");//20秒超时处理0813
                    }
                });
            };
            // 如果是从确认确认页面直接点击了返回   将调用一下只查两号数据的接口
            if(pageCode == 'QUIT_RENEWAL'){ // 已查到续保数据  却不使用  再查2号数据
                var onlyTwoNo =1;
                $scope.queryTwoNumber(onlyTwoNo);
            }
            //多车型选择
            $scope.chooseModel = function (a,b){
                $rootScope.dataList=angular.copy(b);
            };
            $scope.comfirmCar = function (){
                $scope.isShowCar = false;
                $rootScope.isShowTwoNoQueryBtn = false;
                $state.go('tab.licensePlate');
            };
            $scope.cancelCar = function (){
                $scope.isShowCar = false;
            };
            $scope.relevance = function(a,b){
                $rootScope.carBeans.base.busiAttrConfig.attachNatures = '0' + b;
                $rootScope.carBeans.owner.insuredTypeCode = b;
                if(b != '1'){
                    $scope.isCarMass = true;
                    $rootScope.carBeans.owner.identifyType = '09';
                }else{
                    $scope.isCarMass = false;
                    $rootScope.carBeans.owner.identifyType = '01';
                }
                Handle.initPage();
            }



            //----------------------------------------end   车主信息页面----------------------------------------//
        });
        return app;
    });